local addon = DXE

--local MapDims
local sort = table.sort
local UnitPosition = UnitPosition
local GetPlayerMapPosition = GetPlayerMapPosition
local SetMapToCurrentZone = SetMapToCurrentZone
local GetCurrentMapDungeonLevel = GetCurrentMapDungeonLevel
local GetMapInfo = GetMapInfo

function addon:GetPlayerMapPosition(unit)
	SetMapToCurrentZone()
	local x,y = GetPlayerMapPosition(unit)
	--if x <= 0 and y <= 0 then
	--	SetMapToCurrentZone()
	--	x,y = GetPlayerMapPosition(unit)
	--end
	return x,y
end

-- Computes the distance between the player and unit in game yards
-- Intended to be used when the player and unit are in the same map
function addon:GetDistanceToUnit(unit,fx2,fy2)
	local y1,x1 = UnitPosition("player")
	local y2,x2
	
	if fx2 and fy2 then
		y2,x2 = fy2,fx2
	else
		y2,x2 = UnitPosition(unit)
	end

	local dx = (x2 - x1)
	local dy = (y2 - y1)
	--return (dX * dX + dY * dY) ^ 0.5
	return (dx*dx + dy*dy)^(0.5),dx,dy -- dx*dx is faster than dx^2
end
function addon:GetDistanceToUnitSetFixed(unit,fx2,fy2)
	local y,x = UnitPosition("player")
	local x1,y1 = self:GetPlayerMapPosition("player")
	local x2,y2

	if fx2 and fy2 then
		x2,y2 = fx2,fy2
	else
		x2,y2 = self:GetPlayerMapPosition(unit)
	end

	local dx = (x2 - x1) * x
	local dy = (y2 - y1) * y

	return (dx*dx + dy*dy)^(0.3),dx,dy
end

local function comp(a,b)
	return addon:GetDistanceToUnit(a) < addon:GetDistanceToUnit(b)
end

-- @param units an array of units
function addon:FindClosestUnit(units)
	sort(units,comp)
	return units[1]
end

----------------------- NEAR YOU CHECK --------------------------
--[[function addon:GetYouToUnit(unit,fx2,fy2)
	local x1,y1 = self:GetPlayerMapPosition("player")
	local x2,y2

	local list = MapDims[GetMapInfo()]
	if not list then return end
	local level = GetCurrentMapDungeonLevel()
	local dims = list[level]
	if not dims then
		if level == 0 and list[1] then
			SetMapToCurrentZone()
			level = GetCurrentMapDungeonLevel()
			dims = list[level]
			if not dims then return end
		else return end
	end

	if fx2 and fy2 then
		x2,y2 = fx2,fy2
	else
		x2,y2 = self:GetPlayerMapPosition(unit)
	end

	local dx = (x2 - x1) * dims.w
	local dy = (y2 - y1) * dims.h

	return math.sqrt(dx * dx + dy * dy)  -- ^(0.5) <- maybe ?
end--]]
function addon:GetYouToUnit(unit,fx2,fy2)
	local y1,x1 = UnitPosition("player")
	local y2,x2
	
	if fx2 and fy2 then
		x2,y2 = fx2,fy2
	else
		y2,x2 = UnitPosition(unit)
	end

	local dx = (x2 - x1)
	local dy = (y2 - y1)

	return math.sqrt(dx * dx + dy * dy)  -- ^(0.5) <- maybe ?

end
function addon:InRange(unit)
	--sort(units,comp)
	--local range = addon:GetYouToUnit(unit)
	local range = addon:GetDistanceToUnit(unit)
	--print("DXE COORDS InRange",range)
	return range
end

--[[function getDistanceBetween(uId, x, y)
	local startX, startY = GetPlayerMapPosition(uId)
	local mapName = GetMapInfo()
	local dims  = mapSizes[mapName] and mapSizes[mapName][GetCurrentMapDungeonLevel()]
	if not dims then
		return
	end
	local dX = (startX - x) * dims[1]
	local dY = (startY - y) * dims[2]
	return math.sqrt(dX * dX + dY * dY)
end
	function getDistanceBetween(uId, x, y)
		-- alternative arguments: uId, uId2
		if type(x) == "string" then
			local uId2 = x
			x, y = UnitPosition(uId2)
			if not x then
				print("getDistanceBetween failed for: " .. uId .. " (" .. UnitExists(uId) .. ") and " .. uId2 .. " (" .. UnitExists(uId2) .. ")")
				return
			end
		end
		local startX, startY = UnitPosition(uId)
		local dX = startX - x
		local dY = startY - y
		return (dX * dX + dY * dY) ^ 0.5
	end--]]
