local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1122)

do
	local data = {
		version = 10,
		key = "Darmac",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["Darmac"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Beastlord Darmac.BLP:35:35",
		triggers = {
			scan = {76865}, 
			encounterid = {1694},
			ejid = {1122},
		},
		onactivate = {
			tracing = {
				76865,
				markers1 = {85,65,45,25},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1","boss2"},
			defeat = 76865,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			timelfr = 720,
			timeflex = 720,
			timeheroic = 720,
			timemythic = 720,
		},
		raidicons = {
			PinnedDownmark = {
				varname = SN[154960],
				type = "MULTIFRIENDLY",
				persist = 60,
				unit = "#5#",
				icon = 1,
				total = 8,
				reset = 15,
				desc = 154960,
				icon2 = ST[154960],
			},			
		},
		arrows = {
			PinnedDownarrow = {
				varname = format(L.alert["Closest %s"],SN[154960]),
				unit = "&closest|Spearunits2&",
				persist = 60,
				action = "TOWARD",
				msg = L.alert["Free him!"],
				spell = format(L.alert["Closest %s"],SN[154960]),
				range1 = 3,
				range2 = 20,
				range3 = 30,
				desc = 154960,
				icon = ST[154960],
				extank = true,
				exhealer = true,
				exmelee = true,
			},
			InfernoBreatharrow = {
				varname = SN[154989],
				unit = "&upvalue&",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[154989],
				range1 = 10,
				range2 = 11,
				range3 = 12,
				desc = 154989,
				icon = ST[154989],
			},
		},
		announces = { 
			PinnedDownsay = {
				varname = format(L.alert["%s %s %s!"],SN[155365],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[155365],L.alert["on"],L.alert["Me"]),
				desc = 155365,
				icon = ST[155365],
				flashcolor = "ORANGE",
				flashscreen = true,
			},
			InfernoBreathsay = {
				varname = format(L.alert["%s %s %s!"],SN[154989],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[154989],L.alert["on"],L.alert["Me"]),
				desc = 154989,
				icon = ST[154989],
				flashcolor = "RED",
				flashscreen = true,
			},	
			Superheatedsay = {
				varname = format(L.alert["%s %s %s!"],SN[155499],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[155499],L.alert["on"],L.alert["Me"]),
				desc = 155499,
				icon = ST[155499],
				flashcolor = "RED",
				flashscreen = true,
			},				
		},
		timers = {
			timerPinnedDown = {
				{
					"message","mPinnedDown",
					"arrow","PinnedDownarrow",
				},
			},
			timerConflagration = {
				{
					"message","mConflagration",
				},
			},
			timeLife = {
				{
					"expect",{"&gethp|boss1&","<","70"},
					"expect",{"<Bosswarned>","==","0"},
					"set",{Bosswarned = "1"},
					"alert","iNextPhaseBoss1",
				},
				{
					"expect",{"&gethp|boss1&","<","37"},
					"set",{Bosswarned = "2"},
					"alert","iNextPhaseBoss1",
				},				
				{
					"expect",{"<Bosswarned>","~=","2"},
					"scheduletimer",{"timeLife",1},
				},	
			},
		},
		userdata = {
			phase = 1,
			tantrumCount = 1,
			activated = "",
			activatedMounts = {type = "container"},
			currentBosses = {type = "container", wipein = 3},
			Spearunits = {type = "container", wipein = 3},
			Spearunits2 = {type = "container", wipein = 3},
			Conflagrationunits = {type = "container", wipein = 3},
			spearList = "",
			marksUsed = 0,
			markTimer = 0,
			warned = 0,
			Bosswarned = 0,
		},		
		messages = {
			mConflagration = {
				varname = format(L.alert["%s %s %s"],SN[154981],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Conflagrationunits&"],SN[154981],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 154981,
				icon = ST[154981],
			},		
			mPinnedDown = {
				varname = format(L.alert["%s %s %s"],SN[154960],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Spearunits&"],SN[154960],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 154960,
				icon = ST[154960],
			},		
			mTantrum = {
				varname = format(L.alert["%s (1)"],SN[162275]),
				type = "message",
				text = format(L.alert["%s (<tantrumCount>)"],SN[162275]),
				color1 = "BROWN",
				sound = "ALERT13",
				desc = 162275,
				icon = ST[162275],
			},
			mCallThePack = {
				varname = format(L.alert["%s!"],SN[154975]),
				type = "message",
				text = format(L.alert["%s!"],SN[154975]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 154975,
				icon = ST[154975],
			},
			mStampede = {
				varname = format(L.alert["%s!"],SN[155247]),
				type = "message",
				text = format(L.alert["%s!"],SN[155247]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 155247,
				icon = ST[155247],
			},			
			mRendAndTear = {
				varname = format(L.alert["%s %s %s (3)"],SN[155061],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (#11#)"],SN[155061],L.alert["on"]),
				color1 = "ORANGE",
				icon = ST[155061],
				desc = 155061,
				sound = "ALERT13",
				exdps = true,
			},
			mSearedFlesh = {
				varname = format(L.alert["%s %s %s (3)"],SN[155030],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (#11#)"],SN[155030],L.alert["on"]),
				color1 = "ORANGE",
				icon = ST[155030],
				desc = 155030,
				sound = "ALERT13",
				exdps = true,
			},	
			mCrushArmor = {
				varname = format(L.alert["%s %s %s (3)"],SN[155236],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (1)"],SN[155236],L.alert["on"]),
				text2 = format(L.alert["%s %s #5# (#11#)"],SN[155236],L.alert["on"]),
				color1 = "ORANGE",
				icon = ST[155236],
				desc = 155236,
				sound = "ALERT13",
				exdps = true,
			},
			mUnstoppable = {
				varname = format(L.alert["%s %s %s (2)"],SN[155321],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (1)"],SN[155321],L.alert["on"]),
				text2 = format(L.alert["%s %s #5# (#11#)"],SN[155321],L.alert["on"]),
				color1 = "BROWN",
				icon = ST[155321],
				desc = 155321,
				sound = "ALERT13",
			},			
			mMount = {
				varname = format(L.alert["%s!"],L.alert["Boss"]),
				type = "message",
				text = format(L.alert["&bossname|boss2&"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				icon = ST[155247],
			},
			mMountDismount = {
				varname = format(L.alert["%s!"],SN[45874]),
				type = "message",
				text = format(L.alert["%s!"],SN[45874]),
				color1 = "YELLOW",
				sound = "ALERT13",
				--desc = 45874,
				icon = ST[45874],
			},
			mSavageHowl = {
				varname = format(L.alert["%s!"],SN[155198]),
				type = "message",
				text = format(L.alert["%s!"],SN[155198]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 155198,
				icon = ST[155198],
			},
			mInfernoBreath = {
				varname = format(L.alert["%s %s %s"],SN[154989],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[154989],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 154989,
				icon = ST[154989],
			},
			mSuperheated = {
				varname = format(L.alert["%s %s %s"],SN[155499],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[155499],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 155499,
				icon = ST[155499],
			},			
		},
		onstart = {
			{
				--"batchalert",{"CallthePackCD","PinDownCD"},
				"alert","PinDownCD",
				--"scheduletimer",{"timeLife",10},
				--"scheduletimer",{"timerMounts",1},
			},
			{
				"expect",{"&flex&","==","true"},
				"alert",{"CallthePackCD", time = 4},
			},		
			{
				"expect",{"&flex&","==","false"},
				"invoke",{
					{
						"expect",{"&lfr&","==","true"},
						"alert",{"CallthePackCD", time = 4},
					},
					{
						"expect",{"&lfr&","==","false"}, -- heroic and mythic
						"alert","CallthePackCD",
					},
				},
			},
			{
				"expect",{"&lfr&","==","false"},
				"invoke",{
					{
						"expect",{"&isranged&","==","true"},
						"openwindow",{"8"},
					},
					{
						"expect",{"&ishealer&","==","true"},
						"openwindow",{"8"},
					},
				},
			},
		},
		alerts = {
			CallthePackCD = {
				varname = format(L.alert["%s Cooldown"],SN[154975]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[154975]),
				time = 8,
				time2 = 30,
				time3 = 40,
				time4 = 18,
				color1 = "MIDBLUE",
				icon = ST[154975],
				desc = 154975,	
			},
			PinDownCD = {
				varname = format(L.alert["%s Cooldown"],SN[154960]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[154960]),
				time = 11,
				time2 = 20,
				color1 = "MIDBLUE",
				icon = ST[154960],
				desc = 154960,	
			},
			TantrumCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],SN[162275]),
				type = "dropdown",
				text = "(<tantrumCount>) "..format(L.alert["%s Cooldown"],SN[162275]),
				time = 26,
				time2 = 23,
				time3 = 25,
				color1 = "MIDBLUE",
				icon = ST[162275],
				desc = 162275,	
				--counter = true,
			},
			SuperheatedShrapnelCD = {
				varname = format(L.alert["%s Cooldown"],SN[155499]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155499]),
				time = 25,
				time2 = 12,
				color1 = "MIDBLUE",
				icon = ST[155499],
				desc = 155499,	
			},
			RendandTearCD = {
				varname = format(L.alert["%s Cooldown"],SN[155061]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155061]),
				time = 20,
				time2 = 13,
				color1 = "MIDBLUE",
				icon = ST[155061],
				desc = 155061,
				throttle = 7,
				exhealer = true,
				exdps = true,
			},
			SavageHowlCD = {
				varname = format(L.alert["%s Cooldown"],SN[155198]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155198]),
				time = 26,
				time2 = 17,
				color1 = "MIDBLUE",
				icon = ST[155198],
				desc = 155198,	
			},
			ConflagCD = {
				varname = format(L.alert["%s Cooldown"],SN[154981]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[154981]),
				time = 20,
				time2 = 12,
				color1 = "MIDBLUE",
				icon = ST[154981],
				desc = 154981,	
				exdps = true,
				extank = true,
			},
			StampedeCD = {
				varname = format(L.alert["%s Cooldown"],SN[155247]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155247]),
				time = 20,
				time2 = 15,
				color1 = "MIDBLUE",
				icon = ST[155247],
				desc = 155247,	
			},	
			EpicCenterCD = {
				varname = format(L.alert["%s Cooldown"],SN[159043]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[159043]),
				time = 19,
				time2 = 7,
				color1 = "MIDBLUE",
				icon = ST[159043],
				desc = 159043,	
			},
			UnstoppableCD = {
				varname = format(L.alert["%s Cooldown"],SN[155321]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155321]),
				time = 21,
				time2 = 11,
				color1 = "MIDBLUE",
				icon = ST[155321],
				desc = 155321,	
			},	
			InfernoBreathCD = {
				varname = format(L.alert["Next %s"],SN[154989]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[154989]),
				time = 20,
				time2 = 5,
				color1 = "MIDBLUE",
				icon = ST[154989],
				desc = 154989,	
			},						
			-- Warning
			wInfernoBreath = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[154989]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[154989]),
				time = 2,
				color1 = "RED",
				icon = ST[154989],
				sound = "ALERT11",
				desc = 154989,
				flashscreen = true,
			},			
			wPinDown = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155365]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155365]),
				time = 2,
				color1 = "RED",
				icon = ST[155365],
				sound = "ALERT11",
				desc = 155365,
				extank = true,
				exmelee = true,
			},		
			wSuperheated = {
				varname = format(L.alert["%s!"],SN[155499]),
				type = "simple",
				text = format(L.alert["%s!"],SN[155499]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[155499],
				sound = "ALERT10",
				desc = 155499,
			},	
			wEpicenter = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[159043]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[159043]),
				time = 2,
				color1 = "RED",
				icon = ST[159043],
				sound = "ALERT14",
				desc = 159043,
			},	
			-- Inform
			iRendAndTear = {
				varname = format(L.alert["%s: %s 3 %s!"],SN[155061],L.alert["already at"],L.alert["Stacks"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s!"],SN[155061],L.alert["already at"],L.alert["Stacks"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[155061],
				desc = 155061,
				flashscreen = true,
				exhealer = true,
				exdps = true,
			},
			iRendAndTearOther = {
				varname = format(L.alert["%s: %s 3 %s %s %s!"],SN[155061],L.alert["already at"],L.alert["Stacks"],L.alert["on"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s %s #5#!"],SN[155061],L.alert["already at"],L.alert["Stacks"],L.alert["on"]),
				time = 2,
				color1 = "ORANGE",
				sound = "ALERT10",
				icon = ST[155061],
				desc = 155061,
				--flashscreen = true,
				exhealer = true,
				exdps = true,
			},
			iSearedFlesh = {
				varname = format(L.alert["%s: %s 3 %s!"],SN[155030],L.alert["already at"],L.alert["Stacks"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s!"],SN[155030],L.alert["already at"],L.alert["Stacks"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[155030],
				desc = 155030,
				flashscreen = true,
				exhealer = true,
				exdps = true,
			},
			iSearedFleshOther = {
				varname = format(L.alert["%s: %s 3 %s %s %s!"],SN[155030],L.alert["already at"],L.alert["Stacks"],L.alert["on"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s %s #5#!"],SN[155030],L.alert["already at"],L.alert["Stacks"],L.alert["on"]),
				time = 2,
				color1 = "ORANGE",
				sound = "ALERT10",
				icon = ST[155030],
				desc = 155030,
				--flashscreen = true,
				exhealer = true,
				exdps = true,
			},	
			iCrushArmor = {
				varname = format(L.alert["%s: %s 3 %s!"],SN[155236],L.alert["already at"],L.alert["Stacks"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s!"],SN[155236],L.alert["already at"],L.alert["Stacks"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[155236],
				desc = 155236,
				flashscreen = true,
				exhealer = true,
				exdps = true,
			},	
			iCrushArmorOther = {
				varname = format(L.alert["%s: %s 3 %s %s %s!"],SN[155236],L.alert["already at"],L.alert["Stacks"],L.alert["on"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s %s #5#!"],SN[155236],L.alert["already at"],L.alert["Stacks"],L.alert["on"]),
				time = 2,
				color1 = "ORANGE",
				sound = "ALERT10",
				icon = ST[155236],
				desc = 155236,
				--flashscreen = true,
				exhealer = true,
				exdps = true,
			},			
			iSavageHowl = {
				varname = format(L.alert["%s %s!"],L.alert["Dispell"],SN[155198]),
				type = "inform",
				text = format(L.alert["%s %s!"],L.alert["Dispell"],SN[155198]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[155198],
				desc = 155198,
				flashscreen = true,
			},	
			iInfernoBreathDamage = {
				varname = format(L.alert["%s %s %s, %s!"],SN[154989],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s %s, %s!"],SN[154989],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[154989],
				sound = "ALERT12",
				desc = 154989,
				flashscreen = true,
				throttle = 3,
			},
			iEpicenterDamage = {
				varname = format(L.alert["%s %s, %s!"],SN[159043],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[159043],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[159043],
				sound = "ALERT12",
				desc = 159043,
				flashscreen = true,
				throttle = 2,
			},
			iShrapnelDamage = {
				varname = format(L.alert["%s %s, %s!"],SN[155499],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[155499],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[155499],
				sound = "ALERT12",
				desc = 155499,
				flashscreen = true,
				throttle = 3,
			},	
			iFlameInfusionDamage = {
				varname = format(L.alert["%s %s, %s!"],SN[155657],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[155657],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[155657],
				sound = "ALERT12",
				desc = 155657,
				flashscreen = true,
				throttle = 2,
			},	
			iSuperheatedScrap = {
				varname = format(L.alert["%s %s, %s!"],SN[156823],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[156823],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[156823],
				sound = "ALERT12",
				desc = 156823,
				flashscreen = true,
				throttle = 2,
			},
			iInfernoPyre = {
				varname = format(L.alert["%s %s, %s!"],SN[156824],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[156824],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[156824],
				sound = "ALERT12",
				desc = 156824,
				flashscreen = true,
				throttle = 2,
			},				
			iConflagrationDispell = {
				varname = format(L.alert["%s: %s %s! (2)"],SN[154981],L.alert["Dispell"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s: %s #5#! (#11#)"],SN[154981],L.alert["Dispell"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[154981],
				sound = "ALERT13",
				desc = 154981,
				--throttle = 2,
			},
			-- Casts
			TantrumActive = {
				varname = format(L.alert["%s Active"],SN[155222]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[155222]),
				time = 5,
				color1 = "RED",
				icon = ST[155222],
				desc = 155222,
				biggerbar = true,
				exdps = true,
				extank = true,
			},
			-- Debuff
			RendAndTearDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155061]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[155061]),
				text2 = format(L.alert["#5# (1): %s"],SN[155061]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[155061]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[155061]),
				time = 30,
				color1 = "PURPLE",
				desc = 155061,
				icon = ST[155061],
				tag = "#5#",
				exdps = true,				
			},
			SearedFleshDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155030]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[155030]),
				text2 = format(L.alert["#5# (1): %s"],SN[155030]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[155030]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[155030]),
				time = 15,
				color1 = "ORANGE",
				desc = 155030,
				icon = ST[155030],
				tag = "#5#",
				exdps = true,				
			},
			CrushArmorDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155236]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[155236]),
				text2 = format(L.alert["#5# (1): %s"],SN[155236]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[155236]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[155236]),
				time = 15,
				color1 = "RED",
				desc = 155236,
				icon = ST[155236],
				tag = "#5#",
				exdps = true,				
			},
			UnstoppableDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155321]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[155321]),
				text2 = format(L.alert["#5# (1): %s"],SN[155321]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[155321]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[155321]),
				time = 15,
				color1 = "BROWN",
				desc = 155321,
				icon = ST[155321],
				tag = "#5#",
				exdps = true,				
			},				
		},
		events = {
			-- Unstoppable
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155321},
				execute = {
					{
						"message","mUnstoppable",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","UnstoppableDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"UnstoppableDebuff", text = 2},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155321},
				execute = {
					{
						"message",{"mUnstoppable", text = 2},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"UnstoppableDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"UnstoppableDebuff", text = 4},
					},					
				},
			},			
			-- PinnedDown
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {155365},
				execute = {
					{
						"alert","wPinDown",
						"alert",{"PinDownCD", time = 2},
					},		
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {154960},
				execute = {
					{
						"insert",{"Spearunits","#5#"},
						"insert",{"Spearunits2","#5#",true},
						"canceltimer","timerPinnedDown",
						"scheduletimer",{"timerPinnedDown",0.5},	
						"raidicon","PinnedDownmark",
					},		
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","PinnedDownsay",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {154960},
				execute = {
					{
						"removeraidicon","#5#",
						"removearrow","#5#",
					},		
				},
			},			
			-- SpearSummon
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellid = {154956},
				execute = {	
					{
						"alert",{"PinDownCD", time = 2},
					},
				},
			},
			-- CallThePack
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {154975},
				execute = {	
					{
						"message","mCallThePack",
					},
					{
						"expect",{"&flex&","==","true"},
						"alert",{"CallthePackCD", time = 3},
					},		
					{
						"expect",{"&flex&","==","false"},
						"invoke",{
							{
								"expect",{"&lfr&","==","true"},
								"alert",{"CallthePackCD", time = 3},
							},
							{
								"expect",{"&lfr&","==","false"}, -- heroic and mythic
								"alert",{"CallthePackCD", time = 2},
							},
						},
					},					
				},
			},
			-- RendAndTear
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155061,162283},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","RendAndTearDebuff",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"RendAndTearDebuff", text = 2},
							},
						},
					},	
					{
						"alert","RendandTearCD",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {155061,162283},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert",{"RendAndTearDebuff", text = 3},
								"invoke",{
									{
										"expect",{"#11#",">","2"},
										"alert","iRendAndTear",
									},
								},
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"RendAndTearDebuff", text = 4},
								"invoke",{
									{
										"expect",{"#11#",">","2"},
										"alert","iRendAndTearOther",
									},
								},
							},
							{
								"expect",{"#11#",">","2"},
								"message","mRendAndTear",
							},
						},
					},	
					{
						"alert","RendandTearCD",
					},
				},
			},
			-- SavageHowl
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {155198},
				execute = {	
					{
						"alert","SavageHowlCD",
						"message","mSavageHowl",
					},
					{
						"expect",{"&removeenrage&","==","true"},
						"alert","iSavageHowl",
					},				
				},
			},
			-- InfernoBreath
			--[[{
				type = "event",
				event = "EMOTE", 
				execute = {
					{
						"expect",{"#1#","find","spell:154989"},
						"alert","wInfernoBreath",
						"alert","InfernoBreathCD",
					},				
				},
			},--]]
			{
				type = "combatevent",
				eventtype = "SPELL_DAMAGE",
				spellid = {154989},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iInfernoBreathDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_MISSED",
				spellid = {154989},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iInfernoBreathDamage",
					},
				},
			},
			-- Conflagration
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155399},
				execute = {
					{
						"alert","ConflagCD",
					},
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {154981},
				execute = {
					{
						"insert",{"Conflagrationunits","#5#"},
						"canceltimer","timerConflagration",
						"scheduletimer",{"timerConflagration",0.5},	
						--"alert","ConflagCD",
						--"raidicon","PinnedDownmark",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {154981},
				throttle = 2,
				execute = {
					{
						"expect",{"&ismagicdispeller&","==","true"},
						"alert","iConflagrationDispell",
					},
				},
			},			
			-- SearedFlesh
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155030},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","SearedFleshDebuff",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"SearedFleshDebuff", text = 2},
							},
						},
					},	
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {155030},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert",{"SearedFleshDebuff", text = 3},
								"invoke",{
									{
										--"expect",{"#11#",">","8"},
										"expect",{"&checkperc|#11#|3&","==","0"},
										"alert","iSearedFlesh",
									},
								},
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"SearedFleshDebuff", text = 4},
								"invoke",{
									{
										"expect",{"#11#",">","12"},
										"alert","iSearedFleshOther",
									},
								},	
							},
							{
								"expect",{"#11#",">","8"},
								"expect",{"&checkperc|#11#|3&","==","0"},
								"message","mSearedFlesh",
							},
						},
					},
				},
			},
			-- Stampede
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {155247},
				execute = {
					{
						"message","mStampede",
						"alert","StampedeCD",
					},		
				},
			},
			-- CrushArmor
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155236},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","CrushArmorDebuff",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"CrushArmorDebuff", text = 2},
							},
							{
								"message","mCrushArmor",
							},
						},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {155236},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert",{"CrushArmorDebuff", text = 3},
								"invoke",{
									{
										--"expect",{"&checkperc|#11#|3&","==","0"},
										"expect",{"#11#",">","3"},
										"alert","iCrushArmor",
									},
								},
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"CrushArmorDebuff", text = 4},
								"invoke",{
									{
										"expect",{"#11#",">","1"},
										"alert","iCrushArmorOther",
									},
								},								
							},
							{
								"message",{"mCrushArmor", text = 2},
							},
						},
					},
				},
			},
			-- Epicenter
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {159043, 159045},
				execute = {
					{
						"alert","wEpicenter",
						"alert","EpicCenterCD",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {159044, 162277},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iEpicenterDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {159044, 162277},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iEpicenterDamage",
					},
				},
			},
			-- ShrapnelDamage
			{
				type = "combatevent",
				eventtype = "SPELL_DAMAGE",
				spellid = {155499},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iShrapnelDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_MISSED",
				spellid = {155499},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iShrapnelDamage",
					},
				},
			},
			-- FlameInfusionDamage
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {155657},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFlameInfusionDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {155657},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFlameInfusionDamage",
					},
				},
			},
			-- Superheated Scrap
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {156823},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iSuperheatedScrap",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {156823},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iSuperheatedScrap",
					},
				},
			},
			-- Inferno Pyre
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {156824},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iInfernoPyre",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {156824},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iInfernoPyre",
					},
				},
			},			
			-----
			{
				type = "event",
				event = "UNIT_TARGETABLE_CHANGED",
				execute = {
					{
						"expect",{"&unitexist|boss1&","==","0"},
						"batchquash",{"RendandTearCD","SuperheatedShrapnelCD","TantrumCD"},
						"message","mMount",
						"invoke",{
							{
								"expect",{"&bossid|boss2&","==","76884"}, --Cruelfang
								"alert",{"RendandTearCD", time = 2},
								"alert",{"SavageHowlCD", time = 2},
								"tracing",{76865,76884},
								"invoke",{
									{
										"expect",{"&ishealer&","==","true"},
										"openwindow",{"8"},
									},
									{
										"expect",{"&isranged&","==","true"},
										"openwindow",{"8"},
									},
								},
							},					
							{
								"expect",{"&bossid|boss2&","==","76874"}, --Dreadwing
								"alert",{"InfernoBreathCD", time = 2},
								"alert",{"ConflagCD", time = 2},
								"tracing",{76865,76874},
							},	
							{
								"expect",{"&bossid|boss2&","==","76945"}, --Ironcrusher
								"set",{tantrumCount = 1},
								"alert",{"StampedeCD", time = 2},
								"tracing",{76865,76945},
							},		
							{
								"expect",{"&bossid|boss2&","==","76946"}, --Faultline (Mythic)
								"alert",{"EpicCenterCD", time = 2},
								"alert",{"UnstoppableCD", time = 2},
								"tracing",{76865,76946},
							},
						},
					},
					{
						"expect",{"&unitexist|boss1&","==","1"},
						"message","mMountDismount",
						"tracing",{76865},
					},
				},
			},	
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","155221"}, -- Iron Crusher's Tantrum
								"message","mTantrum",
								"set",{tantrumCount = "INCR|1"},
								"alert",{"TantrumCD", time = 2},
								"alert","TantrumActive",
							},	
							{
								"expect",{"#5#","==","155520"}, -- Iron Crusher's Tantrum
								"message","mTantrum",
								"set",{tantrumCount = "INCR|1"},
								"alert",{"TantrumCD", time = 2},
								"alert","TantrumActive",
							},	
							{
								"expect",{"#5#","==","155423"}, -- Inferno Breath
								--"message","mInfernoBreath",
								"alert","InfernoBreathCD",
								"target",{
									--source = "#1#",
									npcid = 76874,
									wait = 0.05,
									schedule = 80,
									arrow = "InfernoBreatharrow",
									announce = "InfernoBreathsay",
									message = "mInfernoBreath",
								},	
							},								
							{
								"expect",{"#5#","==","155603"}, -- Superheated Shrapnel
								"alert","wSuperheated",
								"alert","SuperheatedShrapnelCD",
								"target",{
									--source = "#1#",
									npcid = 76874,
									wait = 0.05,
									schedule = 80,
									arrow = "InfernoBreatharrow",
									announce = "Superheatedsay",
									message = "mSuperheated",
								},	
							},						
						},
					},	
					{
						"expect",{"#1#","==","boss2"},
						"invoke",{
							{
								"expect",{"#5#","==","155221"}, -- Iron Crusher's Tantrum
								"message","mTantrum",
								"set",{tantrumCount = "INCR|1"},
								"alert",{"TantrumCD", time = 2},
								"alert","TantrumActive",
							},	
							{
								"expect",{"#5#","==","155520"}, -- Iron Crusher's Tantrum
								"message","mTantrum",
								"set",{tantrumCount = "INCR|1"},
								"alert",{"TantrumCD", time = 2},
								"alert","TantrumActive",
							},	
							{
								"expect",{"#5#","==","155423"}, -- Inferno Breath
								--"message","mInfernoBreath",
								"alert","InfernoBreathCD",
								"target",{
									--source = "#1#",
									npcid = 76874,
									wait = 0.05,
									schedule = 80,
									arrow = "InfernoBreatharrow",
									announce = "InfernoBreathsay",
									message = "mInfernoBreath",
								},	
							},	
							{
								"expect",{"#5#","==","155603"}, -- Superheated Shrapnel
								"alert","wSuperheated",
								"alert","SuperheatedShrapnelCD",
								"target",{
									--source = "#1#",
									npcid = 76874,
									wait = 0.05,
									schedule = 80,
									arrow = "InfernoBreatharrow",
									announce = "Superheatedsay",
									message = "mSuperheated",
								},									
							},					
						},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","76884"}, --Cruelfang
						--"tabupdate",{"activatedMounts","76884","false"},
						"quash","SavageHowlCD",
						"alert","RendandTearCD",
						"closewindow",
					},					
					{
						"expect",{"&npcid|#4#&","==","76874"}, --Dreadwing
						--"tabupdate",{"activatedMounts","76874","false"},
						"quash","ConflagCD",
						"quash","InfernoBreathCD",
						"alert",{"SuperheatedShrapnelCD", time = 2},
						"closewindow",
					},	
					{
						"expect",{"&npcid|#4#&","==","76945"}, --Ironcrusher
						--"tabupdate",{"activatedMounts","76945","false"},
						"quash","StampedeCD",
						"alert",{"TantrumCD", time = 2},
						"closewindow",
					},		
					{
						"expect",{"&npcid|#4#&","==","76946"}, --Faultline (Mythic)
						--"tabupdate",{"activatedMounts","76946","false"},
						"quash","EpicCenterCD",
						"alert","UnstoppableCD",
						"closewindow",
					},
					--[[{
						"expect",{"&targetdebuff|boss1|"..SN[155458].."&","==","true"},
						"invoke",{
							{
								"expect",{"&ishealer&","==","true"},
								"openwindow",{"8"},
							},
							{
								"expect",{"&isranged&","==","true"},
								"openwindow",{"8"},
							},
						},
					},--]]
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end