local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1155)
do
	local data = {
		version = 7,
		key = "HansgarandFranzok",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["Hansgar and Franzok"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Franzok.BLP:35:35",
		triggers = {
			scan = {76973, 76974}, 
			encounterid = {1693},
			ejid = {1155},
		},
		onactivate = {
			tracing = {
				76973, 76974,
				powers={true,true},
				--markers1 = {35},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1","boss2"},
			defeat = {76973, 76974}
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 600,
			--timeflex = 600,
			--timeheroic = 600,
			--timemythic = 360,
		},
		userdata = {
			phase = 1,
			bossUp = 0,
			stamperDodgeCount = 0,
			dtime = 0,
			source = "",
			crippling = "",
			stamperWarned = 0,
			firstJump = 0,
		},	
		arrows = {
			BodySlamarrow = {
				varname = SN[155747],
				unit = "&upvalue&",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[155747],
				range1 = 10,
				range2 = 12,
				range3 = 15,
				desc = 155747,
				icon = ST[155747],
				exmythic = true,
			},
		},
		announces = { 
			BodySlamsay = {
				varname = format(L.alert["%s %s %s!"],SN[155747],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[155747],L.alert["on"],L.alert["Me"]),
				desc = 155747,
				icon = ST[155747],
				flashcolor = "RED",
				flashscreen = true,
			},				
		},			
		messages = {
			mBodySlam = {
				varname = format(L.alert["%s %s %s"],SN[155747],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[155747],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 155747,
				icon = ST[155747],
			},	
			mSkullcracker = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[153470]),
				type = "message",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[153470]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 153470,
				icon = ST[153470],
			},
			mSmartStampers = {
				varname = format(L.alert["%s!"],SN[162124]),
				type = "message",
				text = format(L.alert["%s!"],SN[162124]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 162124,
				icon = ST[162124],
			},	
			mShatteredVertebrae = {
				varname = format(L.alert["%s %s %s (2)"],SN[157139],L.alert["on"],L.alert["player"]),
				type = "message",
			--	text = format(L.alert["%s %s #5# (1)"],SN[157139],L.alert["on"]),
				text = format(L.alert["%s %s #5# (#11#)"],SN[157139],L.alert["on"]),
				color1 = "RED",
				icon = ST[157139],
				desc = 157139,
				sound = "ALERT13",
				exdps = true,
			},
			mCripplingSupplex = {
				varname = format(L.alert["%s %s %s"],SN[156938],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s <crippling>"],SN[156938],L.alert["on"]),
				color1 = "RED",
				icon = ST[156938],
				desc = 156938,
				sound = "ALERT13",
				exdps = true,
			},	
			mSearingPlates = {
				varname = format(L.alert["%s!"],SN[161570]),
				type = "message",
				text = format(L.alert["%s!"],SN[161570]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 161570,
				icon = ST[161570],
			},	
			mStampingPresses = {
				varname = format(L.alert["%s!"],SN[158139]),
				type = "message",
				text = format(L.alert["%s!"],SN[158139]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 158139,
				icon = ST[158139],
			},			
		},
		onstart = {
			{
				"alert","DisruptingRoarCD",
				"alert",{"SkullcrackerCD", time = 2},
			},			
			{
				"expect",{"&mythic&","==","true"},
				"alert","SmartStampersCD",
			},
		},
		alerts = {
			SkullcrackerCD = {
				varname = format(L.alert["%s Cooldown"],SN[153470]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[153470]),
				time = 22,
				time2 = 20,
				color1 = "MIDBLUE",
				icon = ST[153470],
				desc = 153470,	
			},
			DisruptingRoarCD = {
				varname = format(L.alert["%s Cooldown"],SN[160838]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[160838]),
				time = 45,
				time2 = "<dtime>",
				color1 = "MIDBLUE",
				icon = ST[160838],
				desc = 160838,	
			},
			SmartStampersCD = {
				varname = format(L.alert["Next %s"],SN[162124]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[162124]),
				time = 13,
				time2 = 12,
				color1 = "MIDBLUE",
				icon = ST[162124],
				desc = 162124,	
				--extank = true,
				--exdps = true,
			},
			SmartStampers = {
				varname = format(L.alert["Next %s"],SN[160582]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[160582]),
				time = 10,
				color1 = "MIDBLUE",
				icon = ST[160582],
				desc = 160582,	
				counter = true,
				--extank = true,
				--exdps = true,
			},			
			-- Warning
			wCripplingSuplex = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[156938]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[156938]),
				time = 2,
				color1 = "RED",
				icon = ST[156938],
				sound = "ALERT10",
				desc = 156938,
				exdps = true,
			},	
			-- Inform
			--[[iCripplingSupplex = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[156938]),
				type = "inform",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[156938]),
				time = 2,
				color1 = "RED",
				icon = ST[156938],
				sound = "ALERT11",
				desc = 156938,
				exdps = true,
			},--]]
			iDisruptingRoar = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[160838]),
				type = "inform",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[160838]),
				time = 2,
				color1 = "RED",
				icon = ST[160838],
				sound = "ALERT11",
				desc = 160838,
			},			
			iScorchingBurns = {
				varname = format(L.alert["%s %s, %s!"],SN[155818],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[155818],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[155818],
				sound = "ALERT12",
				desc = 155818,
				flashscreen = true,
				throttle = 2,
			},				
			-- Casts
			CripplingSupplex = {
				varname = format(L.alert["%s Active"],SN[156938]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[156938]),
				time = 3,
				color1 = "RED",
				icon = ST[156938],
				desc = 156938,
				exdps = true,
			},
			--[[ShatteredVertebraeCast = {
				varname = format(L.alert["%s Active"],SN[157139]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[157139]),
				time = 8,
				color1 = "RED",
				icon = ST[157139],
				desc = 157139,
			},	--]]			
			DisruptingRoarCast = {
				varname = format(L.alert["%s Casting"],SN[160838]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[160838]),
				time = "<dtime>",
				color1 = "ORANGE",
				icon = ST[160838],
				desc = 160838,
			},
			-- Debuff
			ShatteredVertebraeDebuff = {
				varname = format(L.alert["%s Debuff"],SN[157139]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[157139]),
				text2 = format(L.alert["#5# (1): %s"],SN[157139]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[157139]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[157139]),
				time = 8,
				color1 = "PURPLE",
				desc = 157139,
				icon = ST[157139],
				tag = "#5#",
				exdps = true,				
			},
		},
		events = {
			-- DisruptingRoar
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {160838, 160845, 160847, 160848},
				execute = {
					{
						"alert","DisruptingRoarCD",
						"set",{source = "&targetid|#1#&"},
						"set",{dtime = "&unitcasting|<source>&"},
						--"debug",{"DisruptingRoar","<source>","<dtime>"},
						--"debug",{"#1#","#2#","#3#","#4#"},
					},
					{
						"expect",{"<dtime>",">","0"},
						"alert","DisruptingRoarCast",
					},
					{
						"expect",{"&isranged&","==","true"},
						"alert","iDisruptingRoar",
					},
				},
			},	
			-- CripplingSuplex
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156938},
				execute = {
					{
						"alert","wCripplingSuplex",
						"alert","CripplingSupplex",
					},
				},
			},
			-- ShatteredVertebrae
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {157139},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","ShatteredVertebraeDebuff",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"ShatteredVertebraeDebuff", text = 2},
							},
							--{
							--	"message","mShatteredVertebrae",
							--},
						},
					},	
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {157139},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert",{"ShatteredVertebraeDebuff", text = 3},
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"ShatteredVertebraeDebuff", text = 4},
							},
							{
								--"message",{"mShatteredVertebrae", text = 2},
								"message","mShatteredVertebrae",
							},
						},
					},	
				},
			},
			-- Skullcracker
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {153470},
				execute = {
					{
						"message","mSkullcracker",
						"alert","SkullcrackerCD",
					},
				},
			},
			-- SmartStampers
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {162124},
				execute = {
					{
						"expect",{"<stamperWarned>","==","0"},
						"set",{stamperWarned = 1},
						"message","mSmartStampers",
					},
				},
			},				
			-- ScorchingBurns
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155818},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iScorchingBurns",
					},
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {155818},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iScorchingBurns",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {155818},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iScorchingBurns",
					},
				},
			},	
			----
			{
				type = "event",
				event = "UNIT_TARGETABLE_CHANGED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							"expect",{"&npcid|#1#&","==","76974"},
							"batchquash",{"DisruptingRoarCD","SkullcrackerCD"},
						},
					},
					{
						"expect",{"#1#","==","boss2"},
						"invoke",{
							"expect",{"&npcid|#1#&","==","76974"},
							"batchquash",{"DisruptingRoarCD","SkullcrackerCD"},
						},
					},
				},
			},
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","156220"}, -- Tactical Retreat
								--"quash","SmartStampers",
								"set",{phase = "INCR|1"},
								"invoke",{
									{
										"expect",{"&npcid|#1#&","==","76974"},
										"batchquash",{"DisruptingRoarCD","SkullcrackerCD"},
									},
									{
										"expect",{"<phase>","==","1"},
										"message","mSearingPlates",
									},
									{
										"expect",{"<phase>","==","2"},
										"message","mStampingPresses",
									},
									{
										"expect",{"<phase>","==","3"},
										"message","mSearingPlates",
									},									
								},
							},								
							{
								"expect",{"#5#","==","156883"}, -- Tactical Retreat
								--"quash","SmartStampers",
								"set",{phase = "INCR|1"},
								"invoke",{
									{
										"expect",{"&npcid|#1#&","==","76974"},
										"batchquash",{"DisruptingRoarCD","SkullcrackerCD"},
									},
									{
										"expect",{"<phase>","==","1"},
										"message","mSearingPlates",
									},
									{
										"expect",{"<phase>","==","2"},
										"message","mStampingPresses",
									},
									{
										"expect",{"<phase>","==","3"},
										"message","mSearingPlates",
									},	
								},
							},	
							{
								"expect",{"#5#","==","156546"}, -- CripplingSupplex
								--"alert","CripplingSupplex",
								--"set",{crippling = "&gettarget|#1#&"},
								"set",{crippling = "&tft_unitname|true&"},
								"message","mCripplingSupplex",
								--[["invoke",{
									{
										"expect",{"&istank&","==","true"},
										"alert",{"CripplingSupplex", time = 2},
										"alert","iCripplingSupplex",
									},
									{
										"expect",{"&ishealer&","==","true"},
										"batchalert",{"CripplingSupplex","iCripplingSupplex"},
									},
								},--]]
							},
							{
								"expect",{"#5#","==","156542"}, -- CripplingSupplex	
								--"alert","CripplingSupplex",
								--"set",{crippling = "&gettarget|#1#&"},
								"set",{crippling = "&tft_unitname&"},
								"message","mCripplingSupplex",
							},
							{
								"expect",{"#5#","==","157926"}, -- Jump Activation	
								"set",{firstJump = 0},
								--"debug",{"first activation","#5#","<firstJump>"},
							},
							{
								"expect",{"#5#","==","157922"}, -- First Jump	
								--"debug",{"first jump","#5#","<firstJump>"},
								"invoke",{
									{
										"expect",{"<firstJump>","==","0"},
										"set",{firstJump = 1},
										"target",{
											--source = "#1#",
											npcid = 76973,
											wait = 0.1,
											schedule = 80,
											arrow = "BodySlamarrow",
											announce = "BodySlamsay",
											message = "mBodySlam",
										},										
									},							
								},
							},							
							{
								"expect",{"#5# <firstJump>","==","157923 1"}, -- Body Slam	
								"target",{
									--source = "#1#",
									npcid = 76973,
									wait = 0.5,
									schedule = 40,
									arrow = "BodySlamarrow",
									announce = "BodySlamsay",
									message = "mBodySlam",
								},
							},					
						},
					},			
					{
						"expect",{"#1#","==","boss2"},
						"invoke",{
							{
								"expect",{"#5#","==","156220"}, -- Tactical Retreat
								--"quash","SmartStampers",
								"set",{phase = "INCR|1"},
								"invoke",{
									{
										"expect",{"&npcid|#1#&","==","76974"},
										"batchquash",{"DisruptingRoarCD","SkullcrackerCD"},
									},
									{
										"expect",{"<phase>","==","1"},
										"message","mSearingPlates",
									},
									{
										"expect",{"<phase>","==","2"},
										"message","mStampingPresses",
									},
									{
										"expect",{"<phase>","==","3"},
										"message","mSearingPlates",
									},									
								},
							},								
							{
								"expect",{"#5#","==","156883"}, -- Tactical Retreat
								--"quash","SmartStampers",
								"set",{phase = "INCR|1"},
								"invoke",{
									{
										"expect",{"&npcid|#1#&","==","76974"},
										"batchquash",{"DisruptingRoarCD","SkullcrackerCD"},
									},
									{
										"expect",{"<phase>","==","1"},
										"message","mSearingPlates",
									},
									{
										"expect",{"<phase>","==","2"},
										"message","mStampingPresses",
									},
									{
										"expect",{"<phase>","==","3"},
										"message","mSearingPlates",
									},										
								},
							},	
							{
								"expect",{"#5#","==","156546"}, -- CripplingSupplex
								--"alert","CripplingSupplex",
								--"set",{source = "&gettarget|#1#&"},
								"set",{crippling = "&tft2_unitname&"},
								"message","mCripplingSupplex",
								--[["invoke",{
									{
										"expect",{"&istank&","==","true"},
										"alert",{"CripplingSupplex", time = 2},
										"alert","iCripplingSupplex",
									},
									{
										"expect",{"&ishealer&","==","true"},
										"batchalert",{"CripplingSupplex","iCripplingSupplex"},
									},
								},--]]
							},
							{
								"expect",{"#5#","==","156542"}, -- CripplingSupplex	
								--"alert","CripplingSupplex",
								--"set",{source = "&gettarget|#1#&"},
								"set",{crippling = "&tft2_unitname&"},
								"message","mCripplingSupplex",
							},
							{
								"expect",{"#5#","==","157926"}, -- Jump Activation	
								"set",{firstJump = 0},
								--"debug",{"first activa","#5#","<firstJump>"},
							},
							{
								"expect",{"#5#","==","157922"}, -- First Jump	
								--"debug",{"first jump","#5#","<firstJump>"},
								"invoke",{
									{
										"expect",{"<firstJump>","==","0"},
										"set",{firstJump = 1},
										"target",{
											--source = "#1#",
											npcid = 76973,
											wait = 0.1,
											schedule = 80,
											arrow = "BodySlamarrow",
											announce = "BodySlamsay",
											message = "mBodySlam",
										},										
									},						
								},
							},	
							{
								"expect",{"#5# <firstJump>","==","157923 1"}, -- Body Slam	
								"target",{
									--source = "#1#",
									npcid = 76973,
									wait = 0.5,
									schedule = 40,
									arrow = "BodySlamarrow",
									announce = "BodySlamsay",
									message = "mBodySlam",
								},
							},							
						},	
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end