local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1202)
do
	local data = {
		version = 5,
		key = "Oregorger",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["Oregorger"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Oregorger.BLP:35:35",
		triggers = {
			scan = {77182}, 
			encounterid = {1696},
			ejid = {1202},
		},
		onactivate = {
			tracing = {
				77182,
				powers={true},
				markers1 = {21},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 77182,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 600,
			--timeflex = 600,
			--timeheroic = 600,
			--timemythic = 600,
		},
		userdata = {
			frenzyCount = 0,
			barrageCount = 0,
			power = 100,
			unitpower = 1,
			Berserk = 0,
			torrentCount = 1,
		},	
		timers = {	
			timerPower = {
				{
					"expect",{"<unitpower>","==","1"},
					"set",{power = "&getup|boss1&"},
					"invoke",{
						{
							"expect",{"<power>","<","21"},
							"invoke",{
								{
									"expect",{"<frenzyCount>",">","2"},
									"message","mBerserk",
								},
								{
									"expect",{"<frenzyCount>","<","3"},
									"message","mFeedingFrenzy",
								},		
								{
									"set",{unitpower = "0"},
								},
							},
						},
						{
							"expect",{"<power>",">","20"},
							"scheduletimer",{"timerPower",1},
						},
					},
				},
			},
		},
		arrows = {
			RetchedBlackrockarrow = {
				varname = SN[156179],
				unit = "&upvalue&",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[156179],
				range1 = 1,
				range2 = 10,
				range3 = 12,
				desc = 156179,
				icon = ST[156179],
			},
		},		
		announces = { 
			RetchedBlackrocksay = {
				varname = format(L.alert["%s %s %s!"],SN[156203],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[156203],L.alert["on"],L.alert["Me"]),
				desc = 156203,
				icon = ST[156203],
				flashcolor = "RED",
				flashscreen = true,
			},				
		},		
		messages = {
			mRetchedBlackrock = {
				varname = format(L.alert["%s %s %s"],SN[156203],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[156203],L.alert["on"]),
				text2 = format(L.alert["%s!"],SN[156203]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 156203,
				icon = ST[156203],
			},	
			mBlackrockSpines = {
				varname = format(L.alert["%s (2)"],SN[156877],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s (<barrageCount>)"],SN[156877]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 156877,
				icon = ST[156877],
				--exhealer = true,
			},
			mAcidMaw = {
				varname = format(L.alert["%s %s %s (3)"],SN[173471],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (#11#)"],SN[173471],L.alert["on"]),
				color1 = "YELLOW",
				icon = ST[173471],
				desc = 173471,
				sound = "ALERT13",
				exdps = true,
			},
			mBerserk = {
				varname = format(L.alert["%s %s"],SN[26662],L.alert["soon"]),
				type = "message",
				text = format(L.alert["%s %s"],SN[26662],L.alert["soon"]),
				color1 = "YELLOW",
				icon = ST[26662],
				desc = 26662,
				sound = "ALERT13",
			},	
			mFeedingFrenzy = {
				varname = format(L.alert["%s %s"],SN["ej9968"],L.alert["soon"]),
				type = "message",
				text = format(L.alert["%s %s"],SN["ej9968"],L.alert["soon"]),
				color1 = "TAN",
				icon = EJST[9968],
				ability	= 9968,
				sound = "ALERT13",
			},				
		},
		onstart = {
			{
				"batchalert",{"RetchedBlackrockCD","ExplosiveShardCD","AcidTorrentCD","BlackrockBarrageCD"},
				"scheduletimer",{"timerPower",1},
			},
		},
		alerts = {
			RetchedBlackrockCD = {
				varname = format(L.alert["%s Cooldown"],SN[156203]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156203]),
				time = 6,
				time2 = 20,
				color1 = "MIDBLUE",
				icon = ST[156203],
				desc = 156203,		
			},
			ExplosiveShardCD = {
				varname = format(L.alert["%s Cooldown"],SN[156390]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156390]),
				time = 9,
				time2 = 12,
				color1 = "MIDBLUE",
				icon = ST[156390],
				desc = 156390,		
			},
			AcidTorrentCD = {
				varname = format(L.alert["%s Cooldown"],SN[156240]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156240]),
				time = 12,
				color1 = "MIDBLUE",
				icon = ST[156240],
				desc = 156240,
				exdps = true,
			},
			BlackrockBarrageCD = {
				varname = format(L.alert["%s Cooldown"],SN[156877]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156877]),
				time = 14,
				time2 = 21,
				color1 = "MIDBLUE",
				icon = ST[156877],
				desc = 156877,		
			},
			RollingFuryCD = {
				varname = format(L.alert["%s Cooldown"],SN[155898]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155898]),
				time = 4,
				color1 = "MIDBLUE",
				icon = ST[155898],
				desc = 155898,		
			},					
			-- Warning
			wAcidTorrent = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[156240]),
				type = "simple",
				text = format(L.alert["%s %s (<torrentCount>)"],L.alert["Incoming"],SN[156240]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[156240],
				sound = "ALERT10",
				desc = 156240,
			},					
			wExplosiveShard = {
				varname = format(L.alert["%s!"],SN[156390]),
				type = "simple",
				text = format(L.alert["%s!"],SN[156390]),
				time = 2,
				color1 = "RED",
				icon = ST[156390],
				sound = "ALERT10",
				desc = 156390,
				flashscreen = true,
			},
			wInsane = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[26662]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[26662]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[26662],
				sound = "ALERT11",
				desc = 26662,
			},				
			-- Inform
			iRetchedBlackrock = {
				varname = format(L.alert["%s %s, %s!"],SN[156203],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[156203],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[156203],
				sound = "ALERT12",
				desc = 156203,
				flashscreen = true,
				throttle = 2,
			},		
			iRetchedBlackrockNear = {
				varname = format("%s %s %s!",SN[156203],L.alert["Near"],L.alert["YOU"]),
				type = "inform",
				text = format("%s %s %s!",SN[156203],L.alert["Near"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				flashscreen = true,
				sound = "ALERT12",
				icon = ST[156203],
			},			
			-- Debuff
			AcidMawDebuff = {
				varname = format(L.alert["%s Debuff"],SN[173471]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[173471]),
				text2 = format(L.alert["#5# (1): %s"],SN[173471]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[173471]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[173471]),
				time = 8,
				color1 = "PURPLE",
				desc = 173471,
				icon = ST[173471],
				tag = "#5#",
				exdps = true,				
			},			
		},
		events = {
			-- AcidTorrent
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156240},
				execute = {
					{
						"batchalert",{"AcidTorrentCD","wAcidTorrent"},
						"set",{torrentCount = "INCR|1"},
					},
				},
			},
			-- RetchedBlackrock
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156179},
				execute = {
					{
						"alert",{"RetchedBlackrockCD", time = 2},
					},
					{
						"target",{
							source = "#1#",
							wait = 0.2,
							schedule = 16,
							arrow = "RetchedBlackrockarrow",
							checknearby = 10,
							announce = "RetchedBlackrocksay",
							message = "mRetchedBlackrock",
							alerts = {
								unknownmsg = {"mRetchedBlackrock", text = 2},
								nearbymsg = "iRetchedBlackrockNear"
							},
						},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156203},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRetchedBlackrock",
					},		
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {156203},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRetchedBlackrock",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {156203},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRetchedBlackrock",
					},
				},
			},
			-- ExplosiveShard
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {156390},
				execute = {
					{
						"expect",{"&istank&","==","true"},
						"alert","wExplosiveShard",
						--"alert",{"ExplosiveShardCD", time = 2},
					},
					{
						"expect",{"&ismelee&","==","true"},
						"alert","wExplosiveShard",
						"alert",{"ExplosiveShardCD", time = 2},
					},					
				},	
			},
			-- BlackrockBarrage
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156877, 173459},
				execute = {
					{
						"set",{barrageCount = "INCR|1"},
						"message","mBlackrockSpines",
					},
				},
			},	
			-- BlackrockSpines 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {156834},
				execute = {
					{
						"set",{barrageCount = 0},
						"alert",{"BlackrockBarrageCD", time = 2},
					},		
				},
			},	
			-- AcidMaw
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {173471},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","AcidMawDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"AcidMawDebuff", text = 2},
					},
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {173471},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"AcidMawDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"AcidMawDebuff", text = 4},
					},
					{
						--"expect",{"&checkperc|#11#|2&","==","0"},
						"expect",{"#11#",">","2"},
						"message","mAcidMaw",
					},					
				},
			},
			-- StartBerserk (Earthshaking Stomp)
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {159958},
				execute = {
					{
						"expect",{"<Berserk>","==","0"},
						"set",{Berserk = 1},
						"alert","wInsane",
					},
				},
			},	
			-- Emotes
		--[[	{
				type = "event",
				event = "EMOTE", 
				execute = {
					-- Insane
					{
						"expect",{"#1#","find",L.chat_BlackrockFoundry["(Oregorger has gone insane from hunger!)"]},
						"alert","wInsane",
					},
				},
			},
			{
				type = "event",
				event = "UNIT_SPELLCAST_START",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","159958"}, -- Insane
								"alert","wInsane",
							},								
						},
					},
				},
			},--]]
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED", 
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","165127"}, -- Hunger Drive
								"batchquash",{"RetchedBlackrockCD","ExplosiveShardCD","AcidTorrentCD","BlackrockBarrageCD"},
							},								
						},
					},
				},
			},	
			-- HungerDrive
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {155819},
				execute = {
					{

					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {155819},
				execute = {
					{
						"quash","RollingFuryCD",
						"set",{frenzyCount = "INCR|1"},
						"set",{unitpower = "1"},
						"set",{torrentCount = "1"},
						"scheduletimer",{"timerPower",1},
						"batchalert",{"RetchedBlackrockCD","ExplosiveShardCD","AcidTorrentCD","BlackrockBarrageCD"},
					},
				},
			},		
			-- RollingFury
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155898},
				execute = {
					{
						"quash","RollingFuryCD",
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {155898},
				execute = {
					{
						"alert","RollingFuryCD",
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end