local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local Ship	= EJ_GetSectionInfo(10019)
local Marak = EJ_GetSectionInfo(10033)
local Sorka = EJ_GetSectionInfo(10030)
local Garan = EJ_GetSectionInfo(10025)
local EJName = EJ_GetEncounterInfo(1203)
		
do
	local data = {
		version = 4,
		key = "TheIronMaidens",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["The Iron Maidens"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Iron Maidens.BLP:35:35",
		triggers = {
			scan = {77477, 77557, 77231}, 
			encounterid = {1695},
			ejid = {1203},
		},
		onactivate = {
			tracing = {
				77477, 77557, 77231,
				powers={true,true,true},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1","boss2","boss3"},
			defeat = {77477, 77557, 77231}
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 600,
			--timeflex = 600,
			--timeheroic = 600,
			--timemythic = 600,
		},
		raidicons = {
			RapidFiremark = {
				varname = SN[156631],
				type = "FRIENDLY",
				persist = 60,
				unit = "#5#", 
				icon = 1,
				desc = 156631,
				icon2 = ST[156631],
			},
			PenetratingShotmark = {
				varname = SN[164271],
				type = "FRIENDLY",
				persist = 60,
				unit = "#5#", 
				icon = 2,
				desc = 164271,
				icon2 = ST[164271],
			},
			Heartseekermmark = {
				varname = SN[155326],
				type = "MULTIFRIENDLY",
				persist = 120,
				unit = "#5#",
				icon = 3,
				total = 6,
				reset = 10,
				desc = 155326,
				icon2 = ST[155326],
				enabled = false,
			},				
		},
		arrows = {
			RapidFireArrow = {
				varname = SN[156631],
				unit = "#5#",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[156631],
				range1 = 6,
				range2 = 8,
				range3 = 10,
				desc = 156631,
				icon = ST[156631],
			},
			PenetratingShotarrow = {
				varname = SN[164271].." - "..L.chat_BlackrockFoundry["GET BETWEEN THE LINE!!!"],
				unit = "#5#",
				persist = 6,
				action = "TOWARD",
				msg = SN[164271].." - "..L.chat_BlackrockFoundry["GET BETWEEN THE LINE!!!"],
				spell = SN[164271],
				range1 = 3,
				range2 = 20,
				range3 = 30,
				desc = 164271,
				icon = ST[164271],
			},
		},
		timers = {
			timerHeartseeker = {
				{
					"message","mHeartseeker",
				},
			},
			timerBoat = {
				{
					"expect",{"&unitposition|player&",">","3200"},
					"batchquash",{"BloodRitualCD","HeartSeekerCD"}, -- Sanguine Strikes?
					"batchquash",{"RapidFireCD","PenetratingShotCD","DeployTurretCD"},
					"batchquash",{"BladeDashCD","ConvulsiveShadowsCD"}, 
				},
			},			
			--[[timerPower = {
				{
					"set",{power = "&getap|boss1&"},
					"invoke",{
						{
							"expect",{"<power>","==","1"},
							"alert",{"ShipCD", time = 3},
						},					
						{
							"expect",{"<power>","==","0"},
							"quash","ShipCD",
							"invoke",{
								{
									"expect",{"<rapidfire>",">","&gettime&"},
									"set",{rapidfire = "&gettime|0|<rapidfire>&"},
									"alert",{"RapidFireCD", time = 4},
								},
								{
									"expect",{"<penetrationshot>",">","&gettime&"},
									"set",{penetrationshot = "&gettime|0|<penetrationshot>&"},
									"alert",{"PenetratingShotCD", time = 3},
								},
								{
									"expect",{"<deployturrent>",">","&gettime&"},
									"set",{deployturrent = "&gettime|0|<deployturrent>&"},
									"alert",{"DeployTurretCD", time = 2},
								},
								{
									"expect",{"<convulsiveshadow>",">","&gettime&"},
									"set",{convulsiveshadow = "&gettime|0|<convulsiveshadow>&"},
									"alert",{"ConvulsiveShadowsCD", time = 3},
								},
								{
									"expect",{"<darkhunt>",">","&gettime&"},
									"set",{darkhunt = "&gettime|0|<darkhunt>&"},
									"alert",{"DarkHuntCD", time = 3},
								},
								{
									"expect",{"<bloodritual>",">","&gettime&"},
									"set",{bloodritual = "&gettime|0|<bloodritual>&"},
									"alert",{"BloodRitualCD", time = 4},
								},
								{
									"expect",{"<heartseeker>",">","&gettime&"},
									"set",{heartseeker = "&gettime|0|<heartseeker>&"},
									"alert",{"HeartSeekerCD", time = 3},
								},
								{
									"set",{rapidfire = 0},
									"set",{penetrationshot = 0},
									"set",{deployturrent = 0},
									"set",{convulsiveshadow = 0},
									"set",{darkhunt = 0},
									"set",{bloodritual = 0},
									"set",{heartseeker = 0},
								},
							},
						},
					},
				},
				{
					"scheduletimer",{"timerPower",1},
				},
			},--]]
		},
		userdata = {
			power = 100,
			ship = 0,
			prev = 0,
			rapidfire = 30,
			penetrationshot = 30,
			deployturrent = 30,
			convulsiveshadow = 30,
			darkhunt = 30,
			bloodritual = 30,
			heartseeker = 30,
			Heartseekerunists = {type = "container", wipein = 3},
		},	
		announces = { 
			RapidFiresay = {
				varname = format(L.alert["%s %s %s!"],SN[156631],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[156631],L.alert["on"],L.alert["Me"]),
				desc = 156631,
				icon = ST[156631],
				--flashcolor = "RED",
				--flashscreen = true,
			},
			PenetratingShotsay = {
				varname = format(L.alert["%s %s %s!"],SN[164271],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[164271],L.alert["on"],L.alert["Me"]),
				desc = 164271,
				icon = ST[164271],
			},
			BloodRitualsay = {
				varname = format(L.alert["%s %s %s!"],SN[159724],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[159724],L.alert["on"],L.alert["Me"]),
				desc = 159724,
				icon = ST[159724],
				flashcolor = "RED",
				flashscreen = true,
			},
			Heartseekersay = {
				varname = format(L.alert["%s %s %s!"],SN[158010],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[158010],L.alert["on"],L.alert["Me"]),
				desc = 158010,
				icon = ST[158010],
			},			
		},		
		messages = {
			mConvulsiveShadows = {
				varname = format(L.alert["%s %s %s"],SN[156109],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[156109],L.alert["on"]),
				color1 = "BROWN",
				sound = "ALERT13",
				desc = 156109,
				icon = ST[156109],
			},				
			mBladeDash = {
				varname = format(L.alert["%s %s %s"],SN[155794],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[155794],L.alert["on"]),
				color1 = "GOLD",
				sound = "ALERT13",
				desc = 155794,
				icon = ST[155794],
			},		
			mHeartseeker = {
				varname = format(L.alert["%s %s %s"],SN[158010],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Heartseekerunists&"],SN[158010],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 158010,
				icon = ST[158010],
			},		
			mIronWill = {
				varname = format(L.alert["%s!"],SN[159336]),
				type = "message",
				text = format(L.alert["%s!"],SN[159336]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 159336,
				icon = ST[159336],
			},
			mRapidFire = {
				varname = format(L.alert["%s %s %s"],SN[156631],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[156631],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 156631,
				icon = ST[156631],
			},			
			mFixate = {
				varname = format(L.alert["%s %s %s"],SN[158702],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[158702],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 158702,
				icon = ST[158702],
			},
			mPenetratingShot = {
				varname = format(L.alert["%s %s %s"],SN[164271],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[164271],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 164271,
				icon = ST[164271],
			},	
			mDarkHunt = {
				varname = format(L.alert["%s %s %s"],SN[158315],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[158315],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 158315,
				icon = ST[158315],
			},
			mBloodRitual = {
				varname = format(L.alert["%s %s %s"],SN[159724],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[159724],L.alert["on"]),
				color1 = "BROWN",
				sound = "ALERT13",
				desc = 159724,
				icon = ST[159724],
			},
			mDeadlyThrow = {
				varname = format(L.alert["%s %s %s"],SN[158692],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[158692],L.alert["on"]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 158692,
				icon = ST[158692],
			},	
			mBombardmentAlpha = {
				varname = format(L.alert["%s!"],SN[157854]),
				type = "message",
				text = format(L.alert["%s!"],SN[157854]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 157854,
				icon = ST[157854],
			},
			mBombardmentOmega = {
				varname = format(L.alert["%s!"],SN[157886]),
				type = "message",
				text = format(L.alert["%s!"],SN[157886]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 157886,
				icon = ST[157886],
			},			
		},
		onstart = {
			{
				"alert",{"BloodRitualCD", time = 2},
				"alert",{"BladeDashCD", time = 2},
				"alert",{"RapidFireCD", time = 2},
				"alert",{"ShipCD", time = 2},
				--"scheduletimer",{"timerPower",1},
			},
		},
		alerts = {
			DeployTurretCD = {
				varname = format(L.alert["%s Cooldown"],SN[158599]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158599]),
				time = 20,
				time2 = "<deployturrent>",
				color1 = "MIDBLUE",
				icon = ST[158599],
				desc = 158599,
			},		
			ShipCD = {
				varname = format(L.alert["%s Cooldown"],Ship),--SN["ej10019"]
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],Ship),
				time = 198,
				time2 = 60,
				time3 = 88,
				time4 = 18,
				color1 = "MIDBLUE",
				icon = ST[76204],
				ability = 10019,
			},
			WarningupCD = {
				varname = format(L.alert["%s Cooldown"],SN[158849]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158849]),
				time = 88,
				color1 = "MIDBLUE",
				icon = ST[158849],
				desc = 158849,
			},	
			BombardmentCD = {
				varname = format(L.alert["%s Cooldown"],SN[147135]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[147135]),
				time = 18,
				time2 = 11,
				color1 = "MIDBLUE",
				icon = ST[147135],
				desc = 147135,
			},			
			BombardmentAlphaCD = {
				varname = format(L.alert["%s Cooldown"],SN[157854]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[157854]),
				time = 18,
				color1 = "MIDBLUE",
				icon = ST[157854],
				desc = 157854,
			},
			RapidFireCD = {
				varname = format(L.alert["%s Cooldown"],SN[156631]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156631]),
				time = 30,
				time2 = 19,
				time3 = 31.6,
				time4 = "<rapidfire>",
				color1 = "MIDBLUE",
				icon = ST[156631],
				desc = 156631,
			},
			EarthenBarrierCD = {
				varname = format(L.alert["%s Cooldown"],SN[158708]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158708]),
				time = 10,
				color1 = "MIDBLUE",
				icon = ST[158708],
				desc = 158708,
			},			
			DarkHuntCD = {
				varname = format(L.alert["%s Cooldown"],SN[158315]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158315]),
				time = 13.5,
				time2 = 13,
				time3 = "<darkhunt>",
				color1 = "MIDBLUE",
				icon = ST[158315],
				desc = 158315,
			},
			PenetratingShotCD = {
				varname = format(L.alert["%s Cooldown"],SN[164271]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[164271]),
				time = 22,
				time2 = 30,
				time3 = "<penetrationshot>",
				color1 = "MIDBLUE",
				icon = ST[164271],
				desc = 164271,
			},
			BloodRitualCD = {
				varname = format(L.alert["%s Cooldown"],SN[159724]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[159724]),
				time = 12,
				time2 = 5,
				time3 = 20,
				time4 = "<bloodritual>",
				color1 = "MIDBLUE",
				icon = ST[159724],
				desc = 159724,
			},	
			ConvulsiveShadowsCD = {
				varname = format(L.alert["%s Cooldown"],SN[156214]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156214]),
				time = 46.5,
				time2 = 56,
				time3 = "<convulsiveshadow>",
				color1 = "MIDBLUE",
				icon = ST[156214],
				desc = 156214,
			},
			BladeDashCD = {
				varname = format(L.alert["%s Cooldown"],SN[155794]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155794]),
				time = 18,
				time2 = 11,
				time3 = "<bladedash>",
				color1 = "MIDBLUE",
				icon = ST[155794],
				desc = 155794,
			},	
			HeartSeekerCD = {
				varname = format(L.alert["%s Cooldown"],SN[158010]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158010]),
				time = 51,
				time2 = 70,
				time3 = "<heartseeker>",
				color1 = "MIDBLUE",
				icon = ST[158010],
				desc = 158010,
			},
			-- Warning
			wDeployTurret = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[158599]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[158599]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[158599],
				sound = "ALERT10",
				desc = 158599,
			},			
			--[[wBladeDash = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155794]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155794]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[155794],
				sound = "ALERT10",
				desc = 155794,
			},--]]
			wEarthenBarrier = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[158708]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[158708]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[158708],
				sound = "ALERT10",
				desc = 158708,
			},			
			wSanguineStrikes = {
				varname = format(L.alert["%s!"],SN[156601]),
				type = "simple",
				text = format(L.alert["%s!"],SN[156601]),
				time = 2,
				color1 = "RED",
				icon = ST[156601],
				sound = "ALERT13",
				desc = 156601,
				exdps = true,
				extank = true,
			},				
			-- Inform
			iCorruptedBlood = {
				varname = format(L.alert["%s %s, %s!"],SN[158683],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[158683],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[158683],
				sound = "ALERT12",
				desc = 158683,
				flashscreen = true,
				throttle = 1,
			},			
			iRapidFire = {
				varname = format(L.alert["%s %s %s!"],SN[156631],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[156631],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[156631],
				sound = "ALERT11",
				desc = 156631,
				flashscreen = true,
			},
			iPenetratingShot = {
				varname = format(L.alert["%s %s %s!"],SN[164271],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[164271],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[164271],
				sound = "ALERT10",
				desc = 164271,
				flashscreen = true,
			},
			iFixate = {
				varname = format(L.alert["%s %s %s!"],SN[158702],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[158702],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[158702],
				sound = "ALERT10",
				desc = 158702,
				flashscreen = true,
				throttle = 3,
			},
			iConvulsiveShadows = {
				varname = format(L.alert["%s %s %s!"],SN[156109],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[156109],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "BROWN",
				icon = ST[156109],
				sound = "ALERT10",
				desc = 156109,
				flashscreen = true,
				exflex = true,
				exheroic = true,
				exlfr = true,
			},			
			--[[iConvulsiveShadowsDispell = {
				varname = format(L.alert["%s %s %s %s!"],L.alert["Dispell"],SN[156109],L.alert["on"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s %s %s #5#!"],L.alert["Dispell"],SN[156109],L.alert["on"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[156109],
				sound = "ALERT13",
				desc = 156109,
			},--]]					
			-- Casts
			RapidFireCast = {
				varname = format(L.alert["%s Active"],SN[156631]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[156631]),
				time = 10.5,
				color1 = "RED",
				icon = ST[156631],
				desc = 156631,
			},
			HeartseekerActive = {
				varname = format(L.alert["%s Active"],SN[158010]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[158010]),
				time = 5,
				color1 = "RED",
				icon = ST[158010],
				desc = 158010,
			},
			PenetratingShotActive = {
				varname = format(L.alert["%s Active"],SN[164271]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[164271]),
				time = 8,
				time2 = 6,
				color1 = "ORANGE",
				icon = ST[164271],
				desc = 164271,
			},	
			BloodRitualActive = {
				varname = format(L.alert["%s Active"],SN[159724]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[159724]),
				time = 5,
				color1 = "RED",
				icon = ST[159724],
				desc = 159724,
			},				
			-- Debuff
			PenetratingShotDebuff = {
				varname = format(L.alert["%s Debuff"],SN[164271]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[164271]),
				text2 = format(L.alert["#5#: %s"],SN[164271]),
				time = 8,
				time2 = 6,
				color1 = "PURPLE",
				desc = 164271,
				icon = ST[164271],
				tag = "#5#",
				exdps = true,				
			},
			DarkHuntDebuff = {
				varname = format(L.alert["%s Debuff"],SN[158315]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[158315]),
				text2 = format(L.alert["#5#: %s"],SN[158315]),
				time = 8,
				color1 = "RED",
				desc = 158315,
				icon = ST[158315],
				tag = "#5#",
				exdps = true,				
			},
			HeartseekerDebuff = {
				varname = format(L.alert["%s Debuff"],SN[158010]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[158010]),
				text2 = format(L.alert["#5#: %s"],SN[158010]),
				time = 5,
				color1 = "RED",
				desc = 158010,
				icon = ST[158010],
				tag = "#5#",
				exdps = true,
			},					
		},
		events = {
			-- IronWill
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {159336},
				execute = {
					{
						"expect",{"&getprev|<prev>&",">","5"},
						"set",{prev = "&gettime&"},
						"message","mIronWill",
						"quash","ShipCD",
					},						
				},
			},
			-- RapidFire
			{
				type = "event",
				event = "BOSS_WHISPER", 
				execute = {
					{
						"expect",{"#1#","find","spell:156626"},
						"alert","RapidFireCast",
						"alert","iRapidFire",
						"announce","RapidFiresay",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156631},
				execute = {
					{
						"raidicon","RapidFiremark",
					},
					{
						--"expect",{"&unitposition|player|false|true&",">","3200"},
						"expect",{"&unitposition|player&",">","3200"},
						"set",{rapidfire = "&gettime|31.6"},
						"alert",{"RapidFireCD", time = 4},
					},
					{
						"expect",{"&unitposition|player&","<","3201"},
						"message","mRapidFire",
						"alert",{"RapidFireCD", time = 3},
						"invoke",{
							{
								"expect",{"#4#","~=","&playerguid&"},
								"arrow","RapidFireArrow",
							},
						},
					},							
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {156631},
				execute = {
					{
						"removeraidicon","#5#",
						"removearrow","#5#",
					},			
				},
			},
			-- PenetratingShot
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {164271},
				execute = {
					{
						"raidicon","PenetratingShotmark",
					},			
					{
						"expect",{"&unitposition|player&",">","3200"},
						"set",{penetrationshot = "&gettime|30"},
						"alert",{"PenetratingShotCD", time = 3},
					},
					{
						"expect",{"&unitposition|player&","<","3201"},
						"message","mPenetratingShot",
						"alert",{"PenetratingShotCD", time = 2},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","iPenetratingShot",
								"announce","PenetratingShotsay",
								"invoke",{
									{
										"expect",{"&flex&","==","true"},
										"alert","PenetratingShotDebuff",
										"alert","PenetratingShotActive",
									},
									{
										"expect",{"&flex&","==","false"},
										"alert",{"PenetratingShotDebuff", time = 2},
										"alert",{"PenetratingShotActive", time = 2},
									},									
								},
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"arrow","PenetratingShotarrow",
								"invoke",{
									{
										"expect",{"&flex&","==","true"},
										"alert",{"PenetratingShotDebuff", text = 2},
									},
									{
										"expect",{"&flex&","==","false"},
										"alert",{"PenetratingShotDebuff", time = 2, text = 2},
									},									
								},
							},		
						},
					},							
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {164271},
				execute = {
					{
						"removeraidicon","#5#",
						"removearrow","#5#",
						"quash","PenetratingShotDebuff",
					},			
				},
			},
			-- DeployTurret
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158599},
				execute = {
					{
						"alert","wDeployTurret",
					},
				--	{
				--		"expect",{"&unitposition|player&",">","3200"},
				--		"set",{deployturrent = "&gettime|22"},
				--		"alert",{"DeployTurretCD", time = 2},
				--	},
				--	{
						--"expect",{"&unitposition|player|false|true&","<","3201"},
						--"alert","DeployTurretCD",
				--	},				
				},
			},
			-- BladeDash
			{
				type = "combatevent",
				--eventtype = "SPELL_CAST_START",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {155794},
				execute = {
					{
						"expect",{"&unitposition|player&",">","3200"},
						"set",{bladedash = "&gettime|18"},
						"alert",{"BladeDashCD", time = 3},
					},
					{
						"expect",{"&unitposition|player&","<","3201"},
						"alert","BladeDashCD",
						--"alert","wBladeDash",
						"message","mBladeDash",
					},				
				},
			},
			-- ConvulsiveShadows
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START", -- SPELL_CAST_SUCCESS
				spellid = {156109},
				execute = {
					{
						"expect",{"&dispell|magic&","==","true"},
						"invoke",{
							{
								
								"expect",{"&unitposition|player&",">","3200"},
								"set",{convulsiveshadow = "&gettime|56"},
								"alert",{"ConvulsiveShadowsCD", time = 3},
							},
							{
								"expect",{"&unitposition|player&","<","3201"},
								"alert",{"ConvulsiveShadowsCD", time = 2},
								"target",{
									source = "#1#",
									--npcid = 77231,
									wait = 0.1,
									schedule = 13,
									message = "mConvulsiveShadows",
									alerts = {
										self = "iConvulsiveShadows",
										--other = 
									},									
								},
							--	"alert","iConvulsiveShadowsDispell",
							},
						},
					},
				},
			},	
			-- DarkHunt
			--[[{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {158315},
				execute = {
					{
						"expect",{"&unitposition|player&",">","3200"},
						"set",{darkhunt = "&gettime|13"},
						--"alert",{"DarkHuntCD", time = 3},
					},
					{
						"expect",{"&unitposition|player&","<","3201"},
						--"alert","DarkHuntCD",
						"message","mDarkHunt",
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","DarkHuntDebuff",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"DarkHuntDebuff", text = 2},
							},		
						},
					},				
				},
			},--]]
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {158315},
				execute = {
					{
						--"alert","DarkHuntCD",
						"message","mDarkHunt",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","DarkHuntDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"DarkHuntDebuff", text = 2},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {158315},
				execute = {
					{
						"quash","DarkHuntDebuff",
					},			
				},
			},			
			-- BloodRitual
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {159724},
				execute = {
					{
						"expect",{"&unitposition|player&",">","3200"},
						"set",{bloodritual = "&gettime|20"},
						"alert",{"BloodRitualCD", time = 4},
					},
					{
						"expect",{"&unitposition|player&","<","3201"},
						"alert",{"BloodRitualCD", time = 3},
						"message","mBloodRitual",
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","BloodRitualActive",
								"announce","BloodRitualsay",
							},
						},
					},				
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {159724},
				execute = {
					{
						"quash","BloodRitualActive",
					},			
				},
			},	
			-- Heartseeker
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {158010},
				execute = {
					{
						"insert",{"Heartseekerunists","#5#"},
						"raidicon","Heartseekermmark",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","HeartseekerActive",
						"alert","HeartseekerDebuff",
						"announce","Heartseekersay",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"HeartseekerDebuff", text = 2},
					},
					{
						"expect",{"&count|Heartseekerunists&","==","1"},
						"invoke",{
							{
								"expect",{"&unitposition|player&",">","3200"},
								"set",{heartseeker = "&gettime|70"},
								"alert",{"HeartSeekerCD", time = 3},
							},
							{
								"expect",{"&unitposition|player&","<","3201"},
								"alert",{"HeartSeekerCD", time = 2},
								"canceltimer","timerHeartseeker",
								"scheduletimer",{"timerHeartseeker",0.5},
							},
						},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {158010},
				execute = {
					{
						"removeraidicon","#5#",
						"quash","HeartseekerDebuff",
						"quash","HeartseekerActive",
					},			
				},
			},
			-- SanguineStrikes
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156601},
				execute = {
					{
						"alert","wSanguineStrikes",
					},		
				},
			},
			-- CorruptedBlood
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {158683},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iCorruptedBlood",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {158683},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iCorruptedBlood",
					},
				},
			},	
			-- EarthenBarrier
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158708},
				execute = {
					{
						"expect",{"&unitposition|player&",">","3200"},
						"alert","wEarthenBarrier",
						"alert","EarthenBarrierCD", 
					},		
				},
			},
			-- DeadlyThrow
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158692},
				execute = {
					{
						"expect",{"&unitposition|player&",">","3200"},
						"target",{
							source = "#1#",
							wait = 0.1,
							schedule = 16,
							message = "mDeadlyThrow",
							--announce = "",
							alerts = {
								--self = "",
							},
						},
					},		
				},
			},
			-- BombardmentAlpha
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {157854},
				execute = {
					{
						"expect",{"&unitposition|player&","<","3201"},
						"message","mBombardmentAlpha",
						--"alert",{"ShipCD", time = 4},
						"alert","BombardmentCD",
					},	
					{
						"expect",{"&unitposition|player&",">","3200"},
						"alert",{"BombardmentCD", time = 2},
					},	
				},
			},
			-- BombardmentOmega
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {157886},
				execute = {
					{
						"expect",{"&unitposition|player&","<","3201"},
						"message","mBombardmentOmega",
					},	
					{
						"expect",{"&unitposition|player&",">","3200"},
						"alert",{"BombardmentCD", time = 2},
					},						
				},
			},
			-- Fixate
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {158702},
				execute = {
					{
						"expect",{"&unitposition|player&",">","3200"},
						"message","mFixate",
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","iFixate",
							},
						},
					},		
				},
			},
			----------------------------
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED", 
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","70628"}, -- Permanent Feign Death
								"invoke",{
									{
										"expect",{"&npcid|#1#&","==","77477"},
										"batchquash",{"BloodRitualCD","HeartSeekerCD"}, -- Sanguine Strikes?
									},
									{
										"expect",{"&npcid|#1#&","==","77557"},
										"batchquash",{"RapidFireCD","PenetratingShotCD","DeployTurretCD"},
									},
									{
										"expect",{"&npcid|#1#&","==","77231"},
										"batchquash",{"BladeDashCD","ConvulsiveShadowsCD"}, 
									},									
								},
							},								
						},
					},
				},
			},	
			-- Emotes
			{
				type = "event",
				event = "EMOTE", 
				execute = {
					-- Ship
					{
						"expect",{"#1#","find",L.chat_BlackrockFoundry["(prepares to man the Dreadnaught's Main Cannon!)"]},
						"set",{ship = "INCR|1"},
						"invoke",{
							{
								"expect",{"#2#","==",Garan},
								"batchquash",{"RapidFireCD","PenetratingShotCD","DeployTurretCD"},
							},
							{
								"expect",{"#2#","==",Sorka},
								"batchquash",{"BladeDashCD","ConvulsiveShadowsCD"}, 
							},
							{
								"expect",{"#2#","==",Marak},
								"batchquash",{"BloodRitualCD","HeartSeekerCD"}, -- Sanguine Strikes?
							},	
							{
								"expect",{"<ship>","<","3"},
								"alert","ShipCD",
							},	
							{
								"scheduletimer",{"timerBoat",6},
							},								
						},
					},
				},
			},
			{
                type = "event",
                event = "UNIT_POWER_FREQUENT",
                execute = {
					{
						"expect",{"#1# #2#","==","boss1 ALTERNATE"},
						"set",{power = "&getap|boss1&"},
						"invoke",{
							{
								"expect",{"<power>","==","1"},
								"alert","WarningupCD",
							},					
							{
								"expect",{"<power>","==","0"},
								"quash","WarningupCD",
								"quash","BombardmentCD",
								"invoke",{
									{
										"expect",{"<rapidfire>",">","&gettime&"},
										"set",{rapidfire = "&gettime|0|<rapidfire>&"},
										"alert",{"RapidFireCD", time = 4},
									},
									{
										"expect",{"<penetrationshot>",">","&gettime&"},
										"set",{penetrationshot = "&gettime|0|<penetrationshot>&"},
										"alert",{"PenetratingShotCD", time = 3},
									},
									{
										"expect",{"<deployturrent>",">","&gettime&"},
										"set",{deployturrent = "&gettime|0|<deployturrent>&"},
										"alert",{"DeployTurretCD", time = 2},
									},
									{
										"expect",{"<convulsiveshadow>",">","&gettime&"},
										"set",{convulsiveshadow = "&gettime|0|<convulsiveshadow>&"},
										"alert",{"ConvulsiveShadowsCD", time = 3},
									},
									{
										"expect",{"<darkhunt>",">","&gettime&"},
										"set",{darkhunt = "&gettime|0|<darkhunt>&"},
										"alert",{"DarkHuntCD", time = 3},
									},
									{
										"expect",{"<bloodritual>",">","&gettime&"},
										"set",{bloodritual = "&gettime|0|<bloodritual>&"},
										"alert",{"BloodRitualCD", time = 4},
									},
									{
										"expect",{"<heartseeker>",">","&gettime&"},
										"set",{heartseeker = "&gettime|0|<heartseeker>&"},
										"alert",{"HeartSeekerCD", time = 3},
									},
									{
										"set",{rapidfire = 0},
										"set",{penetrationshot = 0},
										"set",{deployturrent = 0},
										"set",{convulsiveshadow = 0},
										"set",{darkhunt = 0},
										"set",{bloodritual = 0},
										"set",{heartseeker = 0},
									},
								},
							},
						},
					},
					{
						"expect",{"#1# #2#","==","boss2 ALTERNATE"},
						"set",{power = "&getap|boss2&"},
						"invoke",{
							{
								"expect",{"<power>","==","1"},
								"alert","WarningupCD",
							},					
							{
								"expect",{"<power>","==","0"},
								"quash","BombardmentAlphaCD",
								"quash","WarningupCD",
								"invoke",{
									{
										"expect",{"<rapidfire>",">","&gettime&"},
										"set",{rapidfire = "&gettime|0|<rapidfire>&"},
										"alert",{"RapidFireCD", time = 4},
									},
									{
										"expect",{"<penetrationshot>",">","&gettime&"},
										"set",{penetrationshot = "&gettime|0|<penetrationshot>&"},
										"alert",{"PenetratingShotCD", time = 3},
									},
									{
										"expect",{"<deployturrent>",">","&gettime&"},
										"set",{deployturrent = "&gettime|0|<deployturrent>&"},
										"alert",{"DeployTurretCD", time = 2},
									},
									{
										"expect",{"<convulsiveshadow>",">","&gettime&"},
										"set",{convulsiveshadow = "&gettime|0|<convulsiveshadow>&"},
										"alert",{"ConvulsiveShadowsCD", time = 3},
									},
									{
										"expect",{"<darkhunt>",">","&gettime&"},
										"set",{darkhunt = "&gettime|0|<darkhunt>&"},
										"alert",{"DarkHuntCD", time = 3},
									},
									{
										"expect",{"<bloodritual>",">","&gettime&"},
										"set",{bloodritual = "&gettime|0|<bloodritual>&"},
										"alert",{"BloodRitualCD", time = 4},
									},
									{
										"expect",{"<heartseeker>",">","&gettime&"},
										"set",{heartseeker = "&gettime|0|<heartseeker>&"},
										"alert",{"HeartSeekerCD", time = 3},
									},
									{
										"set",{rapidfire = 0},
										"set",{penetrationshot = 0},
										"set",{deployturrent = 0},
										"set",{convulsiveshadow = 0},
										"set",{darkhunt = 0},
										"set",{bloodritual = 0},
										"set",{heartseeker = 0},
									},
								},
							},
						},
					},
					{
						"expect",{"#1# #2#","==","boss3 ALTERNATE"},
						"set",{power = "&getap|boss3&"},
						"invoke",{
							{
								"expect",{"<power>","==","1"},
								"alert",{"ShipCD", time = 3},
							},					
							{
								"expect",{"<power>","==","0"},
								"quash","ShipCD",
								"invoke",{
									{
										"expect",{"<rapidfire>",">","&gettime&"},
										"set",{rapidfire = "&gettime|0|<rapidfire>&"},
										"alert",{"RapidFireCD", time = 4},
									},
									{
										"expect",{"<penetrationshot>",">","&gettime&"},
										"set",{penetrationshot = "&gettime|0|<penetrationshot>&"},
										"alert",{"PenetratingShotCD", time = 3},
									},
									{
										"expect",{"<deployturrent>",">","&gettime&"},
										"set",{deployturrent = "&gettime|0|<deployturrent>&"},
										"alert",{"DeployTurretCD", time = 2},
									},
									{
										"expect",{"<convulsiveshadow>",">","&gettime&"},
										"set",{convulsiveshadow = "&gettime|0|<convulsiveshadow>&"},
										"alert",{"ConvulsiveShadowsCD", time = 3},
									},
									{
										"expect",{"<darkhunt>",">","&gettime&"},
										"set",{darkhunt = "&gettime|0|<darkhunt>&"},
										"alert",{"DarkHuntCD", time = 3},
									},
									{
										"expect",{"<bloodritual>",">","&gettime&"},
										"set",{bloodritual = "&gettime|0|<bloodritual>&"},
										"alert",{"BloodRitualCD", time = 4},
									},
									{
										"expect",{"<heartseeker>",">","&gettime&"},
										"set",{heartseeker = "&gettime|0|<heartseeker>&"},
										"alert",{"HeartSeekerCD", time = 3},
									},
									{
										"set",{rapidfire = 0},
										"set",{penetrationshot = 0},
										"set",{deployturrent = 0},
										"set",{convulsiveshadow = 0},
										"set",{darkhunt = 0},
										"set",{bloodritual = 0},
										"set",{heartseeker = 0},
									},
								},
							},
						},
					},					
				},
			},
			
		},
	}

	DXE:RegisterEncounter(data)
end