local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1196)

do
	local data = {
		version = 2,
		key = "Brackenspore",
		zone = L.zone["Highmaul"],
		category = L.zone["Highmaul"],
		--name = L.npc_Highmaul["Brackenspore"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Brackenspore.BLP:35:35",
		triggers = {
			scan = {78491}, 
			encounterid = {1720},
			ejid = {1196},
		},
		onactivate = {
			tracing = {78491},
			tracerstart = true,
			combatstop = true,
			unittracing = {	"boss1"},
			defeat = 78491,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			timelfr = 600,
			timeflex = 600,
			timeheroic = 600,
			timemythic = 600,
		},
		userdata = {
			spores = 0,
			rot = 0,
			sporesCount = 0,
		},		
		messages = {
			mRot = {
				varname = format(L.alert["%s %s %s"],SN[163241],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (1)"],SN[163241],L.alert["on"]),
				text2 = format(L.alert["%s %s #5# (#11#)"],SN[163241],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 163241,
				icon = ST[163241],
			},
			mCreepingMoss = {
				varname = format(L.alert["%s %s %s"],SN[164125],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[164125],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 164125,
				icon = ST[164125],
			},	
			mInfestingSpores = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[159996]),
				type = "message",
				text = format(L.alert["%s %s (<sporesCount>"],L.alert["Incoming"],SN[159996]),
				time = 2,
				color1 = "RED",
				icon = ST[159996],
				sound = "ALERT13",
				desc = 159996,
			},			
		},
		onstart = {
			{
				"alert",{"MindFungusCD", time = 2},
				"alert",{"LivingMushroomCD", time = 2},
				"alert",{"SporeShooterCD", time = 2},
				"alert",{"NecroticBreathCD", time = 2},
				"alert",{"FungalFleshEaterCD", time = 2},
				"alert",{"RejuvMushroomCD", time = 2},
				"alert",{"InfestingSporesCD", time = 2},
			},
		},
		alerts = {
			InfestingSporesCD = {
				varname = format(L.alert["%s Cooldown"],SN[159996]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[159996]),
				time = 57,
				time2 = 45,
				color1 = "MIDBLUE",
				icon = ST[159996],
				desc = 159996,
				audiocd = true,
				audiotime = 10,				
			},
			RotCD = {
				varname = format(L.alert["%s Cooldown"],SN[163241]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163241]),
				time = 10,
				color1 = "MIDBLUE",
				icon = ST[163241],
				desc = 163241,
				enabled = false,
			},
			NecroticBreathCD = {
				varname = format(L.alert["%s Cooldown"],SN[159219]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[159219]),
				time = 32,
				time2 = 30,
				color1 = "MIDBLUE",
				icon = ST[159219],
				desc = 159219,
				exdps = true,
			},
			SporeShooterCD = {
				varname = format(L.alert["%s Cooldown"],SN[163594]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163594]),
				time = 57,
				time2 = 20,
				color1 = "MIDBLUE",
				icon = ST[163594],
				desc = 163594,
			},
			FungalFleshEaterCD = {
				varname = format(L.alert["%s Cooldown"],SN["ej9995"]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN["ej9995"]),
				time = 120,
				time2 = 32,
				color1 = "MIDBLUE",
				icon = EJST[9995],
				ability = 9995,
			},
			DecayCD = {
				varname = format(L.alert["%s Cooldown"],SN[160013]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[160013]),
				time = 9.5,
				color1 = "MIDBLUE",
				icon = ST[160013],
				desc = 160013,
				exdps = true,
			},
			MindFungusCD = {
				varname = format(L.alert["%s Cooldown"],SN[163141]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163141]),
				time = 30,
				time2 = 10,
				color1 = "MIDBLUE",
				icon = ST[163141],
				desc = 163141,
				exhealer = true,
				extank = true,
			},
			LivingMushroomCD = {
				varname = format(L.alert["%s Cooldown"],SN[160022]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[160022]),
				time = 55.5,
				time2 = 18,
				color1 = "MIDBLUE",
				icon = ST[160022],
				desc = 160022,
			},
			RejuvMushroomCD = {
				varname = format(L.alert["%s Cooldown"],SN[160021]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[160021]),
				time = 150,
				time2 = 80,
				color1 = "MIDBLUE",
				icon = ST[160021],
				desc = 160021,
			},
			SpecialCD = {
				varname = format(L.alert["%s Cooldown"],SN[163755]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163755]),
				time = 20,
				color1 = "MIDBLUE",
				icon = ST[163755],
				desc = 163755,
			},
			-- Warning
			wSpore = {
				varname = format(L.alert["%s!"],SN[163594]),
				type = "simple",
				text = format(L.alert["%s!"],SN[163594]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[163594],
				sound = "ALERT13",
				desc = 163594,
			},
			wMindFungus = {
				varname = format(L.alert["%s!"],SN[163141]),
				type = "simple",
				text = format(L.alert["%s!"],SN[163141]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[163141],
				sound = "ALERT13",
				desc = 163141,
			},
			wFungalFlesheater = {
				varname = format(L.alert["%s!"],SN["ej9995"]),
				type = "simple",
				text = format(L.alert["%s!"],SN["ej9995"]),
				time = 2,
				color1 = "RED",
				icon = EJST[9995],
				sound = "ALERT10",
				ability = 9995,
			},	
			wLivingMushroom = {
				varname = format(L.alert["%s!"],SN[160022]),
				type = "simple",
				text = format(L.alert["%s!"],SN[160022]),
				time = 2,
				color1 = "GREEN",
				icon = ST[160022],
				sound = "ALERT14",
				desc = 160022,
			},
			wRejuvMushroom = {
				varname = format(L.alert["%s!"],SN[160021]),
				type = "simple",
				text = format(L.alert["%s!"],SN[160021]),
				time = 2,
				color1 = "GREEN",
				icon = ST[160021],
				sound = "ALERT14",
				desc = 160021,
			},
			wRejuvMushroom = {
				varname = format(L.alert["%s!"],SN[163794]),
				type = "simple",
				text = format(L.alert["%s!"],SN[163794]),
				time = 2,
				color1 = "RED",
				icon = ST[163794],
				sound = "ALERT10",
				desc = 163794,
			},
			wWaves = {
				varname = format(L.alert["%s!"],SN[163755]),
				type = "simple",
				text = format(L.alert["%s!"],SN[163755]),
				time = 2,
				color1 = "RED",
				icon = ST[163755],
				sound = "ALERT11",
				desc = 163755,
			},
			wDecay = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[160013]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[160013]),
				time = 2,
				color1 = "RED",
				icon = ST[160013],
				sound = "ALERT10",
				desc = 160013,
				exhealer = true,
			},	
			wNecroticBreath = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[159219]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[159219]),
				time = 2,
				color1 = "RED",
				icon = ST[159219],
				sound = "ALERT11",
				desc = 159219,
			},				
			-- Inform
			iDecay = {
				varname = format(L.alert["%s: %s"],SN[160013],L.alert["INTERRUPT"]),
				type = "inform",
				text = format(L.alert["%s: %s #2#"],SN[160013],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "RED",
				--sound = "ALERT10",
				icon = ST[160013],
				exhealer = true,
				desc = 160013,
			},				
			iSporeShooter = {
				varname = format(L.alert["%s %s!"],SN[163594],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[163594],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",                
				icon = ST[163594],
				desc = 163594,
			},
			iMindFungus = {
				varname = format(L.alert["%s %s!"],SN[163141],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[163141],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[163141],
				desc = 163141,
				exhealer = true,
				extank = true,
			},
			iFungalFlesheater = {
				varname = format(L.alert["%s %s!"],SN["ej9995"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN["ej9995"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = EJST[9995],
				ability = 9995,
				exhealer = true,
			},	
			iRot = {
				varname = format(L.alert["%s: %s 4 %s!"],SN[163241],L.alert["already at"],L.alert["Stacks"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s!"],SN[163241],L.alert["already at"],L.alert["Stacks"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT14",
				icon = ST[163241],
				desc = 163241,
				flashscreen = true,
				exdps = true,
				exhealer = true,				
			},
			iRotTaunt = {
				varname =  format(L.alert["%s - %s!"],SN[163241],L.alert["Taunt"]),
				type = "inform",
				text = format(L.alert["%s - %s!"],SN[163241],L.alert["Taunt"]),
				time = 2,
				color1 = "GREEN",
				sound = "ALERT10",
				icon = ST[163241],
				desc = 163241,
				exdps = true,
				exhealer = true,
				flashscreen = true,
			},
			iCreepingMoss = {
				varname = format(L.alert["%s %s!"],SN[136646],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[136646],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT12",
				icon = ST[136646],
				flashscreen = true,
				desc = 136646,
				exdps = true,
				exhealer = true,
			},				
			-- Debuff
			Rotstacks = {
				varname = format(L.alert["%s Debuff"],SN[163241]),
				type = "debuff",
				text = format(L.alert["%s: %s (1)"],L.alert["YOU"],SN[163241]),
				text2 = format(L.alert["%s: %s (#11#)"],L.alert["YOU"],SN[163241]),
				text3 = format(L.alert["#5#: %s (1)"],SN[163241]),
				text4 = format(L.alert["#5#: %s (#11#)"],SN[163241]),
				time = 45,
				color1 = "GREEN",
				icon = ST[163241],
				tag = "#5#",
				desc = 163241,
			},			
		},
		events = {
			-- InfestingSpores
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {159996},
				execute = {
					{
						"alert","InfestingSporesCD",
						"set",{sporesCount = "INCR|1"},
						"message","wInfestingSpores",
					},
				},
			},
			-- Decay
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {160013},
				execute = {
					{
						"alert","wDecay",
					},
					{
						"expect",{"&targetguild|true&","==","#1#"},
						"batchalert",{"DecayCD","iDecay"},
					},
					{
						"expect",{"&focusguid|true&","==","#1#"},
						"batchalert",{"DecayCD","iDecay"},
					},					
				},
			},
			-- NecroticBreath
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {159219},
				execute = {
					{
						"batchalert",{"NecroticBreathCD","wNecroticBreath"},
					},
				},
			},
		
			-- SporeShooter
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {163594},
				execute = {
					{
						"set",{spores = "INCR|1"},
						"batchalert",{"SporeShooterCD","wSpore"},
						"openwindow",{"8"},
					},
					{
						"expect",{"&isranged&","==","true"},
						"alert","iSporeShooter",
					},
				},
			},	
			-- Rot
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {163241},
				execute = {
					{
						"alert","RotCD",
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {163241},
				execute = {
					{
						"message","mRot",
					},		
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","Rotstacks",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"Rotstacks", text = 3},
					},	
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {163241},
				execute = {
					{
						"message",{"mRot", text = 2},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"Rotstacks", text = 2},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"Rotstacks", text = 4},
					},						
					{
						"expect",{"#11#",">=","4"},
						"invoke", {
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","iRot",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"expect",{"&playerdebuff|"..SN[163241].."&","==","false"},
								"alert","iRotTaunt",
							},
						},
					},
				},
			},	
			-- CreepingMoss
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {164125},
				dstnpcid = {78491},
				execute = {
					{
						"message","mCreepingMoss",
						"alert","iCreepingMoss",
					},						
				},
			},	
			-----------------------
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","79183"}, --Spore Shooter
						"set",{spores = "DECR|1"},
						"invoke", {
							{
								"expect",{"<spores>","==","0"},
								"closewindow",
							},
						},
					},		
					{
						"expect",{"&npcid|#4#&","==","79183"}, --Fungal Flesh Eater
						"quash","DecayCD",
					},
				},
			},
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","163141"}, -- MindFungus
								"invoke",{
									{
										"expect",{"&ismelee&","==","true"},
										"batchalert",{"MindFungusCD","wMindFungus"},
									},
									{
										"alert","iMindFungus",
									},
								},
							},
							{
								"expect",{"#5#","==","163142"}, -- FungalFlesheater
								"batchalert",{"FungalFleshEaterCD","wFungalFlesheater","iFungalFlesheater"},
							},
							{
								"expect",{"#5#","==","160022"}, -- LivingMushroom
								"batchalert",{"LivingMushroomCD","wLivingMushroom"},
							},
							{
								"expect",{"#5#","==","160021"}, -- RejuvMushroom
								"batchalert",{"RejuvMushroomCD","wRejuvMushroom"},
							},
							{
								"expect",{"#5#","==","177820"}, -- RejuvMushroom (Mythic)
								"batchalert",{"RejuvMushroomCD","wRejuvMushroom"},
							},	
							{
								"expect",{"#5#","==","163794"}, -- ExplodingFungus
								"batchalert",{"ExplodingFungusCD","wExplodingFungus"},
							},	
							{
								"expect",{"#5#","==","160425"}, -- Waves
								"batchalert",{"SpecialCD","wWaves"},
							},									
						},
					},
				},
			},	
			
		},
	}

	DXE:RegisterEncounter(data)
end