local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local Earthwarper = EJ_GetSectionInfo(10061)
local Berserker = EJ_GetSectionInfo(10062)
local EJName = EJ_GetEncounterInfo(1195)

do
	local data = {
		version = 3,
		key = "Tectus",
		zone = L.zone["Highmaul"],
		category = L.zone["Highmaul"],
		--name = L.npc_Highmaul["Tectus"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Tectus The Living Mountain.BLP:35:35",
		triggers = {
			scan = {78948,powers={true}},
			encounterid = {1722},
			ejid = {1195},
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {"boss1","boss2","boss3","boss4","boss5",powers={true,true,true,true,true}},
			unittracing = {"boss1","boss2","boss3","boss4","boss5"},
			defeat = 78948,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 300,
			timeflex = 600,
			timeheroic = 600,
			timemythic = 480,
		},
		timers = {
			timerCrystallineBarrage = {
				{
					"message","mCrystallineBarrage",
				},
			},
			timerDBM = {
				"set",{dbm = "0"},
			},
			timerCheckBosses = {
				{

				},

			},
			--[[timerCheckBosses1 = {
				{
					"expect",{"&unitexist|boss2& &unitexist|boss3&","==","1 0"},
					"tracing",{"boss2",powers={true}},
				},
				{
					"expect",{"&unitexist|boss2& &unitexist|boss3&","==","0 1"},
					"tracing",{"boss3",powers={true}},
				},
				{
					"expect",{"&unitexist|boss2& &unitexist|boss3&","==","1 1"},
					"debug",{"&unitexist|boss2&","&unitexist|boss3&"},
					"tracing",{"boss2","boss3",powers={true,true}},
				},
				{
					"expect",{"&unitexist|boss2& &unitexist|boss3& &unitexist|boss4&","==","1 1 1"},
					"tracing",{"boss2","boss3","boss4",powers={true,true,true}},
				},				
				{
					"expect",{"&unitexist|boss2& &unitexist|boss3& &unitexist|boss4&","==","1 0 1"},
					"tracing",{"boss2","boss4",powers={true,true}},
				},
				{
					"expect",{"&unitexist|boss3& &unitexist|boss4& &unitexist|boss5&","==","1 1 1"},
					"tracing",{"boss3","boss4","boss5",powers={true,true,true}},
				},
				{
					"expect",{"&unitexist|boss3& &unitexist|boss4& &unitexist|boss5&","==","0 1 1"},
					"tracing",{"boss4","boss5",powers={true,true}},
				},
				{
					"expect",{"&unitexist|boss3& &unitexist|boss4& &unitexist|boss5&","==","1 0 1"},
					"tracing",{"boss3","boss5",powers={true,true}},
				},
				{
					"expect",{"&unitexist|boss3& &unitexist|boss4& &unitexist|boss5&","==","1 1 0"},
					"tracing",{"boss3","boss4",powers={true,true}},
				},
								{
					"expect",{"&unitexist|boss3& &unitexist|boss4& &unitexist|boss5&","==","0 1 0"},
					"tracing",{"boss4",powers={true}},
				},
				{
					"expect",{"&unitexist|boss3& &unitexist|boss4& &unitexist|boss5&","==","0 0 1"},
					"tracing",{"boss5",powers={true}},
				},	
				{
					"scheduletimer",{"timerCheckBosses",1},
				},
			},--]]
		},			
		userdata = {
			dbm = 0,
			EarthwarperAlive = 0,
			firstEarthDuders = 0,
			earthDuders = {type="container"},
			CrystallineBarrageunists = {type = "container", wipein = 3},
			Tectus = 0,
			ShardofTectus = "",
			ShardofTectusunit = {type = "container"},
		},
		announces = { 
			CrystallineBarragesay = {
				varname = format(L.alert["%s %s %s!"],SN[162346],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[162346],L.alert["on"],L.alert["Me"]),
				desc = 162346,
				icon = ST[162346],
			},					
		},			
		raidicons = {
			CrystallineBarragemark = {
				varname = SN[162346],
				type = "MULTIFRIENDLY",
				persist = 120,
				unit = "#5#",
				icon = 3,
				total = 6,
				reset = 10,
				desc = 162346,
				icon2 = ST[162346],
			},
			ShardofTectusmark = {
				varname = SN["ej10063"],
				type = "MULTIENEMY",
				persist = 120,
				unit = "<ShardofTectus>",
				icon = 1,
				total = 2,
				ability = 10063,
				icon2 = EJST[10063],
			},				
		},		
		messages = {
			mCrystallineBarrage = {
				varname = format(L.alert["%s %s %s"],SN[162346],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|CrystallineBarrageunists&"],SN[162346],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 162346,
				icon = ST[162346],
			},
			mEarthwarper = {
				varname = format(L.alert["%s (2)"],SN["ej10061"]),
				type = "simple",
				text = format(L.alert["%s (<EarthwarperAlive>)"],SN["ej10061"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[162894],
				sound = "ALERT13",
				ability = 10061,
			},			
		},
		onstart = {	
			{
				"alert",{"EarthwarperCD", time = 2},
				"alert",{"BerserkerCD", time = 2},
				"scheduletimer",{"timerCheckBosses",10},
			},
		},
		alerts = {
			EarthwarperCD = {
				varname = format(L.alert["%s Cooldown"],SN["ej10061"]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN["ej10061"]),
				time = 41,
				time2 = 11,
				color1 = "MIDBLUE",
				icon = ST[162894],
				ability = 10061,	
				audiocd = true,
				audiotime = 5,					
			},
			BerserkerCD = {
				varname = format(L.alert["%s Cooldown"],SN["ej10062"]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN["ej10062"]),
				time = 41,
				time2 = 21,
				color1 = "MIDBLUE",
				icon = ST[163312],
				ability = 10062,	
				exhealer = true,
				exdps = true,
			},
			EarthenFlechettesCD = {
				varname = format(L.alert["%s Cooldown"],SN[162968]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[162968]),
				time = 14,
				color1 = "MIDBLUE",
				icon = ST[162968],
				desc = 162968,	
			},			
			GiftOfEarthCD = {
				varname = format(L.alert["%s Cooldown"],SN[162894]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[162894]),
				time = 10.5,
				time2 = 10,
				color1 = "MIDBLUE",
				icon = ST[162894],
				desc = 162894,
			},
			CrystalBarrageCD = {
				varname = format(L.alert["%s Cooldown"],SN[162346]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[162346]),
				time = 14,
				time2 = 15,
				time3 = 30,
				color1 = "MIDBLUE",
				icon = ST[162346],
				desc = 162346,
				enabled = false,
			},		
			-- Warning
			wTectonicUpheaval = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[162475]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[162475]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[162475],
				sound = "ALERT13",
				desc = 162475,
			},	
			wEarthenFlechettes = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[162968]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[162968]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[162968],
				sound = "ALERT13",
				desc = 162968,
			},
			wGiftOfEarth = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[162894]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[162894]),
				time = 2,
				color1 = "RED",
				icon = ST[162894],
				sound = "ALERT11",
				desc = 162894,
			},
			wRavingAssault = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[163312]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[163312]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[163312],
				sound = "ALERT13",
				desc = 163312,
			},
			wBerserker = {
				varname = format(L.alert["%s"],SN["ej10062"]),
				type = "simple",
				text = format(L.alert["%s"],SN["ej10062"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[163312],
				sound = "ALERT13",
				ability = 10062,
			},	
			wEarthenPillar = {
				varname = format(L.alert["%s"],SN[162518]),
				type = "simple",
				text = format(L.alert["%s"],SN[162518]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[162518],
				sound = "ALERT13",
				desc = 162518,
			},				
			-- Inform
			iEarthwarper = {
				varname = format(L.alert["%s %s!"],SN["ej10061"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN["ej10061"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[162894],
				ability = 10061,
				exhealer = true,
			},			
			iCrystallineBarrage = {
				varname = format(L.alert["%s %s %s!"],SN[162346],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[162346],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[162346],
				sound = "ALERT10",
				desc = 162346,
				flashscreen = true,
			},
			iCrystallineBarrageUnder = {
				varname = format(L.alert["%s %s, %s!"],SN[162370],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[162370],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[162370],
				sound = "ALERT10",
				desc = 162370,
				throttle = 3,
			},
			-- Casts
			CrystallineBarrageCast = {
				varname = format(L.alert["%s Active"],SN[162346]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[162346]),
				time = 15,
				color1 = "RED",
				icon = ST[162346],
				desc = 162346,
			},				
		},
		events = {
			{
				type = "event",
				event = "UPDATE_MOUSEOVER_UNIT",
				execute = {
					{
						"expect",{"&bossid|mouseover&","==","80551"}, -- Shard of Tectus
						"set",{ShardofTectus = "&bossid|mouseover|true&"},
						"expect",{"&tabread|ShardofTectusunit|<ShardofTectus>&","~=","true"},
						"raidicon","ShardofTectusmark",
						"tabinsert",{"ShardofTectusunit","<ShardofTectus>","true"},
					},				
				},
			},
			{
				type = "event",
				event = "UNIT_TARGET",
				execute = {
					{
						"expect",{"#1#","~=","0"},
						"invoke",{
							{
								"expect",{"&unittarget|#1#&","==","80551"}, -- Shard of Tectus
								"set",{ShardofTectus = "&unittarget|#1#|true&"},
								--"debug",{"&unittarget|#1#&","<ShardofTectus>","&tabread|ShardofTectusunit|<ArcaneAberration>&"},
								"tabinsert",{"ShardofTectusunit","<ShardofTectus>","true"},
								"expect",{"&tabread|ShardofTectusunit|<ShardofTectus>&","~=","true"},
							--	"debug",{"lalalalala","#1#","&tabread|ShardofTectusunit|<ShardofTectus>&"},
								"raidicon","ShardofTectusmark",
								"tabinsert",{"ShardofTectusunit","<ShardofTectus>","true"},
							},																		
						},
					},					
				},
			},
			-- TectonicUpheaval
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {162475},
				execute = {
					{
						"alert","wTectonicUpheaval",
					},
				},
			},
			-- EarthenFlechettes
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {162968},
				execute = {
					{
						"expect",{"&ismelee&","==","true"},
						"batchalert",{"EarthenFlechettesCD","wTectonicUpheaval"},
					},
				},
			},
			-- earthDuders
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {162894},
				execute = {
					{
						"expect",{"&ismelee&","==","true"},
						"invoke",{
							{
								--"expect",{"&tabread|earthDuders|#1#&","==","nil"},
								"expect",{"<firstEarthDuders>","==","0"},
								"set",{firstEarthDuders = "1"},
								--"tabinsert",{"earthDuders","#1#","0"},
							},
							{
								--"tabupdate",{"earthDuders","#1#","INCR|1"},
								"batchalert",{"GiftOfEarthCD","wGiftOfEarth"},
							},
						},
					},
				},
			},
			-- RavingAssault
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {163312},
				execute = {
					{
						"alert","wRavingAssault",
					},
				},
			},
			-- CrystallineBarrage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {162346},
				execute = {
					{
						"insert",{"CrystallineBarrageunists","#5#"},
						"canceltimer","timerCrystallineBarrage",
						"scheduletimer",{"timerCrystallineBarrage",1},
						"alert",{"CrystalBarrageCD", time = 3},
						"raidicon","CrystallineBarragemark",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"CrystallineBarrageCast","iCrystallineBarrage"},
						"announce","CrystallineBarragesay",
						--[["invoke", {
							{
								"alert","iCrystallineBarrage",
							},
							{
								"expect",{"&lfr&","==","false"},
								"announce","CrystallineBarragesay",
							},
						},--]]
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {162346},
				execute = {
					{
						"removeraidicon","#5#",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"quash","CrystallineBarrageCast",
					},					
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {162370},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iCrystallineBarrageUnder",
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {162370},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iCrystallineBarrageUnder",
					},
				},
			},	
			-- Mote of the Mountain
			--[[{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {162658},
				execute = {
					{
						-- icons...
					},				
				},
			},	--]]
			-----------------------
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","140562"}, -- Break Player Targetting
								"quash","EarthwarperCD",
								"quash","BerserkerCD",
								"scheduletimer",{"timerCheckBosses",1},
								--[["invoke",{
									{
										"expect",{"<Tectus>","==","2"},
										"tracing",{80551,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4","boss5"},
										--"set",{Tectus = 3},
									},
									{
										"expect",{"<Tectus>","==","1"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4"},
										"set",{Tectus = 2},
									},									
									{
										"expect",{"<Tectus>","==","0"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2"},
										"set",{Tectus = 1},
									},
								},--]]
							},						
						},
					},
					{
						"expect",{"#1#","==","boss2"},
						"invoke",{
							{
								"expect",{"#5#","==","140562"}, -- Break Player Targetting
								"quash","EarthwarperCD",
								"quash","BerserkerCD",
								"scheduletimer",{"timerCheckBosses",1},
								--[["invoke",{
									{
										"expect",{"<Tectus>","==","2"},
										"tracing",{80551,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4","boss5"},
										--"set",{Tectus = 3},
									},
									{
										"expect",{"<Tectus>","==","1"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4"},
										"set",{Tectus = 2},
									},									
									{
										"expect",{"<Tectus>","==","0"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2"},
										"set",{Tectus = 1},
									},
								},--]]
							},						
						},
					},
					{
						"expect",{"#1#","==","boss3"},
						"invoke",{
							{
								"expect",{"#5#","==","140562"}, -- Break Player Targetting
								"quash","EarthwarperCD",
								"quash","BerserkerCD",
								"scheduletimer",{"timerCheckBosses",1},
								--[["invoke",{
									{
										"expect",{"<Tectus>","==","2"},
										"tracing",{80551,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4","boss5"},
										--"set",{Tectus = 3},
									},
									{
										"expect",{"<Tectus>","==","1"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4"},
										"set",{Tectus = 2},
									},									
									{
										"expect",{"<Tectus>","==","0"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2"},
										"set",{Tectus = 1},
									},
								},--]]
							},							
						},
					},
					{
						"expect",{"#1#","==","boss4"},
						"invoke",{
							{
								"expect",{"#5#","==","140562"}, -- Break Player Targetting
								"quash","EarthwarperCD",
								"quash","BerserkerCD",
								"scheduletimer",{"timerCheckBosses",1},
								--[["invoke",{
									{
										"expect",{"<Tectus>","==","2"},
										"tracing",{80551,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4","boss5"},
										--"set",{Tectus = 3},
									},
									{
										"expect",{"<Tectus>","==","1"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4"},
										"set",{Tectus = 2},
									},									
									{
										"expect",{"<Tectus>","==","0"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2"},
										"set",{Tectus = 1},
									},
								},--]]
							},							
						},
					},	
					{
						"expect",{"#1#","==","boss5"},
						"invoke",{
							{
								"expect",{"#5#","==","140562"}, -- Break Player Targetting
								"quash","EarthwarperCD",
								"quash","BerserkerCD",
								"scheduletimer",{"timerCheckBosses",1},
								--[["invoke",{
									{
										"expect",{"<Tectus>","==","2"},
										"tracing",{80551,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4","boss5"},
										--"set",{Tectus = 3},
									},
									{
										"expect",{"<Tectus>","==","1"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2","boss3","boss4"},
										"set",{Tectus = 2},
									},									
									{
										"expect",{"<Tectus>","==","0"},
										"tracing",{80557,powers={true}},
										--"tracing",{"boss1","boss2"},
										"set",{Tectus = 1},
									},
								},--]]
							},							
						},
					},							
				},
			},
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","80599"}, --Spore Shooter
						"set",{EarthwarperAlive = "DECR|1"},
						"quash","GiftOfEarthCD",
						"quash","EarthenFlechettesCD",
						--"tabupdate",{"earthDuders","#1#","0"},
					},		
				},
			},
			{
				type = "event",
				event = "YELL", 
				execute = {
					-- Earthwarper
					{
						"expect",{"#2#","==",Earthwarper},
						"set",{EarthwarperAlive = "INCR|1"},
						"batchalert",{"iEarthwarper","EarthwarperCD"},
						"message","mEarthwarper",
						"alert",{"GiftOfEarthCD", time = 2},
						"invoke",{
							{
								"expect",{"&ismelee&","==","true"},
								"alert",{"EarthenFlechettesCD", time = 2},
							},
						},
						-- do icons?
					},
					-- Berserker
					{
						"expect",{"#2#","==",Berserker},
						"batchalert",{"BerserkerCD","wBerserker"},
					},		
					{
						"expect",{"#1#","find",L.chat_Highmaul["(RISE, MOUNTAINS!)"]},
						"alert","wEarthenPillar",
						--"dbmsync",{"TectusPillar"},
					},				
				},
			},
			--[[{
				type = "event",
				event = "CHAT_MSG_ADDON", 
				execute = {
					{
						"expect",{"#1#","==","D4"},
						--"set",{sync = "DBM  #2#"},
						"debug",{"&sync|DBM|#2#&"},
						--"debug",{"DBM DBM DBM DBM DBM DBM DBM DBM DBM DBM"},
						"invoke",{
							{
								"expect",{"&sync|DBM|#2#&","==","TectusPillar"},
								"expect",{"<dbm>","==","0"},
								"alert","wEarthenPillar",
								"set",{dbm = "1"},
								"scheduletimer",{"timerDBM",6},
								
							},
						},
					},					
				},
			},--]]
		},
	}

	DXE:RegisterEncounter(data)
end