local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
local EJName = EJ_GetEncounterInfo(971)
do
	local data = {
		version = 2,
		key = "TheButcher",
		zone = L.zone["Highmaul"],
		category = L.zone["Highmaul"],
		--name = L.npc_Highmaul["The Butcher"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-The Butcher.BLP:35:35",
		triggers = {
			scan = {77404}, 
			encounterid = {1706},
			ejid = {971},
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {77404,powers={true,}},
			unittracing = {	"boss1",},
			defeat = 77404,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 300,
			timeflex = 300,
			timeheroic = 300,
			timemythic = 240,
		},
		userdata = {
			cleaveCount = 0,
			boundingCleave = 0,
			isFrenzied = 0,
			bossPower = 0,
			bossPowerP = 0,
		},		
		messages = {
			mTenderizer = {
				varname = format(L.alert["%s %s %s"],SN[156151],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (1)"],SN[156151],L.alert["on"]),
				text2 = format(L.alert["%s %s #5# (#11#)"],SN[156151],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 156151,
				icon = ST[156151],
			},
			mFrenzy = {
				varname = format(L.alert["%s %s %s"],SN[156598],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[156598],L.alert["on"]),
				color1 = "PURPLE",
				sound = "ALERT13",
				desc = 156598,
				icon = ST[156598],
			},
			mBoundingCleave = {
				varname = format(L.alert["%s (2)"],SN[156598]),
				type = "message",
				text = format(L.alert["%s (<boundingCleave>)"],SN[156598]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 156598,
				icon = ST[156598],
			},
			mCleave = {
				varname = format(L.alert["%s (2)"],SN[156157]),
				type = "message",
				text = format(L.alert["%s (<cleaveCount>)"],SN[156157]),
				color1 = "RED",
				icon = ST[156157],
				sound = "ALERT13",
				desc = 156157,
			},			
		},
		onstart = {
			{
				"alert",{"TenderizerCD", time = 2},
				"alert",{"CleaveCD", time = 2},
				"alert",{"CleaverCD", time = 2},
				"alert","BoundingCleaveCD",
			},
		},
		alerts = {
			CleaveCD = {
				varname = format(L.alert["%s Cooldown"],SN[156157]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156157]),
				time = 6,
				time2 = 10,
				time3 = 5,
				time4 = 11,
				color1 = "MIDBLUE",
				icon = ST[156157],
				desc = 156157,	
				enabled = false,
			},	
			TenderizerCD = {
				varname = format(L.alert["%s Cooldown"],SN[156151]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156151]),
				time = 17,
				time2 = 7,
				time3 = 15,
				color1 = "MIDBLUE",
				icon = ST[156151],
				desc = 156151,	
				--exhealer = true,
				exdps = true,
			},	
			CleaverCD = {
				varname = format(L.alert["%s Cooldown"],SN[156143]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156143]),
				time = 9,
				time2 = 12,
				time3 = 21,
				color1 = "MIDBLUE",
				icon = ST[156143],
				desc = 156143,	
				exhealer = true,
				exdps = true,				
			},	
			BoundingCleaveCD = {
				varname = format(L.alert["%s Cooldown"],SN[156160]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156160]),
				time = 60,
				time2 = 91,
				time3 = 30,
				color1 = "MIDBLUE",
				icon = ST[156160],
				desc = 156160,	
				audiocd = true,
				audiotime = 10,				
			},	
			-- Warning
			wCleaver = {
				varname = format(L.alert["%s!"],SN[156143]),
				type = "simple",
				text = format(L.alert["%s!"],SN[156143]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[156143],
				sound = "ALERT10",
				desc = 156143,
				exhealer = true,
				exdps = true,
			},
			wBoundingCleaveEnded = {
				varname = format(L.alert["%s %s!"],SN[156172],L.alert["Over"]),
				type = "simple",
				text = format(L.alert["%s %s!"],SN[156172],L.alert["Over"]),
				time = 2,
				color1 = "GREEN",
				icon = ST[156172],
				sound = "ALERT13",
				desc = 156172,
			},				
			-- Inform
			iGushingWounds = {
				varname = format(L.alert["%s: %s 2 %s!"],SN[156152],L.alert["already at"],L.alert["Stacks"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s!"],SN[156152],L.alert["already at"],L.alert["Stacks"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT14",
				icon = ST[156152],
				desc = 156152,
				flashscreen = true,
			},
			iTenderizer = {
				varname = format(L.alert["%s: %s 4 %s!"],SN[156151],L.alert["already at"],L.alert["Stacks"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s!"],SN[156151],L.alert["already at"],L.alert["Stacks"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT14",
				icon = ST[163241],
				desc = 163241,
				flashscreen = true,
				exdps = true,
				exhealer = true,				
			},
			iTenderizerTaunt = {
				varname =  format(L.alert["%s - %s!"],SN[156151],L.alert["Taunt"]),
				type = "inform",
				text = format(L.alert["%s - %s!"],SN[156151],L.alert["Taunt"]),
				time = 2,
				color1 = "GREEN",
				sound = "ALERT10",
				icon = ST[156151],
				desc = 156151,
				exdps = true,
				exhealer = true,
				flashscreen = true,
			},
			iPaleVitriolUnder = {
				varname = format(L.alert["%s %s, %s!"],SN[163046],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[163046],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[163046],
				sound = "ALERT10",
				desc = 163046,
				throttle = 3,
			},	
			-- Casts
			BoundingCleaveCast = {
				varname = format(L.alert["%s Active"],SN[156160]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[156160]),
				time = 15,
				time2 = "<bossPowerP>",
				color1 = "MIDBLUE",
				icon = ST[156160],
				desc = 156160,
			},			
			-- Debuff
			GushingWoundsDebuff = {
				varname = format(L.alert["%s Debuff"],SN[156152]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[156152]),
				text2 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[156152]),
				time = 15,
				color1 = "PURPLE",
				desc = 156152,
				icon = ST[156152],
				tag = "#5#",			
			},	
			TenderizerDebuff = {
				varname = format(L.alert["%s Debuff"],SN[156151]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[156151]),
				text2 = format(L.alert["#5# (1): %s"],SN[156151]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[156151]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[156151]),
				time = 40,
				color1 = "RED",
				desc = 156151,
				icon = ST[156151],
				tag = "#5#",
				exdps = true,				
			},			
		},
		events = {
			-- Cleave
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156157,156293},
				execute = {
					{
						"set",{cleaveCount = "INCR|1"},
						--"alert","CleaveCD",
						"message","mCleave",
					},
					{
						"expect",{"<isFrenzied>","==","1"},
						"alert",{"CleaveCD", time = 3},
					},
					{
						"expect",{"<isFrenzied>","~=","1"},
						"alert","CleaveCD",
					},
				},
			},
			-- GushingWounds
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156152},
				dstisplayerunit = true,
				execute = {
					{
						"alert","GushingWoundsDebuff",
					},						
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {156152},
				dstisplayerunit = true,
				execute = {
					{
						"alert",{"GushingWoundsDebuff", text = 2},
						"alert","iGushingWounds",
					},	
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {156152},
				dstisplayerunit = true,
				execute = {
					{
						"quash","GushingWoundsDebuff",
					},						
				},
			},			
			-- Tenderizer
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156151},
				execute = {
					{
						"message","mTenderizer",
						"alert","TenderizerCD",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","TenderizerDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"TenderizerDebuff", text = 2},
					},								
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {156151},
				execute = {
					{
						"message",{"mTenderizer", text = 2},
						"alert","TenderizerCD",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"TenderizerDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"TenderizerDebuff", text = 4},
					},		
					{
						"expect",{"#11#",">=","2"},
						"invoke", {
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","iTenderizer",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"expect",{"&playerdebuff|"..SN[156151].."&","==","false"},
								"alert","iTenderizerTaunt",
							},
						},
					},
				},
			},
			-- Frenzy
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156598},
				execute = {
					{
						"set",{isFrenzied = "1"},
						"message","mFrenzy",
					},						
				},
			},
			-- Cleaver
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {156143},
				execute = {
					{
						"batchalert",{"CleaverCD","wCleaver"},
					},						
				},
			},
			-- BoundingCleaveEnded
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {156172},
				execute = {
					{
						"alert","wBoundingCleaveEnded",
					},
					{
						"expect",{"<isFrenzied>","==","1"},
						"alert",{"CleaveCD", time = 3},
					},
					{
						"expect",{"<isFrenzied>","~=","1"},
						"alert",{"CleaveCD", time = 4},
					},
					{
						"set",{bossPower = "&getup|boss1&"},
						"set",{bossPowerP = "MULT|3.33"},
						"alert",{"BoundingCleaveCast", time = 2},
					},					
				},
			},
			-- adds spawn (Mythic)
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {163051},
				execute = {
					{
						
					},				
				},
			},			
			-- PaleVitriol (Mythic)
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {163046},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iPaleVitriolUnder",
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_ABSORBED",
				spellid = {163046},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iPaleVitriolUnder",
					},
				},
			},	
			--------------------------
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","156197"}, -- BoundingCleave
								"set",{cleaveCount = "0"},
								"set",{boundingCleave = "INCR|1"},
								"quash","CleaveCD",
								"message","mBoundingCleave",
								"alert",{"TenderizerCD", time = 3},
								"alert",{"CleaverCD", time = 3},
								"invoke",{
									{
										"expect",{"<isFrenzied>","==","1"},
										"alert",{"BoundingCleaveCD", time = 3},
										"schedulealert",{"BoundingCleaveCast",5},
									},
									{
										"expect",{"<isFrenzied>","~=","1"},
										"alert","BoundingCleaveCD",
										"schedulealert",{"BoundingCleaveCast",9},
									},									
								},
							},
							{
								"expect",{"#5#","==","156257"}, -- BoundingCleave
								"set",{cleaveCount = "0"},
								"set",{boundingCleave = "INCR|1"},
								"quash","CleaveCD",
								"message","mBoundingCleave",
								"alert",{"TenderizerCD", time = 3},
								"alert",{"CleaverCD", time = 3},
								"invoke",{
									{
										"expect",{"<isFrenzied>","==","1"},
										"alert",{"BoundingCleaveCD", time = 3},
										"schedulealert",{"BoundingCleaveCast",5},
									},
									{
										"expect",{"<isFrenzied>","~=","1"},
										"alert","BoundingCleaveCD",
										"schedulealert",{"BoundingCleaveCast",9},
									},									
								},
							},							
						},
					},
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end