local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

-- Oro
do
	local data = {
		version = 1,
		key = "highmaultrash",
		zone = L.zone["Highmaul"],
		category = L.zone["Highmaul"],
		name = L.npc_Highmaul["Trash: Oro"],
		triggers = {
			scan = {86072}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {86072},
			defeat = {86072},
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},	
		announces = { 
			RadiatingPoisonsay = {
				varname = format(L.alert["%s %s %s!"],SN[172066],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[172066],L.alert["on"],L.alert["Me"]),
				desc = 172066,
				icon = ST[172066],
			},				
		},		
		messages = {
			mRadiatingPoison = {
				varname = format(L.alert["%s %s %s"],SN[172066],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[172066],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 172066,
				icon = ST[172066],
			},
		},
		onstart = {
			{

			},
		},
		alerts = {
			-- Debuff
			RadiatingPoisonDebuff = {
				varname = format(L.alert["%s Debuff"],SN[172066]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[172066]),
				text2 = format(L.alert["#5#: %s"],SN[172066]),
				time = 40,
				color1 = "PURPLE",
				desc = 172066,
				icon = ST[172066],
				tag = "#5#",			
			},	
		},
		events = {
			-- RadiatingPoison
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {172066},
				execute = {
					{
						"message","mRadiatingPoison",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"RadiatingPoisonDebuff", text = 2},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","RadiatingPoisonDebuff",
						"announce","RadiatingPoisonsay",
						"openwindow",{"10"},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {172066},
				execute = {
					{
						"quash","RadiatingPoisonDebuff",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"closewindow",
					},					
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


-- Gorian Runemaster
do
	local data = {
		version = 1,
		key = "highmaultrash2",
		zone = L.zone["Highmaul"],
		category = L.zone["Highmaul"],
		name = L.npc_Highmaul["Trash: Gorian Runemaster"],
		triggers = {
			scan = {81272}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {81272},
			defeat = {81272},
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},	
		announces = { 
			RuneOfDestructionsay = {
				varname = format(L.alert["%s %s %s!"],SN[175636],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[175636],L.alert["on"],L.alert["Me"]),
				desc = 175636,
				icon = ST[175636],
			},				
		},		
		messages = {
			mRuneOfDestruction = {
				varname = format(L.alert["%s %s %s"],SN[175636],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[175636],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 175636,
				icon = ST[175636],
			},
		},
		onstart = {
			{

			},
		},
		alerts = {
			iRuneOfDisintegrationAway = {
				varname = format(L.alert["%s %s, %s!"],SN[175654],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[175654],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[175654],
				sound = "ALERT10",
				desc = 175654,
				flashscreen = true,
				throttle = 1,
			},
			-- Debuff
			RuneOfDestructionDebuff = {
				varname = format(L.alert["%s Debuff"],SN[175636]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[175636]),
				text2 = format(L.alert["#5#: %s"],SN[175636]),
				time = 15,
				color1 = "PURPLE",
				desc = 175636,
				icon = ST[175636],
				tag = "#5#",			
			},	
		},
		events = {
			-- RuneOfDestruction
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {175636},
				execute = {
					{
						"message","mRuneOfDestruction",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"RuneOfDestructionDebuff", text = 2},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","RuneOfDestructionDebuff",
						"announce","RuneOfDestructionsay",
						"openwindow",{"6"},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {175636},
				execute = {
					{
						"quash","RuneOfDestructionDebuff",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"closewindow",
					},					
				},
			},
			-- RuneOfDisintegration
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {175654},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRuneOfDisintegrationAway",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {175654},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRuneOfDisintegrationAway",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {175654},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRuneOfDisintegrationAway",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


--  Gorian Arcanist
do
	local data = {
		version = 2,
		key = "highmaultrash3",
		zone = L.zone["Highmaul"],
		category = L.zone["Highmaul"],
		name = L.npc_Highmaul["Trash: Gorian Arcanist"],
		triggers = {
			scan = {82528}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {82528},
			defeat = {82528},
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
			ArcaneVolatilityunists = {type = "container", wipein = 3},
		},	
		announces = { 
			ArcaneVolatilitysay = {
				varname = format(L.alert["%s %s %s!"],SN[166200],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[166200],L.alert["on"],L.alert["Me"]),
				desc = 166200,
				icon = ST[166200],
			},				
		},	
		timers = {
			timerArcaneVolatility = {
				{
					"message","mArcaneVolatility",
				},
			},	
		},
		messages = {
			mArcaneVolatility = {
				varname = format(L.alert["%s %s %s"],SN[166200],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|ArcaneVolatilityunists&"],SN[166200],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 166200,
				icon = ST[166200],
			},
		},
		onstart = {
			{

			},
		},
		alerts = {

		},
		events = {
			-- ArcaneVolatility
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {166200},
				execute = {
					{
						--"message","mArcaneVolatility",
						"insert",{"ArcaneVolatilityunists","#5#"},
						"canceltimer","timerArcaneVolatility",
						"scheduletimer",{"timerArcaneVolatility",0.5},						
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","ArcaneVolatilitysay",
						"openwindow",{"8"},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {166200},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"closewindow",
					},					
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


--  Breaker Ritualist
do
	local data = {
		version = 1,
		key = "highmaultrash4",
		zone = L.zone["Highmaul"],
		category = L.zone["Highmaul"],
		name = L.npc_Highmaul["Trash: Breaker Ritualist"],
		triggers = {
			scan = {86326, 86329}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {86326, 86329},
			defeat = {86326, 86329},
		},
		windows = {
			proxwindow = true,
		},
		userdata = {
		},	
		announces = { 
			FrozenCoresay = {
				varname = format(L.alert["%s %s %s!"],SN[174404],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[174404],L.alert["on"],L.alert["Me"]),
				desc = 174404,
				icon = ST[174404],
			},				
		},		
		messages = {
			mFrozenCore = {
				varname = format(L.alert["%s %s %s"],SN[174404],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[174404],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 174404,
				icon = ST[174404],
			},
		},
		onstart = {
			{

			},
		},
		alerts = {
			iWildFlamesAway = {
				varname = format(L.alert["%s %s, %s!"],SN[173827],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[173827],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[173827],
				sound = "ALERT10",
				desc = 173827,
				flashscreen = true,
				throttle = 1,
			},
			-- Debuff
			FrozenCoreDebuff = {
				varname = format(L.alert["%s Debuff"],SN[174404]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[174404]),
				text2 = format(L.alert["#5#: %s"],SN[174404]),
				time = 20,
				color1 = "PURPLE",
				desc = 174404,
				icon = ST[174404],
				tag = "#5#",			
			},	
		},
		events = {
			-- FrozenCore
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {174404},
				execute = {
					{
						"message","mFrozenCore",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","FrozenCoreDebuff",
						"announce","FrozenCoresay",
						"openwindow",{"8"},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"FrozenCoreDebuff", text = 2},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {174404},
				execute = {
					{
						"quash","FrozenCoreDebuff",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"closewindow",
					},					
				},
			},
			-- WildFlamesAway
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {173827},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iWildFlamesAway",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {173827},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iWildFlamesAway",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {173827},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iWildFlamesAway",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end