local addon
local module = CreateFrame("Frame")
local L = LibStub("AceLocale-3.0"):GetLocale("DXE")

local CORE_ADDON = "DXE"
local Z_MODS = {} -- Zone modules
local Z_MODS_LIST = {}
local ID_MODS = {} -- ID modules
local ID_MODS_LIST = {}
local BossMods = {}
local B_MODS = {} -- Boot modules
local WORLD_MODS = {} -- WORLD modules
local WORLD_MODS_LIST = {}
local WORLDZONE_MODS = {} -- WORLD modules
local WORLDZONE_MODS_LIST = {}
local saved_command  

module.Z_MODS_LIST = Z_MODS_LIST
module.ID_MODS_LIST = ID_MODS_LIST
module.WORLD_MODS_LIST = WORLD_MODS_LIST
module.WORLDZONE_MODS_LIST = WORLDZONE_MODS_LIST

--[[local function GetAddOnIndex(name)
	for i=1, GetNumAddOns() do
		if GetAddOnInfo(i) == name then
			return i
		end
	end
end--]]
function module:LoaderBreak(seconds, text)
	--print("sadfsdfsdf",time(),seconds, PREFIX,text)
	DXEDB.breakTime = {time(),seconds, text}
end
function module:Load(name)
	--if type(name) == "string" then name = GetAddOnIndex(name) end
	if not select(4,GetAddOnInfo(name)) then EnableAddOn(name) end 
	LoadAddOn(name) 
end

function module:CleanZoneModules(name)
	for zone,list in pairs(Z_MODS) do
		for k in pairs(list) do
			if k == name then Z_MODS[zone][name] = nil break end
		end
		Z_MODS[zone] = next(Z_MODS[zone]) and Z_MODS[zone]
	end
	Z_MODS = next(Z_MODS) and Z_MODS
	Z_MODS_LIST[name] = nil
	if not Z_MODS then 
		self:UnregisterEvent("ZONE_CHANGED_NEW_AREA")
		self.CleanZoneModules, self.ZONE_CHANGED_NEW_AREA = nil,nil 
	end
end--[[
function module:CleanIDModules(name)
	for zone,list in pairs (ID_MODS) do
		for k in pairs(list) do
			if k == name then ID_MODS[zone][name] = nil break end
		end
		ID_MODS[zone] = next(ID_MODS[zone]) and ID_MODS[zone]
	end
	ID_MODS = next(ID_MODS) and ID_MODS
	ID_MODS_LIST[name] = nil
	if not ID_MODS then 
		self:UnregisterEvent("ZONE_CHANGED_NEW_AREA")
		self.CleanIDModules, self.ZONE_CHANGED_NEW_AREA = nil,nil 
	end
end--]]
function module:ZONE_CHANGED_NEW_AREA()
	--local inside = IsInInstance()
	local zoneid
	if not IsInInstance() and WorldMapFrame:IsShown() then
		local prevId = GetCurrentMapAreaID()
		SetMapToCurrentZone()
		zoneid = GetCurrentMapAreaID()
		SetMapByID(prevId)
	else
		SetMapToCurrentZone()
		zoneid = GetCurrentMapAreaID()
	end
	--SetMapToCurrentZone()
	--local zoneid = GetCurrentMapAreaID()
	--module:UnregisterEvent("UNIT_TARGET")
	if addon ~= nil then
		if GetNumGroupMembers() == 0 then
			addon:SetActiveEncounter("default")
		end
	end
	local zone = GetRealZoneText()
	if not zone or zone == "" then return end
	--print("teste",zone,zoneid)
	if Z_MODS[zone] then for name in pairs(Z_MODS[zone]) do self:Load(name) end
	elseif ID_MODS[zoneid] then
		for name, data in pairs(ID_MODS[zoneid]) do
			--print("DSFDS",ID_MODS[zoneid],data,data.name)
			self:Load(data.name)
		end
	elseif WORLDZONE_MODS[zoneid] then
		--print("DSFDS")
		module:RegisterEvent("UNIT_TARGET")
	end
end

function module:ADDON_LOADED(name)
	if name == "DXE_Loader" then
		self:SetupBroker()
	elseif name == CORE_ADDON then
		addon = DXE
		addon.Loader = module
		for name in pairs(B_MODS) do self:Load(name) end
		B_MODS = nil
		if saved_command then
			DXE_SLASH_HANDLER(saved_command)
			saved_command = nil
		end
	end
	local zmeta = GetAddOnMetadata(name,"X-DXE-Zone")
	local raidname
	if Z_MODS_LIST[name] then
		self:CleanZoneModules(name)
		addon.callbacks:Fire("OnLoadZoneModule")
		if zmeta then raidname = zmeta
		else raidname = name end
	end
	--[[if ID_MODS_LIST[name] then
		--self:CleanIDModules(name)
		self:CleanZoneModules(name)
		addon.callbacks:Fire("OnLoadZoneModule")
		if zmeta then raidname = zmeta
		else raidname = name end
	else
		if Z_MODS_LIST[name] then
			self:CleanZoneModules(name)
			--self:CleanIDModules(name)
			addon.callbacks:Fire("OnLoadZoneModule")
			if zmeta then raidname = zmeta
			else raidname = name end
		end
	end--]]
	if raidname then print("|cff99ff33DXE|r: Loaded|cff99ff33",raidname) end
	if not B_MODS and not Z_MODS and not ID_MODS and not WORLD_MODS and not WORLDZONE_MODS then self:UnregisterEvent("ADDON_LOADED"); self.ADDON_LOADED = nil end
end

local function AddZoneModule(name,zone,...)
	if not zone then return end
	zone = L.zone[zone:trim()]
	Z_MODS[zone] = Z_MODS[zone] or {}
	Z_MODS[zone][name] = true
	return AddZoneModule(name,...)
end

function module:PLAYER_LOGIN()
	self:UnregisterEvent("PLAYER_LOGIN")
	--local corename = GetAddOnIndex(CORE_ADDON)
	if select(6,GetAddOnInfo(CORE_ADDON)) == "MISSING" then error(("DXE requires %s to be installed"):format(CORE_ADDON)) end

	for i=1,GetNumAddOns() do
		local name = GetAddOnInfo(i)
		if IsAddOnLoadOnDemand(name) and not IsAddOnLoaded(name) then
			-- Backwards Compability
			local zmeta = GetAddOnMetadata(i,"X-DXE-Zone")
			local bmeta = GetAddOnMetadata(i,"X-DXE-Boot")
			if zmeta then
				local cmeta = GetAddOnMetadata(i,"X-DXE-Category")
				Z_MODS_LIST[name] = L.zone[cmeta or zmeta]
				AddZoneModule(name,strsplit(",",zmeta))
			elseif tonumber(bmeta) == 1 then
				B_MODS[name] = true
			end
			
			---------New Loader--------------------
			if GetAddOnMetadata(i, "X-DXE-LoadWithZone") then
				local zones = {strsplit(",", GetAddOnMetadata(i, "X-DXE-LoadWithZone") or "")}
				for i, zone in pairs(zones) do
					local zoneNumber = tonumber(zone)
					if not zoneNumber then zoneNumber = zone end
					ID_MODS_LIST[name] = name
					ID_MODS[zoneNumber] = ID_MODS[zoneNumber] or {}
					ID_MODS[zoneNumber][name] = {
						name = name,
					}				
					--ID_MODS[zoneNumber] = true
					--print("x-Dxe1",zmeta,zoneNumber,ID_MODS_LIST[name])
				end
			end
			if GetAddOnMetadata(i, "X-DXE-LoadWorldBoss") then
				local worldboss = {strsplit(",", GetAddOnMetadata(i, "X-DXE-LoadWorldBoss") or "")}
				for a, worldboss in pairs(worldboss) do
					local worldbossNumber = tonumber(worldboss)
					if not worldbossNumber then worldbossNumber = worldboss end
					WORLD_MODS_LIST[name] = name
					WORLD_MODS[worldbossNumber] = WORLD_MODS[worldbossNumber] or {}
					WORLD_MODS[worldbossNumber][name] = {
						name = name,
					}				
					--ID_MODS[worldbossNumber] = true
					--print("x-Dxe",zmeta,worldbossNumber,WORLD_MODS[name])
				end
			end
			if GetAddOnMetadata(i, "X-DXE-LoadWorldBossZones") then
				local worldbosszone = {strsplit(",", GetAddOnMetadata(i, "X-DXE-LoadWorldBossZones") or "")}
				for b, worldbosszone in pairs(worldbosszone) do
					local worldbossNumberZone = tonumber(worldbosszone)
					if not worldbossNumberZone then worldbossNumberZone = worldbosszone end
					--print("x-Dxe1",worldbossNumberZone)
					WORLDZONE_MODS_LIST[name] = name
					WORLDZONE_MODS[worldbossNumberZone] = WORLDZONE_MODS[worldbossNumberZone] or {}
					WORLDZONE_MODS[worldbossNumberZone][name] = {
						name = name,
					}
				end
			end
		end
	end
	if next(Z_MODS) or next(ID_MODS) or next(WORLD_MODS) or next(WORLDZONE_MODS_LIST) then self:RegisterEvent("ZONE_CHANGED_NEW_AREA") end
	self:ZONE_CHANGED_NEW_AREA()
	DXEDB = DXEDB or {}

	-- Break timer restoration, thanks BigWigs
	local tbl = DXEDB.breakTime
	if tbl then -- Break time present, resume it
		local prevTime, seconds, text = tbl[1], tbl[2], tbl[3], tbl[4]
		local curTime = time()
		if curTime-prevTime > seconds then
			DXEDB.breakTime = nil
		else
			module:Load(CORE_ADDON)
		end
	end
		
	self.PLAYER_LOGIN = nil
end

function module:SetupBroker()
	local LDB = LibStub("LibDataBroker-1.1",true)
	if not LDB then return end

	local function refresh()
		-- Refreshes Text
		if GameTooltipTextLeft2:GetText() == L.loader["|cffffff00Click|r to load"] then
			GameTooltip:ClearLines()
			GameTooltip:AddLine(L.loader["Deus Vox Encounters"])
			GameTooltip:AddLine(L.loader["|cffffff00Click|r to toggle the settings window"],1,1,1)
			GameTooltip:Show()
		end
	end

	local launcher = LDB:NewDataObject("DXE", {
		type = "launcher",
		icon = "Interface\\Addons\\DXE_Loader\\Icon",
		OnClick = function(_, button)
			if addon then
				addon:ToggleConfig() 
			else
				module:Load(CORE_ADDON)
				refresh(); refresh = nil
			end
		end,
		OnTooltipShow = function(tooltip)
			if addon then
				tooltip:AddLine(L.loader["Deus Vox Encounters"])
				tooltip:AddLine(L.loader["|cffffff00Click|r to toggle the settings window"],1,1,1)
			else
				tooltip:AddLine(L.loader["Deus Vox Encounters"])
				tooltip:AddLine(L.loader["|cffffff00Click|r to load"],1,1,1)
			end
		end,
	})

	local LDBIcon = LibStub("LibDBIcon-1.0",true)
	if not LDBIcon then return end
	DXEIconDB = DXEIconDB or {}
	LDBIcon:Register("DXE",launcher,DXEIconDB)

	self.SetupBroker = nil
end

SLASH_DXE1 = "/dxe"
function DXE_SLASH_HANDLER(msg)
	if not addon then
		saved_command = msg
		module:Load(CORE_ADDON)
	end
end
SlashCmdList.DXE = function(msg) DXE_SLASH_HANDLER(msg) end


	--[[
---------------------- Break Timer ----------------------------	

	local ID_PREFIX3 = "dxebreak"
	local DROPDOWN_THRES3 = 15
	local COMMTYPE3 = "AlertsRaidBarBreak"

	function fireBreak(text,time,color,icon,audiotime)
		local id = ID_PREFIX3--ID_PREFIX..text
		module:QuashByPattern(id)
		if time > DROPDOWN_THRES3 then
			module:Dropdown(id,text,time,DROPDOWN_THRES3,pfl.BreakSound,color,nil,nil,icon,true)
		else
			module:CenterPopup(id,text,time,nil,pfl.BreakSound,color,nil,nil,icon,true)
		end
	end

	local function parsebreak(msg,slash)
		if type(msg) ~= "string" then addon:Print(format(FORMAT_ERROR,slash)) return end
		local time,text = msg:match(MSG_PTN)
		if not time then
			time = msg:match(MSG_PTN2)
			if not time then
				addon:Print(format(FORMAT_ERROR,slash)) 
				return
			end
		end
		if not text then text = L.alert["Break"] end
		local secs = tonumber(time)
		if not secs then
			local m,s = time:trim():match(TIME_PTN)
			if m then secs = (tonumber(m)*60) + tonumber(s)
			else addon:Print(TIME_ERROR) return end
		end
		return true,secs,replace(text)
	end

	local function LocalBarHandler3(msg)
		local success,time,text = parsebreak(msg,"/lbreak")
		if success then fireBreak(YOU_PREFIX..text,time + 1,pfl.BreakLocalClr,L_ICON) end
	end

	local function RaidBarHandler3(msg)
		if UnitIsGroupAssistant("player") or UnitIsGroupLeader("player") then
			local success,time,text = parsebreak(msg,"/break")
			if success then
				fireBreak(YOU_PREFIX..text,time + 1,pfl.BreakRaidClr,R_ICON)
				addon:SendRaidComm(COMMTYPE3,time,UnitName("player")..": "..text)
				--SendAddonMessage("D4", "BT\t".. time, IsInGroup(2) and "INSTANCE_CHAT" or "RAID")
				local _, _, _, _, _, _, _, mapID = GetInstanceInfo()
				--SendAddonMessage("D4", ("BT\t%s\t%d"):format(time, mapID or 0), IsInGroup(2) and "INSTANCE_CHAT" or "RAID")
				SendAddonMessage("D4", ("BT\t%d"):format(time), IsInGroup(2) and "INSTANCE_CHAT" or "RAID") -- DBM message
				DXEDB.breakTime = {time(), time, YOU_PREFIX, false}
			end
		else
			addon:Print(OFFICER_ERROR)
		end
	end	

	module["OnComm"..COMMTYPE3] = function(self,event,commType,sender,time,text)
		--if not UnitIsGroupAssistant(sender) then return end --UnitIsRaidOfficer
		if UnitIsGroupAssistant("player") or UnitIsGroupLeader("player") then
			fireBreak(text,time,pfl.BreakRaidClr,R_ICON)
			DXEDB.breakTime = {time(), time, sender, false}
		end
	end
	addon.RegisterCallback(module,"OnComm"..COMMTYPE3)
	
	SlashCmdList.DXEALERTLBREAK = LocalBarHandler3
	SlashCmdList.DXEALERTRAIDBREAK = RaidBarHandler3
	SLASH_DXEALERTLBREAK1 = "/lbreak"
	SLASH_DXEALERTRAIDBREAK1 = "/break"	
--]]
---------------------------------------------------------------
function module:UNIT_TARGET(unit)
	local guid = UnitGUID(unit.."target")
	
	--if IsInInstance() or not UnitIsFriend("player", guid) and UnitIsDead("player") or UnitIsDead(guid) then 
	--	module:UnregisterEvent("UNIT_TARGET")
	--	return 
	--end
		-- helper
	local function add_data(tbl,info,key)
		if type(info) == "table" then
			-- Info contains ids
			for _,id in ipairs(info) do
				tbl[id] = key
			end
		else
			-- Info is the id
			tbl[info] = key
		end
	end
	
	if guid then
		local _, _, _, _, _, id = strsplit("-", guid)
		local mobId = tonumber(id)

		if mobId and WORLD_MODS[mobId] then
			for i, data in pairs(WORLD_MODS[mobId]) do
				--print("DSFDS",WORLD_MODS[mobId])
				self:Load(data.name)
			end
			--if InCombatLockdown() or UnitAffectingCombat("player") then
			
			--else
			if not addon:IsRunning() then
				local EDBids = {}
				for key, data in addon:IterateEDB() do
					if data.triggers then
						local scan = data.triggers.scan
						if scan then
							--print("scan2",scan)
							add_data(EDBids,scan,key)
						end
					end
				end
				
				--print("EDBids",EDBids[mobId])
				--local playertargetid = NID[UnitGUID("playertarget")]
				if EDBids[mobId] then
					local key = EDBids[mobId]	
					--print("EDBidsinside",key)				
					addon:SetActiveEncounter(key)
				--	addon:StopEncounter()
				--	addon:StartEncounter()
				--	return true
				end
				if InCombatLockdown() or UnitAffectingCombat("player") then
						addon:StopEncounter()
						addon:StartEncounter()
				end
			end
		end
	end

	
end

module:SetScript("OnEvent",function(self,event,...) self[event](self,...) end)
module:RegisterEvent("PLAYER_LOGIN")
module:RegisterEvent("ADDON_LOADED")
--module:RegisterEvent("UNIT_TARGET")
--module:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
--module:RegisterEvent("PLAYER_TARGET_CHANGED")
