local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 2,
		key = "Azzakel",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["Auchindoun: Azzakel"],
		triggers = {
			scan = {75927}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1",},
			unittracing = {	"boss1",},
			defeat = 75927,
		},
		userdata = {
			lastplayer = "",
			flamesCast = 2,
		},	
		timers = {	
			timerCurtainOfFlame = {
				{
					"expect",{"&inrange|<lastplayer>&","<","6"},
					"arrow","CurtainOfFlamearrow",
				},
			},
		},
		arrows = {
			CurtainOfFlamearrow = {
				varname = SN[153392],
				unit = "<lastplayer>",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[153392],
				range1 = 6,
				range2 = 7,
				range3 = 8,
				desc = 153392,
				icon = ST[153392],
			},
		},
		raidicons = {
			CurtainOfFlamemark = {
				varname = SN[153392],
				type = "FRIENDLY",
				persist = 120,
				unit = "#5#",
				icon = 1,
				desc = 153392,
				icon2 = ST[153392],
			},
		},
		announces = { 
			CurtainOfFlamesay = {
				varname = format(L.alert["%s %s %s!"],SN[153396],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[153396],L.alert["on"],L.alert["Me"]),
				desc = 153396,
			},			
		},	
		messages = {
			mCurtainOfFlame = {
				varname = format(L.alert["%s %s %s"],SN[153392],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[153392],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 153392,
				icon = ST[153392],
			},
			mFelLash = {
				varname = format(L.alert["%s %s %s"],SN[153234],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[153234],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 153234,
				icon = ST[153234],
				exdps = true,
			},
			mSummonFelguard = {
				varname = format(L.alert["%s!"],SN[153234]),
				type = "message",
				text = format(L.alert["%s!"],SN[153234]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 153234,
				icon = ST[153234],
			},						
		},
		onstart = {
			{
				"alert",{"CurtainOfFlameCD", time = 2},
				"alert",{"ClawsOfArgusCD", time = 2},
			},
		},
		alerts = {
			CurtainOfFlameCD = {
				varname = format(L.alert["%s Cooldown"],SN[153396]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[153396]),
				time = 20,
				time2 = 16,
				time3 = 7,
				color1 = "NEWBLUE",
				icon = ST[153396],
				desc = 153396,
				audiocd = true,
				audiotime = 5,				
			},
			ClawsOfArgusCD = {
				varname = format(L.alert["%s Cooldown"],SN[153764]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[153764]),
				time = 70,
				time2 = 34,
				color1 = "NEWBLUE",
				icon = ST[153764],
				desc = 153764,
				audiocd = true,
				audiotime = 10,
			},
			-- Alert
			wClawsOfArgus = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[153764]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[153764]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[153764],
				sound = "ALERT2",
				desc = 153764,
			},	
			wFelPool = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[153500]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[153500]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[153500],
				sound = "ALERT10",
				desc = 153500,
			},
			wFelStomp = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[157173]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[157173]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[157173],
				sound = "ALERT10",
				desc = 157173,
				exdps = true,
				exhealer = true,
			},
			wFelblast = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[154221]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[154221]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[154221],
				sound = "ALERT10",
				desc = 154221,
				exdps = true,
				extank = true,
			},			
			-- Inform	
			iFelblast = {
				varname = format(L.alert["%s - %s!!!"],SN[154221],L.alert["INTERRUPT"]),
				type = "inform",
				text = format(L.alert["%s - %s!!!"],SN[154221],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[154221],
				desc = 154221,
				exhealer = true,
				extank = true,
			},			
			iFelStomp = {
				varname = format(L.alert["%s, %s!"],SN[157173],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s, %s!"],SN[157173],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[157173],
				sound = "ALERT10",
				desc = 157173,
			},				
			iFelLashself = {
				varname = format(L.alert["%s %s %s!"],SN[153234],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[153234],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[153234],
				desc = 153234,
			},
			iFelPoolUnder = {
				varname = format(L.alert["%s %s, %s!"],SN[153616],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[153616],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[153616],
				sound = "ALERT10",
				desc = 153616,
				throttle = 2,
			},	
			iFelSparkUnder = {
				varname = format(L.alert["%s %s, %s!"],SN[153726],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[153726],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[153726],
				sound = "ALERT10",
				desc = 153726,
				throttle = 2,
			},
			iSummonFelguard = {
				varname = format(L.alert["%s %s!"],SN[164081],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[164081],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[164081],
				desc = 164081,
				exdps = true,
				exhealer = true,
			},
			--[[iSummonFelguard = {
				varname = format(L.alert["%s Warning"],SN[164081]),
				text = SN[164081].."! "..L.alert["CAREFUL"].."!",
				type = "inform",
				time = 5,
				sound = "ALERT8",
				color1 = "BLACK",
				icon = ST[164081],
				throttle = 3,
			},	--]]		
			-- Casts
			ClawsOfArgusBuff = {
				varname = format(L.alert["%s Active"],SN[153764]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[153764]),
				time = 20,
				color1 = "NEWBLUE",
				icon = ST[153764],
				desc = 153764,
			},
			-- Debuff
			FelLashDebuff = {
				varname = format(L.alert["%s Debuff"],SN[153234]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[153234]),
				text2 = format(L.alert["#5#: %s"],SN[153234]),
				time = 7.5,
				color1 = "RED",
				icon = ST[153234],
				desc = 153234,
				tag = "#5#",
			},		
		},
		events = {
			-- CurtainOfFlame
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {153392},
				execute = {
					{
						"set",{lastplayer = "#5#"},
						"message","mCurtainOfFlame",
						"raidicon","CurtainOfFlamemark",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"StaticShockDebuff", text = 2},
						"arrow","CurtainOfFlamearrow",
						"openwindow",{"5","#5#"},
						"canceltimer",{"timerCurtainOfFlame"},
						"scheduletimer",{"timerCurtainOfFlame",1},
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","CurtainOfFlamesay",
						"openwindow",{"5"},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {153392},
				execute = {
					{
						"set",{flamesCast = "DECR|1"},
						"removeraidicon","#5#",
						"set",{lastplayer = ""},
						"closewindow",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {153396},
				execute = {
					{
						"set",{flamesCast = "INCR|1"},
					},
					{
						"expect",{"<flamesCast>","<","3"},
						"alert","CurtainOfFlameCD",
					},
				},
			},
			-- FelLash
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {153234},
				execute = {
					{
						"message","mFelLash",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"FelLashDebuff","iFelLashself"},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"FelLashDebuff", text = 2},
					},					
				},
			},		
			-- ClawsOfArgus
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {153764},
				execute = {
					{
						"batchalert",{"ClawsOfArgusBuff","wClawsOfArgus"},
					},
				},
			},	
			-- Claws of Argus ending
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {153764},
				execute = {
					{
						"alert",{"CurtainOfFlameCD", time = 3},
						"alert","ClawsOfArgusCD",
						"set",{flamesCast = "0"},
					},
				},
			},				
			-- Felblast
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {154221},
				execute = {
					{
						"batchalert",{"wFelblast","iFelblast"},
					},
				},
			},
			-- FelStomp
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {157173},
				execute = {
					{
						"batchalert",{"wFelStomp","iFelStomp"},
					},
				},
			},				
			-- FelPool
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {153616},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelPoolUnder",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {153616},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelPoolUnder",
					},
				},
			},	
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#5#","==","153500"}, -- FelPool
						"expect",{"#1#","==","boss1"},
						"alert","wFelPool",
					},
				},
			},					
			-- FelSpark
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {153726},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelSparkUnder",
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {153726},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelSparkUnder",
					},
				},
			},	
			-- SummonFelguard
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellid = {164081},
				execute = {
					{
						"alert","iSummonFelguard",
						"message","mSummonFelguard",
					},
				},
			},	
		},
	}

	DXE:RegisterEncounter(data)
end