local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 3,
		key = "Terongor",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["Auchindoun: Terongor"],
		triggers = {
			scan = {77734}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1", },
			unittracing = {	"boss1",},
			defeat = 77734,
		},
		userdata = {
			SeedOfcorruption = 0,
			SeedOfcorruptionunists = {type = "container", wipein = 3},
			SeedOfcorruptionunists2 = {type = "container"},
			DBMReset = 0,
			phase = 1,
		},	
		timers = {
			timerDBMSyncReset  = {
				{
					"set",{DBMReset = "0"},	
				},
			},	
			timerSeedOfcorruption  = {
				{
					"openwindow",{"5","&list|SeedOfcorruptionunists2&",true},
				},
			},				
		},				
		announces = { 
			DemonicLeapsay = {
				varname = format(L.alert["%s %s %s!"],SN[157039],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[157039],L.alert["on"],L.alert["Me"]),
				desc = 157039,
			},
			ChaosWavesay = {
				varname = format(L.alert["%s %s %s!"],SN[157001],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[157001],L.alert["on"],L.alert["Me"]),
				desc = 157001,
			},			
		},		
		messages = {
			mDemonicLeap = {
				varname = format(L.alert["%s %s %s"],SN[157039],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[157039],L.alert["on"]),
				text2 = format(L.alert["%s!"],SN[157039]),
				color1 = "PURPLE",
				sound = "ALERT13",
				desc = 157039,
				icon = ST[157039],
			},
			mChaosWave = {
				varname = format(L.alert["%s %s %s"],SN[157001],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[157001],L.alert["on"]),
				text2 = format(L.alert["%s!"],SN[157001]),
				color1 = "PURPLE",
				sound = "ALERT13",
				desc = 157001,
				icon = ST[157001],
			},
			mDrainLife = {
				varname = format(L.alert["%s %s %s"],SN[156854],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[156854],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 156854,
				icon = ST[156854],
			},	
			mDoom = {
				varname = format(L.alert["%s %s %s"],SN[156965],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[156965],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 156965,
				icon = ST[156965],
				extank = true,
				exdps = true,
			},	
			mCorruption = {
				varname = format(L.alert["%s %s %s"],SN[156842],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[156842],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 156842,
				icon = ST[156842],
				extank = true,
				exdps = true,				
			},
			mExhaustion = {
				varname = format(L.alert["%s %s %s"],SN[164841],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[164841],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 164841,
				icon = ST[164841],
			},
			mFixate = {
				varname = format(L.alert["%s %s %s"],SN[157168],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[157168],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 157168,
				icon = ST[157168],
			},	
			mSeedOfMalevolence = {
				varname = format(L.alert["%s %s %s"],SN[156921],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[156921],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 156921,
				icon = ST[156921],
			},
			mImmolate = {
				varname = format(L.alert["%s %s %s"],SN[156964],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[156964],L.alert["on"]),
				color1 = "GOLD",
				sound = "ALERT13",
				desc = 156964,
				icon = ST[156964],
			},				
			mRainOfFire = {
				varname = format(L.alert["%s!"],SN[156857]),
				type = "message",
				text = format(L.alert["%s!"],SN[156857]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 156857,
				icon = ST[156857],
			},			
		},
		onstart = {
			{
				"alert",{"RainOfFireCD", time = 2},
			},
		},
		alerts = {
			DrainLifeCD = {
				varname = format(L.alert["%s Cooldown"],SN[156854]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156854]),
				time = 15,
				color1 = "NEWBLUE",
				icon = ST[156854],
				desc = 156854,
			},
			RainOfFireCD = {
				varname = format(L.alert["%s Cooldown"],SN[156857]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156857]),
				time = 12,
				time2 = 15,
				color1 = "NEWBLUE",
				icon = ST[156857],
				desc = 156857,
			},			
			--Demonic Abilities
			ChaosWaveCD = {
				varname = format(L.alert["%s Cooldown"],SN[157001]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[157001]),
				time = 13,
				time2 = 10,
				color1 = "NEWBLUE",
				icon = ST[157001],
				desc = 157001,
			},
			DemonicLeapCD = {
				varname = format(L.alert["%s Cooldown"],SN[157039]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[157039]),
				time = 20,
				time2 = 23,
				color1 = "NEWBLUE",
				icon = ST[157039],
				desc = 157039,
			},	
			-- Destruction Abilities
			ChaosBoltCD = {
				varname = format(L.alert["%s Cooldown"],SN[156975]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156975]),
				time = 20.5,
				color1 = "NEWBLUE",
				icon = ST[156975],
				desc = 156975,
			},
			ImmolateCD = {
				varname = format(L.alert["%s Cooldown"],SN[156964]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156964]),
				time = 12,
				color1 = "NEWBLUE",
				icon = ST[156964],
				desc = 156964,
				extank = true,
				exdps = true,
			},		
			-- Affliction Abilities
			SeedOfMelevolenceCD = {
				varname = format(L.alert["%s Cooldown"],SN[156921]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156921]),
				time = 22,
				color1 = "NEWBLUE",
				icon = ST[156921],
				desc = 156921,
			},
			-- Alert
			--[[Phase2 = {
				varname = format(L.alert["Phase 2"]),
				type = "simple",
				text = format(L.alert["Phase 2"]),
				time = 2,
				color1 = "YELLOW",
				icon = EJST[156919],
				sound = "ALERT13",
			},	--]]		
			wChaosBolt = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[156975]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[156975]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[156975],
				sound = "ALERT10",
				desc = 156975,
			},
			wRainOfFire = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[156857]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[156857]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[156857],
				sound = "ALERT10",
				desc = 156857,
			},				
			-- Inform
			iSeedOfcorruptionself = {
				varname = format(L.alert["%s %s!"],SN[136646],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[136646],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT12",
				icon = ST[136646],
				flashscreen = true,
				desc = 136646,
			},	
			iFixateself = {
				varname = format(L.alert["%s %s %s!"],SN[157168],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[157168],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[157168],
				desc = 157168,
			},				
			iDemonicLeapself = {
				varname = format(L.alert["%s %s %s!"],SN[157039],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[157039],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[157039],
				desc = 157039,
			},	
			iChaosWaveself = {
				varname = format(L.alert["%s %s %s!"],SN[157001],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[157001],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[157001],
				desc = 157001,
			},		
			iChaosBolt = {
				varname = format(L.alert["%s - %s"],SN[156975],L.alert["INTERRUPT"]),
				type = "inform",
				text = format(L.alert["%s - %s &bossname|boss1&"],SN[156975],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[156975],
				exhealer = true,
				desc = 156975,
			},
			iDrainLife = {
				varname = format(L.alert["%s - %s"],SN[156854],L.alert["INTERRUPT"]),
				type = "inform",
				text = format(L.alert["%s - %s &bossname|boss1&"],SN[156854],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[156854],
				exhealer = true,
				desc = 156854,
			},	
			iCorruption = {
				varname = format(L.alert["%s %s %s!"],SN[156842],L.alert["Dispell"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s #5#"],L.alert["Dispell"]),
				time = 2,
				color1 = "GREEN",
				sound = "ALERT10",
				icon = ST[156842],
				desc = 156842,
			},				
			iExhaustion = {
				varname = format(L.alert["%s %s %s!"],SN[164841],L.alert["Dispell"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s #5#"],L.alert["Dispell"]),
				time = 2,
				color1 = "GREEN",
				sound = "ALERT10",
				icon = ST[164841],
				desc = 164841,
			},
			iImmolate = {
				varname = format(L.alert["%s %s %s!"],SN[156964],L.alert["Dispell"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s #5#"],L.alert["Dispell"]),
				time = 2,
				color1 = "GREEN",
				sound = "ALERT10",
				icon = ST[156964],
				desc = 156964,
			},
			iRainofFire = {
				varname = format(L.alert["%s %s, %s!"],SN[156856],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[156856],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[156856],
				sound = "ALERT10",
				flashscreen = true,
				desc = 156856,
			},				
			-- Casts
			FixateCast = {
				varname = format(L.alert["%s Active"],SN[157168]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[157168]),
				time = 12,
				color1 = "RED",
				icon = ST[157168],
				desc = 157168,
			},
			SeedOfcorruptionCast = {
				varname = format(L.alert["%s Active"],SN[156921]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[156921]),
				time = 15,
				color1 = "RED",
				icon = ST[156921],
				desc = 156921,
			},				
			-- Debuff
			FixateDebuff = {
				varname = format(L.alert["%s Debuff"],SN[157168]),
				type = "debuff",
				--text = format(L.alert["%s: %s"],L.alert["YOU"],SN[153234]),
				text = format(L.alert["#5#: %s"],SN[157168]),
				time = 12,
				color1 = "PURPLE",
				icon = ST[157168],
				desc = 157168,
				tag = "#5#",
			},	
			SeedOfcorruptionDebuff = {
				varname = format(L.alert["%s Debuff"],SN[156921]),
				type = "debuff",
				--text = format(L.alert["%s: %s"],L.alert["YOU"],SN[153234]),
				text = format(L.alert["#5#: %s"],SN[156921]),
				time = 15,
				color1 = "RED",
				icon = ST[156921],
				desc = 156921,
				tag = "#5#",
			},					
		},
		events = {
			-- DemonicLeap
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {157039},
				execute = {
					{
						"alert","DemonicLeapCD",
						"target",{
							--source = "#1#",
							npcid = 77734,
							wait = 0.1,
							schedule = 16,
							announce = "DemonicLeapsay",
							message = "mDemonicLeap",
							alerts = {
								self = "iDemonicLeapself",
								--other = 
								--unknown = "",
								unknownmsg = {"mDemonicLeap", text = 2},
							},
						},
					},
				},
			},
			-- ChaosWave
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {157001},
				execute = {
					{
						"alert","ChaosWaveCD",
						"target",{
							--source = "#1#",
							npcid = 77734,
							wait = 0.1,
							schedule = 16,
							announce = "ChaosWavesay",
							message = "mChaosWave",
							alerts = {
								self = "iChaosWaveself",
								--other = 
								--unknown = "",
								unknownmsg = {"mChaosWave", text = 2},
							},
						},
					},
				},
			},			
			-- ChaosBolt
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156975},
				execute = {
					{
						"batchalert",{"ChaosBoltCD","iChaosBolt","wChaosBolt"},
					},
				},
			},
			-- RainOfFire
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156857},
				execute = {
					{
						"alert","wRainOfFire",
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {156974},
				execute = {
					{
						"message","mRainOfFire",
						"alert","RainOfFireCD",
					},
				},
			},				
			-- DrainLife
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {156854},
				execute = {
					{
						"message","mDrainLife",
						"batchalert",{"DrainLifeCD","iDrainLife"},
					},
				},
			},	
			-- Doom
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156965},
				execute = {
					{
						"message","mDoom",
					},				
				},
			},	
			-- Corruption
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156842},
				execute = {
					{
						"message","mCorruption",
					},
					{
						"expect",{"&dispell|magic&","==","true"},
						"alert","iCorruption",
					},					
				},
			},	
			-- Exhaustion
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {164841},
				execute = {
					{
						"expect",{"&dispell|curse&","==","true"},
						"alert","iExhaustion",
						"message","mExhaustion",
					},						
				},
			},
			-- iRainofFire
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156856},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iRainofFire",
					},
				},
			},				
			-- Fixate
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {157168},
				execute = {
					{
						"message","mFixate",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"FixateCast","iFixateself"},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert","FixateDebuff",
					},	
				},
			},	
			-- SeedOfMalevolence
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156921},
				execute = {
					{
						"message","mSeedOfMalevolence",
						"set",{SeedOfcorruption = "INCR|1"},
						"insert",{"SeedOfcorruptionunists","#5#"},
						"insert",{"SeedOfcorruptionunists2","#5#",true},
						"canceltimer","timerSeedOfcorruption",
						--"scheduletimer",{"timerSeedOfcorruption",0.2},
						--"set",{SeedOfcorruptionunists2 = "&RaidDebuff|"..SN[156921].."&"},
						--"openwindow",{"5","<SeedOfcorruptionunists2>"},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"SeedOfcorruptionCast","iSeedOfcorruptionself"},
						"openwindow",{"10"},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert","SeedOfcorruptionDebuff",
						"scheduletimer",{"timerSeedOfcorruption",0.2},
						--"openwindow",{"5","#5#"},
					},					
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {156921},
				execute = {
					{
						"set",{SeedOfcorruption = "DECR|1"},
						"delete",{"SeedOfcorruptionunists2","#5#"},
					},
					{
						--"expect",{"#4#","==","&playerguid&"},
						"expect",{"<SeedOfcorruption>",">","0"},
						"canceltimer","timerSeedOfcorruption",
						"scheduletimer",{"timerSeedOfcorruption",1.2},						
						--"set",{SeedOfcorruptionunists2 = "&RaidDebuff|"..SN[156921].."&"},
						--"openwindow",{"5","<AuraOfPrideunists2>"},
					},
					{
						"expect",{"<SeedOfcorruption>","==","0"},
						"closewindow",
					},					
				},
			},	
			-- Immolate
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156964},
				execute = {
					{
						"expect",{"&dispell|magic&","==","true"},
						"alert","ImmolateCD",
						"alert","iImmolate",
						"message","mImmolate",
					},						
				},
			},
			
			---------------------------------
			
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","156919"}, -- Demonology Transformation
								"batchquash",{"RainOfFireCD","DrainLifeCD"},
								"alert",{"ChaosWaveCD", time = 2},
								"alert",{"DemonicLeapCD", time = 2},
								"set",{phase = 2},
							},
							{
								"expect",{"#5#","==","156863"}, -- Affliction Transformation
								"quash","RainOfFireCD",
								"set",{phase = 2},
							},
							{
								"expect",{"#5#","==","156863"}, -- Destruction Transformation
								"quash","DrainLifeCD",
								"set",{phase = 2},
							},	
							{
								"expect",{"#5#","==","114268"}, -- endcombat
								"endcombat",
							},							
						},
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end