local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 2,
		key = "Crushto",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["Bloodmaul: Crushto"],
		triggers = {
			scan = {74787}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1", 	},
			unittracing = {	"boss1",},
			defeat = 74787,
		},
		userdata = {

		},		
		messages = {
			mCrushingLeap = {
				varname = format(L.alert["%s %s %s"],SN[150751],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[150751],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 150751,
				icon = ST[150751],
			},
			mMoltenCore = {
				varname = format(L.alert["%s %s %s"],SN[150678],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[150678],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 150678,
				icon = ST[150678],
			},				
		},
		onstart = {

		},
		alerts = {
			WildSlamCD = {
				varname = format(L.alert["%s Cooldown"],SN[150753]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[150753]),
				time = 23,
				color1 = "NEWBLUE",
				icon = ST[150753],
				desc = 150753,
			},
			CrushingLeapCD = {
				varname = format(L.alert["%s Cooldown"],SN[150751]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[150751]),
				time = 23,
				color1 = "NEWBLUE",
				icon = ST[150751],
				desc = 150751,
			},			
			-- Warning
			wFerocious = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[150759]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[150759]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[150759],
				sound = "ALERT10",
				desc = 150759,
			},	
			wRaiseMiners = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[150801]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[150801]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[150801],
				sound = "ALERT10",
				desc = 150801,
				exhealer = true,
				exdps = true,
			},
			wEarthCrush = {
				varname = format(L.alert["%s %s"],SN[153679],L.alert["Incoming"]),
				type = "simple",
				text = format(L.alert["%s %s"],SN[153679],L.alert["Incoming"]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[153679],
				sound = "ALERT10",
				desc = 153679,
			},
			wWildSlam = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[150753]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[150753]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[150753],
				sound = "ALERT10",
				desc = 150753,
			},			
			-- Inform
			iFerocious = {
				varname = format(L.alert["%s - %s"],SN[150759],L.alert["INTERRUPT"]),
				type = "inform",
				text = format(L.alert["%s - %s &bossname|boss1&"],SN[150759],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[150759],
				exhealer = true,
				desc = 150759,
			},	
			iRaiseMiners = {
				varname = format(L.alert["%s %s"],SN[150801],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s"],SN[150801],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[150801],
				exhealer = true,
				exdps = true,
				desc = 150801,
			},				
		},
		events = {
			-- MoltenCore
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {150678},
				dstisplayerunit = false,
				execute = {
					{
						"message","mMoltenCore",
					},				
				},
			},			
			-- CrushingLeap
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {150751},
				execute = {
					{
						"message","mCrushingLeap",
						"alert","CrushingLeapCD",
					},				
				},
			},	
			-- Ferocious
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {150759},
				execute = {
					{
						"batchalert",{"iFerocious","wFerocious"},
					},
				},
			},
			-- RaiseMiners
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {150801},
				execute = {
					{
						"batchalert",{"iRaiseMiners","wRaiseMiners"},
					},
				},
			},	
			-- EarthCrush
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {153679},
				execute = {
					{
						"alert","wEarthCrush",
					},
				},
			},
			-- WildSlam
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {150753},
				execute = {
					{
						"batchalert",{"WildSlamCD","wWildSlam"},
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end