local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 2,
		key = "Magmolatus",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["Bloodmaul: Magmolatus"],
		triggers = {
			scan = {74366, 74475}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1", "boss2", 	},
			unittracing = {	"boss1","boss2"},
			defeat = 74475,
		},
		userdata = {
			Boss = {type = "container"},
			DancingFlamesunists = {type = "container", wipein = 3},
		},
		timers = {
			timerBoss = {
				--Ruination
				{
					"expect",{"&tabread|Boss|74570&","~=","true"},
					"expect",{"&bossexist|74570&","==","true"}, 
					"tabinsert",{"Boss","74570","true"},
					"alert","iRuination",
					--	"debug",{"Ruination"},
				},		
				--Calamity
				{
					"expect",{"&tabread|Boss|74571&","~=","true"},
					"expect",{"&bossexist|74571&","==","true"}, 
					"tabinsert",{"Boss","74571","true"},
					"alert","iCalamity",
					--	"debug",{"Calamity"},
				},
				--Magmolatus
				{
					"expect",{"&tabread|Boss|74475&","~=","true"},
					"expect",{"&bossexist|74475&","==","true"}, 
					"tabinsert",{"Boss","74475","true"},
					"batchalert",{"iMagmolatus","Phase2"},
				--	"debug",{"Magmolatus"},
				},		
			},
			timerDancingFlames = {
				{
					"message","mDancingFlames",
				},
			},			
		},
		messages = {
			mDancingFlames = {
				varname = format(L.alert["%s %s %s"],SN[149975],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|DancingFlamesunists&"],SN[149975],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 149975,
				icon = ST[149975],
			},			
			mWitheringFlames = {
				varname = format(L.alert["%s %s %s"],SN[150032],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[150032],L.alert["on"]),
				color1 = "PURPLE",
				sound = "ALERT13",
				desc = 150032,
				icon = ST[150032],
			},
		},
		onstart = {

		},
		alerts = {
			MoltenImpactCD = {
				varname = format(L.alert["%s Cooldown"],SN[150038]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[150038]),
				time = 21.5,
				color1 = "NEWBLUE",
				icon = ST[150038],
				desc = 150038,
			},
			-- Warning
			Phase2 = {
				varname = format(L.alert["Phase 2"]),
				type = "simple",
				text = format(L.alert["Phase 2"]),
				time = 2,
				color1 = "ORANGE",
				icon = EJST[8621],
				sound = "ALERT13",
			},	
			wFirestorm = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[149997]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[149997]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[149997],
				sound = "ALERT10",
				desc = 149997,
			},
			wMoltenImpactm = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[150038]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[150038]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[150038],
				sound = "ALERT10",
				desc = 150038,
			},				
			-- Inform
			iRuination = {
				varname = format(L.alert["%s %s"],SN["ej8622"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s"],SN["ej8622"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = EJST[8622],
				exhealer = true,
				ability = 8622,
			},
			iCalamity = {
				varname = format(L.alert["%s %s"],SN["ej8626"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s"],SN["ej8626"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = EJST[8626],
				exhealer = true,
				ability = 8626,
			},	
			iMagmolatus = {
				varname = format(L.alert["%s %s"],SN["ej8621"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s"],SN["ej8621"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = EJST[8621],
				exhealer = true,
				exdps = true,
				ability = 8621,
			},
			iFirestorm = {
				varname = format(L.alert["%s - %s"],SN[149997],L.alert["INTERRUPT"]),
				type = "inform",
				text = format(L.alert["%s - %s #1#"],SN[149997],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[149997],
				exhealer = true,
				desc = 149997,
			},
			iRoughSmash = {
				varname = format(L.alert["%s %s!"],SN[149941],L.alert["MOVE AWAY"]),
				type = "simple",
				text = format(L.alert["%s %s!"],SN[149941],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[149941],
				flashscreen = true,
				desc = 149941,
			},
			iSlagSmash = {
				varname = format(L.alert["%s %s!"],SN[150023],L.alert["MOVE AWAY"]),
				type = "simple",
				text = format(L.alert["%s %s!"],SN[150023],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[150023],
				flashscreen = true,
				desc = 150023,
			},	
			iMagmaBarrage = {
				varname = format(L.alert["%s %s, %s!"],SN[150011],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "simple",
				text = format(L.alert["%s %s, %s!"],SN[150011],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[150011],
				flashscreen = true,
				throttle = 2,
				desc = 150011,
			},			
		},
		events = {
			{
                type = "event",
                event = "INSTANCE_ENCOUNTER_ENGAGE_UNIT",
                execute = {
					{
						--"debug",{"engaged #1#"},
						"scheduletimer",{"timerBoss",1},
					},
				},
			},
			-- Firestorm
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {149997},
				execute = {
					{
						"batchalert",{"iFirestorm","wFirestorm"},
					},				
				},
			},
			-- DancingFlames
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {149975},
				execute = {
					{
						"insert",{"DancingFlamesunists","#5#"},
						"canceltimer","timerDancingFlames",
						"scheduletimer",{"timerDancingFlames",0.5},
					},				
				},
			},			
			-- WitheringFlames
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {150032},
				execute = {
					{
						"message","mWitheringFlames",
					},				
				},
			},			
			-- RoughSmash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {149941},
				execute = {
					{
						"expect",{"&ismelee&","==","true"},
						"alert","iRoughSmash",
					},
				},
			},	
			-- MoltenImpact
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {150038},
				execute = {
					{
						"batchalert",{"MoltenImpactCD","wMoltenImpactm"},
					},
				},
			},	
			-- SlagSmash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {150023},
				execute = {
					{
						"expect",{"&ismelee&","==","true"},
						"alert","iSlagSmash",
					},
				},
			},	
			-- MagmaBarrage
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {150011},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMagmaBarrage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {150011},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMagmaBarrage",
					},
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end