local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 2,
		key = "ThunderlordGeneral",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["GrimRailDepot: Skylord Tovra"],
		triggers = {
			scan = {80005}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1"	},
			unittracing = {	"boss1",},
			defeat = 80005,
		},
		userdata = {
			Mark = 0,
			Markunists = {type = "container", wipein = 3},
			Markunists2 = {type = "container"},
		},	
		timers = {	
			timerMark  = {
				{
					"openwindow",{"8","&list|Markunists2&",true},
				},
			},				
		},
		arrows = {
			FreezingSnarearrow = {
				varname = SN[162066],
				unit = "&upvalue&",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[162066],
				range1 = 6,
				range2 = 7,
				range3 = 8,
				desc = 162066,
				icon = ST[162066],
			},
		},		
		announces = { 
			FreezingSnaresay = {
				varname = format(L.alert["%s %s %s!"],SN[162066],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[162066],L.alert["on"],L.alert["Me"]),
				desc = 162066,
			},
			Marksay = {
				varname = format(L.alert["%s %s %s!"],SN[163447],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[163447],L.alert["on"],L.alert["Me"]),
				desc = 163447,
			},			
		},				
		messages = {
			mMark = {
				varname = format(L.alert["%s %s %s"],SN[163447],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Markunists&"],SN[163447],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 163447,
				icon = ST[163447],
			},
			mFreezingSnare = {
				varname = format(L.alert["%s %s %s"],SN[162066],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[162066],L.alert["on"]),
				text2 = format(L.alert["%s!"],SN[162066]),
				color1 = "PURPLE",
				sound = "ALERT13",
				desc = 162066,
				icon = ST[162066],
			},			
		},
		onstart = {

		},
		alerts = {
			FreezingSnareCD = {
				varname = format(L.alert["%s Cooldown"],SN[162066]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[162066]),
				time = 20,
				color1 = "NEWBLUE",
				icon = ST[162066],
				desc = 162066,
			},
			SpinningSpearCD = {
				varname = format(L.alert["%s Cooldown"],SN[162058]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[162058]),
				time = 20,
				color1 = "NEWBLUE",
				icon = ST[162058],
				desc = 162058,
			},	
			MarkCD = {
				varname = format(L.alert["%s Cooldown"],SN[163447]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163447]),
				time = 20,
				color1 = "NEWBLUE",
				icon = ST[163447],
				desc = 163447,
			},
			-- Warning
			wSpinningSpear = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[162058]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[162058]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[162058],
				sound = "ALERT10",
				desc = 162058,
			},			
			-- Inform
			iMarkself = {
				varname = format(L.alert["%s %s!"],SN[163447],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[163447],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[163447],
				flashscreen = true,
				desc = 163447,
			},
			iFreezingSnareself = {
				varname = format(L.alert["%s %s %s!"],SN[162066],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[162066],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[162066],
				desc = 162066,
			},
			iFreezingSnareNear = {
				varname = format(L.alert["%s %s %s!"],SN[162066],L.alert["near"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[162066],L.alert["near"],L.alert["YOU"]),
				time = 2,
				color1 = "VIOLET",
				sound = "ALERT10",
				icon = ST[162066],
				throttle = 2,
				desc = 162066,
			},	
			iDiffusedEnergy = {
				varname = format(L.alert["%s %s, %s!"],SN[161588],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "simple",
				text = format(L.alert["%s %s, %s!"],SN[161588],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[161588],
				flashscreen = true,
				throttle = 1,
				desc = 161588,
			},					
			-- Debuff
			MarkDebuff = {
				varname = format(L.alert["%s Debuff"],SN[157168]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[153234]),
				text2 = format(L.alert["#5#: %s"],SN[157168]),
				time = 5,
				color1 = "PURPLE",
				icon = ST[157168],
				desc = 157168,
				tag = "#5#",
			},				
		},
		events = {
			-- Mark
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {163447},
				execute = {
					{
						"alert","MarkCD",
						"message","mMark",
						"set",{Mark = "INCR|1"},
						"insert",{"Markunists","#5#"},
						"insert",{"Markunists2","#5#",true},
						"canceltimer","timerMark",
						"scheduletimer",{"timerMark",0.5},
						--"set",{Markunists2 = "&RaidDebuff|"..SN[163447].."&"},
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"MarkDebuff","iMarkself"},
						"announce","Marksay",
						"openwindow",{"8"},					
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"MarkDebuff", text = 2},
						--"openwindow",{"8","#5#"},
						"canceltimer",{"timerCurtainOfFlame"},
						"scheduletimer",{"timerCurtainOfFlame",1},
					},						
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {163447},
				execute = {
					{
						"set",{Mark = "DECR|1"},
						"delete",{"Markunists2","#5#"},
					},
					{
						--"expect",{"#4#","==","&playerguid&"},
						"expect",{"<Mark>",">","0"},
						"canceltimer","timerMark",
						"scheduletimer",{"timerMark",1},						
						--"set",{Markunists2 = "&RaidDebuff|"..SN[163447].."&"},
						--"openwindow",{"5","<Markunists2>"},
					},
					{
						"expect",{"<Mark>","==","0"},
						"closewindow",
					},					
				},
			},
			-- FreezingSnare
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {162066},
				execute = {
					{
						"alert","FreezingSnareCD",
						"target",{
							source = "#1#",
							wait = 0.04,
							schedule = 15,
							announce = "FreezingSnaresay",
							message = "mFreezingSnare",
							arrow = "FreezingSnarearrow",
							checknearby = 8,
							alerts = {
								self = "iFreezingSnareself",
								nearby = "iFreezingSnareNear",
								--other = 
								--unknown = "",
								unknownmsg = {"mFreezingSnare", text = 2},
							},
						},
					},
				},
			},
			-- SpinningSpear
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {162058},
				execute = {
					{
						"batchalert",{"SpinningSpearCD","wSpinningSpear"},
					},
				},
			},	
			-- DiffusedEnergy
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {161588},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iDiffusedEnergy",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {161588},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iDiffusedEnergy",
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end