local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 2,
		key = "GrimrailEnforcers",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["IronDocks: Grimrail Enforcers"],
		triggers = {
			scan = {80805, 80816, 80808}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1","boss2","boss3" 	},
			unittracing = {	"boss1","boss2","boss3"},
			defeat = {	80805, 80816, 80808, 	}
		},
		userdata = {

		},		
		messages = {
			mSanguineSphere = {
				varname = format(L.alert["%s %s %s"],SN[163689],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[163689],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 163689,
				icon = ST[163689],
			},
			mLavaSwipe = {
				varname = format(L.alert["%s!"],SN[163689]),
				type = "message",
				text = format(L.alert["%s!"],SN[163689]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 163689,
				icon = ST[163689],
				throttle = 5,
			},				
		},
		onstart = {
			{
				"alert",{"FlamingSlashCD", time = 2},
				"alert",{"OgreTrapsCD", time = 2},
				"alert",{"SanguineSphereCD", time = 2},
			},
		},
		alerts = {
			SanguineSphereCD = {
				varname = format(L.alert["%s Cooldown"],SN[163689]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163689]),
				time = 43.5,
				time2 = 47,
				color1 = "NEWBLUE",
				icon = ST[163689],
				desc = 163689,
			},
			FlamingSlashCD = {
				varname = format(L.alert["%s Cooldown"],SN[163665]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163665]),
				time = 29,
				time2 = 5,
				time3 = 41.5,
				audiocd = true,
				audiotime = 8,	
				color1 = "NEWBLUE",
				icon = ST[163665],
				desc = 163665,
			},
			OgreTrapsCD  = {
				varname = format(L.alert["%s Cooldown"],SN[163390]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163390]),
				time = 25,
				time2 = 19.5,
				color1 = "NEWBLUE",
				icon = ST[163390],
				desc = 163390,
			},
			LavaSwipeCD  = {
				varname = format(L.alert["%s Cooldown"],SN[165152]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[165152]),
				time = 29,
				time2 = 19.5,
				time3 = 41.5,
				color1 = "NEWBLUE",
				icon = ST[165152],
				desc = 165152,
				throttle = 5,
			},				
			-- Warning
			wBigBoom = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[163379]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[163379]),
				time = 2,
				color1 = "RED",
				icon = ST[163379],
				sound = "ALERT11",
				desc = 163379,
			},			
			wFlamingSlash = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[163665]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[163665]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[163665],
				sound = "ALERT10",
				desc = 163665,
			},
			wOgreTraps = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[163390]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[163390]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[163390],
				sound = "ALERT10",
				desc = 163390,
			},	
			-- Inform
			iOgreTraps = {
				varname = format(L.alert["%s!"],SN[163390]),
				type = "inform",
				text = format(L.alert["%s!"],SN[163390]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[163390],
				desc = 163390,
			},
			-- Debuff
			SanguineSphereDebuff = {
				varname = format(L.alert["%s Debuff"],SN[163689]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[163689]),
				text2 = format(L.alert["#5#: %s"],SN[163689]),
				time = 15,
				color1 = "PURPLE",
				icon = ST[163689],
				desc = 163689,
				tag = "#5#",
			},		
		},
		events = {
			-- SanguineSphere
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {163689},
				execute = {
					{
						"message","mSanguineSphere",
						"alert","SanguineSphereCD",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","SanguineSphereDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"SanguineSphereDebuff", text = 2},
					},						
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {163689},
				execute = {
					{
						"quash","SanguineSphereDebuff",
					},					
				},
			},
			-- FlamingSlash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {163665},
				execute = {
					{
						"alert","wFlamingSlash",
					},
					{
						"expect",{"&isheroic&","==","true"},
						"alert","FlamingSlashCD",
					},
					{
						"expect",{"&isheroic&","~=","true"},
						"alert",{"FlamingSlashCD", time = 3},
					},				
				},
			},			
			-- BigBoom
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {163379},
				execute = {
					{
						"alert","wBigBoom",
					},
				},
			},
			-- OgreTraps
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {163390},
				execute = {
					{
						"alert","wOgreTraps",
					},
					{
						"expect",{"&isranged&","==","true"},
						"alert","iOgreTraps",
					},
				},
			},	
			----
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","80805"}, -- Makogg Emberblade
						"quash","FlamingSlashCD",
						"quash","LavaSwipeCD",
					},
					{
						"expect",{"&npcid|#4#&","==","80808"}, -- Neesa Nox
						"quash","OgreTrapsCD",
					},	
					{
						"expect",{"&npcid|#4#&","==","80816"}, -- Ahri'ok Dugru
						"quash","SanguineSphereCD",
					},						
				},
			},
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","164956"}, -- LavaSwipe
								"invoke",{
									{
										"expect",{"&isheroic&","==","true"},
										"alert","LavaSwipeCD",
									},
									{
										"expect",{"&isheroic&","~=","true"},
										"alert",{"LavaSwipeCD", time = 3},
									},	
								},
							},								
						},
					},
					{
						"expect",{"#1#","==","boss2"},
						"invoke",{
							{
								"expect",{"#5#","==","164956"}, -- LavaSwipe
								"invoke",{
									{
										"expect",{"&isheroic&","==","true"},
										"alert","LavaSwipeCD",
									},
									{
										"expect",{"&isheroic&","~=","true"},
										"alert",{"LavaSwipeCD", time = 3},
									},	
								},
							},								
						},
					},
					{
						"expect",{"#1#","==","boss3"},
						"invoke",{
							{
								"expect",{"#5#","==","164956"}, -- LavaSwipe
								"invoke",{
									{
										"expect",{"&isheroic&","==","true"},
										"alert","LavaSwipeCD",
									},
									{
										"expect",{"&isheroic&","~=","true"},
										"alert",{"LavaSwipeCD", time = 3},
									},	
								},
							},								
						},
					},					
				},
			},	
		},
	}

	DXE:RegisterEncounter(data)
end