local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 2,
		key = "Skulloc",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["IronDocks: Skulloc"],
		triggers = {
			scan = {83612}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1", 	},
			unittracing = {	"boss1",},
			defeat = 83612,
		},
		userdata = {

		},	
		announces = { 
			RapidFiresay = {
				varname = format(L.alert["%s %s %s!"],SN[164426],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[164426],L.alert["on"],L.alert["Me"]),
				desc = 164426,
			},		
		},			
		messages = {
			mRapidFire = {
				varname = format(L.alert["%s %s %s"],SN[164426],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[164426],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 164426,
				icon = ST[164426],
			},
		},
		onstart = {
			{
				"alert",{"GronSmashCD", time = 2},
			},
		},
		alerts = {
			RapidFireCD = {
				varname = format(L.alert["%s Cooldown"],SN[168398]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[168398]),
				time = 12,
				color1 = "NEWBLUE",
				icon = ST[168398],
				desc = 168398,
			},	
			GronSmashCD = {
				varname = format(L.alert["%s Cooldown"],SN[168398]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[168398]),
				time = 67,
				time2 = 30,
				color1 = "NEWBLUE",
				icon = ST[168398],
				desc = 168398,
			},				
			-- Warning
			wCannonBarrage = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[168929]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[168929]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[168929],
				sound = "ALERT10",
				desc = 168929,
			},	
			wCannonBarrageEnds = {
				varname = format(L.alert["%s %s"],SN[168929],L.alert["Ended"]),
				type = "simple",
				text = format(L.alert["%s %s"],SN[168929],L.alert["Ended"]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[168929],
				sound = "ALERT10",
				desc = 168929,
			},			
			wGronSmash = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[168227]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[168227]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[168227],
				sound = "ALERT10",
				desc = 168227,
			},				
			-- Inform
			iRapidFire = {
				varname = format(L.alert["%s %s %s!"],SN[164426],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[164426],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[164426],
				desc = 164426,
			},	
			iBackdraft = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[169129]),
				type = "inform",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[169129]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[169129],
				sound = "ALERT10",
				desc = 169129,
			},	
			-- Casts
			BackdraftCast = {
				varname = format(L.alert["Boss %s %s!"],L.alert["casting"],SN[169129]),
				type = "centerpopup",
				text = format(L.alert["&bossname|boss1& %s %s!"],L.alert["casting"],SN[169129]),
				time = 3,
				flashtime = 3,
				color1 = "RED",
				icon = ST[169129],
				sound = "ALERT11",
				desc = 169129,
			},	
			-- Debuff
			RapidFireDebuff = {
				varname = format(L.alert["%s Debuff"],SN[164426]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[164426]),
				text2 = format(L.alert["#5#: %s"],SN[164426]),
				time = 5,
				color1 = "PURPLE",
				desc = 164426,
				icon = ST[164426],
				tag = "#5#",
				exdps = true,				
			},			
		},
		events = {
			-- RapidFire
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {164426},
				execute = {
					{
						"message","mRapidFire",
						"alert","RapidFireCD",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","RapidFiresay",
						"alert","iRapidFire",
						"alert","RapidFireDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert","iRapidFire",
						"alert",{"RapidFireDebuff", text = 2},
					},
				},
			},
			-- GronSmash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {168227},
				execute = {
					{
						"quash","RapidFireCD",
						"alert","wGronSmash",
					},
				},
			},
			-- CannonBarrage
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {168929},
				execute = {
					{
						"alert","wCannonBarrage",
					},
				},
			},
			-- Backdraft
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {169129},
				execute = {
					{
						"batchalert",{"BackdraftCast","iBackdraft"},
					},
				},
			},			
			----
			{
				type = "event",
				event = "UNIT_SPELLCAST_INTERRUPTED",
				execute = {
					{
						"expect",{"#5#","==","168929"}, -- CannonBarrage
						"expect",{"#1#","==","boss1"},
						"alert","wCannonBarrageEnds",
					},	
				},
			},
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","83613"}, -- Makogg Emberblade
						"quash","RapidFireCD",
						"quash","RapidFireDebuff",
					},
					
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end