local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

do
	local data = {
		version = 3,
		key = "Tarlna the Ageless",
		zone = L.zone["Draenor"],
		category = L.zone["Draenor"],
		name = L.npc_Draenor["Tarlna the Ageless"],
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Tarlna the Ancient.BLP:35:35",
		triggers = {
			scan = {81535}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {81535},
			--unittracing = {	"boss1",},
			defeat = {81535},
			delayrecombat = 20,
		},
		userdata = {
			SavageVinesunists = {type = "container", wipein = 3},
			SavageVinesunists2 = {type = "container", wipein = 3},
		},	
		timers = {
			timerSavageVines = {
				{
					"message","mSavageVines",
				},
			},
			timerSavageVinesDebuffs  = {
				{
					"openwindow",{"8","&list|SavageVinesunists2&",true},
				},
			},
			timerSavageVinesDebuffsOff  = {
				{
					"closewindow",
				},
			},			
		},
		arrows = {
			SavageVinesarrow = {
				varname = SN[176004],
				unit = "#5#",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[176004],
				range1 = 8,
				range2 = 10,
				range3 = 12,
				desc = 176004,
				icon = ST[176004],
			},
		},	
		announces = { 
			SavageVinessay = {
				varname = format(L.alert["%s %s %s!"],SN[176004],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[176004],L.alert["on"],L.alert["Me"]),
				desc = 176004,
				icon = ST[176004],
			},					
		},			
		messages = {
			mSavageVines = {
				varname = format(L.alert["%s %s %s"],SN[176004],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|SavageVinesunists&"],SN[176004],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 176004,
				icon = ST[176004],
			},	
			mGrowUntamedMandragora = {
				varname = format(L.alert["%s!"],SN[176013]),
				type = "message",
				text = format(L.alert["%s!"],SN[176013]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 176013,
				icon = ST[176013],
			},	
		},
		onstart = {
			{
			
			},
		},
		alerts = {
			GenesisCD = {
				varname = format(L.alert["%s Cooldown"],SN[169613]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[169613]),
				time = 45,
				color1 = "NEWBLUE",
				icon = ST[169613],
				desc = 169613,
			},
			GrowUntamedMandragoraCD = {
				varname = format(L.alert["%s Cooldown"],SN[176013]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[176013]),
				time = 30,
				color1 = "NEWBLUE",
				icon = ST[176013],
				desc = 176013,
			},	
			-- Warning
			wColossalBlow = {
				varname = format(L.alert["%s!"],SN[175973]),
				type = "simple",
				text = format(L.alert["%s!"],SN[175973]),
				time = 2,
				color1 = "ORANGE",
				sound = "ALERT10",
				icon = ST[175973],
				desc = 175973,
			},	
			wGenesis = {
				varname = format(L.alert["%s!"],SN[175979]),
				type = "simple",
				text = format(L.alert["%s!"],SN[175979]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[175979],
				desc = 175979,
			},
			-- Inform
			iNoxiousSpit = {
				varname = format(L.alert["%s %s, %s!"],SN[176037],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[176037],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[176037],
				sound = "ALERT12",
				desc = 176037,
				flashscreen = true,
				throttle = 1.5,
			},	
			iSolarRadiation = {
				varname = format(L.alert["%s!"],SN[176013]),
				type = "inform",
				text = format(L.alert["%s!"],SN[176013]),
				time = 2,
				color1 = "RED",
				icon = ST[176013],
				sound = "ALERT13",
				desc = 176013,
				exhealer = true,
			},	
			iSavageVines = {
				varname = format(L.alert["%s %s %s!"],SN[176004],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[176004],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[176004],
				sound = "ALERT10",
				desc = 176004,
				flashscreen = true,
			},
			-- Casts
			GenesisCast = {
				varname = format(L.alert["%s Active"],SN[175979]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[175979]),
				time = 14,
				color1 = "RED",
				icon = ST[175979],
				desc = 175979,
			},			
		},
		events = {
			-- ColossalBlow
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {175973},
				execute = {
					{
						"alert","wColossalBlow",
					},
				},
			},
			-- Genesis
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {175979, 169613},
				execute = {
					{
						"batchalert",{"GenesisCD","GenesisCast","wGenesis"},
					},
				},
			},	
			-- GrowUntamedMandragora
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {176013},
				execute = {
					{
						"batchalert",{"GrowUntamedMandragoraCD","iGrowUntamedMandragora"},
						"message","mGrowUntamedMandragora",
					},						
				},
			},	
			-- SavageVines
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {176001, 176004},
				execute = {
					{
						"insert",{"SavageVinesunists","#5#"},
						"insert",{"SavageVinesunists2","#5#",true},
						"canceltimer","timerSavageVines",
						"scheduletimer",{"timerSavageVines",0.5},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iSavageVines",
						"announce","SavageVinessay",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"expect",{"&inrange|#5#&","<","9"},
						"arrow","SavageVinesarrow",
					},
					{
						"expect",{"&playerdebuff|"..SN[156921].."&","==","true"},
						"openwindow",{"8"},
					},
					{
						"expect",{"&playerdebuff|"..SN[156921].."&","==","false"},
						--"set",{SavageVinesunists2 = "&RaidDebuff|"..SN[156921].."&"},
						--"set",{SavageVinesunists2 = "&list|SeedOfcorruptionunists&"},
						"canceltimer","timerSavageVinesDebuffs",
						"canceltimer","timerSavageVinesDebuffs2",
						"scheduletimer",{"timerSavageVinesDebuffs2",8},
						"scheduletimer",{"timerSavageVinesDebuffs",0.5},
					},
				},
			},	
			-- NoxiousSpit
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {176037},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iNoxiousSpit",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {176037},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iNoxiousSpit",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {176037},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iNoxiousSpit",
					},
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end